/*
 * Copyright (C) 2015 MediaTek Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   sp2518yuv_Sensor.h
 *
 * Project:
 * --------
 *   MAUI
 *
 * Description:
 * ------------
 *   Image sensor driver declare and macro define in the header file.
 *
 * Author:
 * -------
 *   Mormo
 *
 *=============================================================
 *             HISTORY
 * Below this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 * $Log$
 * 2011/11/03 Firsty Released By Mormo;
 *
 *
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *=============================================================
 ******************************************************************************/
 
#ifndef __NT99141YUV_SENSOR_H
#define __NT99141YUV_SENSOR_H


#define N720P_PERIOD_PIXEL_NUMS						(1280)
#define N720P_PERIOD_LINE_NUMS						(720)

#define SVGA_PERIOD_PIXEL_NUMS						(800)
#define SVGA_PERIOD_LINE_NUMS						(600)

#define IMAGE_SENSOR_SVGA_GRAB_PIXELS		0
#define IMAGE_SENSOR_SVGA_GRAB_LINES		1

#define IMAGE_SENSOR_UXGA_GRAB_PIXELS		0
#define IMAGE_SENSOR_UXGA_GRAB_LINES		1

#define IMAGE_SENSOR_VGA_WIDTH					(640)
#define IMAGE_SENSOR_VGA_HEIGHT				    (480)

#define IMAGE_SENSOR_SVGA_WIDTH					(800)
#define IMAGE_SENSOR_SVGA_HEIGHT				(600)

#define IMAGE_SENSOR_720P_WIDTH					(1280)
#define IMAGE_SENSOR_720P_HEIGHT				(720)

#define IMAGE_SENSOR_PV_WIDTH					(IMAGE_SENSOR_SVGA_WIDTH - 8)
#define IMAGE_SENSOR_PV_HEIGHT					(IMAGE_SENSOR_SVGA_HEIGHT - 6)

#define IMAGE_SENSOR_FULL_WIDTH					(IMAGE_SENSOR_720P_WIDTH - 16)
#define IMAGE_SENSOR_FULL_HEIGHT				(IMAGE_SENSOR_720P_HEIGHT - 12)

#define NT99141_WRITE_ID							0x54
#define NT99141_READ_ID							0x55



typedef enum
{
	Gamma_1_8 = 1,
	Gamma_2_0,
	Gamma_2_2,
	Gamma_dm_3,
	Gamma_dm_5,
	Gamma_dm_6,
	Gamma_dm_7,
	Gamma_dm_8,
	Gamma_dm_9
}NT99141_GAMMA_TAG;

UINT32 NT99141Open(void);
UINT32 NT99141Control(MSDK_SCENARIO_ID_ENUM ScenarioId, MSDK_SENSOR_EXPOSURE_WINDOW_STRUCT *pImageWindow, MSDK_SENSOR_CONFIG_STRUCT *pSensorConfigData);
UINT32 NT99141FeatureControl(MSDK_SENSOR_FEATURE_ENUM FeatureId, UINT8 *pFeaturePara,UINT32 *pFeatureParaLen);
UINT32 NT99141GetInfo(MSDK_SCENARIO_ID_ENUM ScenarioId, MSDK_SENSOR_INFO_STRUCT *pSensorInfo, MSDK_SENSOR_CONFIG_STRUCT *pSensorConfigData);
UINT32 NT99141GetResolution(MSDK_SENSOR_RESOLUTION_INFO_STRUCT *pSensorResolution);
UINT32 NT99141Close(void);

extern void kdSetI2CSpeed(u32 i2cSpeed);


#endif /* __SENSOR_H */

