ifneq ($(TARGET_SIMULATOR),true)

LOCAL_PATH:= $(call my-dir)

#############################################  dropbear  ##############################################
include $(CLEAR_VARS)
LOCAL_SRC_FILES = \
		  buffer.c bignum.c circbuffer.c dbhelpers.c dbrandom.c dbutil.c crypto_desc.c \
		   dss.c list.c listener.c netio.c packet.c \
		   process-packet.c queue.c rsa.c signkey.c sshpty.c tcp-accept.c termcodes.c
LOCAL_SRC_FILES += \
		   common-algo.c common-channel.c common-chansession.c common-kex.c common-runopts.c common-session.c dh_groups.c
LOCAL_SRC_FILES += \
		   svr-agentfwd.c svr-auth.c svr-authpasswd.c svr-authpubkey.c svr-authpubkeyoptions.c \
		   svr-chansession.c svr-kex.c svr-main.c svr-runopts.c svr-service.c \
		   svr-session.c svr-tcpfwd.c svr-x11fwd.c

LOCAL_STATIC_LIBRARIES := libtommath libtomcrypt libz
LOCAL_SHARED_LIBRARIES := libgsnvram
LOCAL_MODULE_PATH := $(TARGET_OUT_OPTIONAL_EXECUTABLES)
LOCAL_MODULE_TAGS := optional
LOCAL_MODULE := dropbear
LOCAL_C_INCLUDES += external/zlib 
LOCAL_C_INCLUDES += $(LOCAL_PATH)/libtommath 
LOCAL_C_INCLUDES += $(LOCAL_PATH)/libtomcrypt/src/headers
LOCAL_CFLAGS += -DDROPBEAR_SERVER -DGRANDSTREAM_CHANGES -Wno-int-conversion

include $(BUILD_EXECUTABLE)

########################################   dropbear_server.sh   ###########################################

include $(CLEAR_VARS)
LOCAL_MODULE := dropbear_server.sh
LOCAL_MODULE_TAGS := optional
LOCAL_MODULE_CLASS := ETC 
LOCAL_MODULE_PATH := $(TARGET_OUT_OPTIONAL_EXECUTABLES)
LOCAL_SRC_FILES := $(LOCAL_MODULE)
include $(BUILD_PREBUILT)

########################################   copy configure file  ############################################

etc_dir := $(TARGET_OUT)/etc/dropbear
key_dir := $(TARGET_OUT)/root/.ssh

#include $(CLEAR_VARS)
#LOCAL_MODULE := passwd
#LOCAL_MODULE_TAGS := eng
#LOCAL_MODULE_CLASS := ETC
#LOCAL_MODULE_PATH := $(etc_dir)
#LOCAL_SRC_FILES := $(LOCAL_MODULE)
#include $(BUILD_PREBUILT)

include $(CLEAR_VARS)
LOCAL_MODULE := dropbear_rsa_host_key
LOCAL_MODULE_TAGS := optional
LOCAL_MODULE_CLASS := ETC
LOCAL_MODULE_PATH := $(etc_dir)
LOCAL_SRC_FILES := $(LOCAL_MODULE)
include $(BUILD_PREBUILT)

include $(CLEAR_VARS)
LOCAL_MODULE := authorized_keys
LOCAL_MODULE_TAGS := optional
LOCAL_MODULE_CLASS := ETC
LOCAL_MODULE_PATH := $(key_dir)

LOCAL_SRC_FILES := authorized_keys

ifeq ($(TARGET_PRODUCT),full_bat)
LOCAL_SRC_FILES := gxv3370_authorized_keys
endif
ifeq ($(TARGET_PRODUCT),full_eagle)
LOCAL_SRC_FILES := gxv3350_authorized_keys
endif
ifeq ($(TARGET_DEVICE), ceilcast)
LOCAL_SRC_FILES := gsc3510_authorized_keys
endif

ifeq ($(oem_id), 70)
LOCAL_SRC_FILES := NEC_authorized_keys
endif

include $(BUILD_PREBUILT)


#include $(CLEAR_VARS)
#copy_from := 
#copy_to := $(TARGET_OUT)/root/.ssh/authorized_keys
#copy_from := $(LOCAL_PATH)/,$(copy_from)
#$(copy_to) : PRIVATE_MODULE := system_etcdir
#$(copy_to) : $(TARGET_OUT)/% : $(LOCAL_PATH)/% | $(ACP)
#$(transform-prebuilt-to-target)

#ALL_PREBUILT += $(copy_to)


###########################################################################################################

#include $(CLEAR_VARS)

#LOCAL_SRC_FILES:=\
#	scp.c progressmeter.c atomicio.c scpmisc.c

#LOCAL_STATIC_LIBRARIES := libtommath libtomcrypt

#LOCAL_MODULE_PATH := $(TARGET_OUT_OPTIONAL_EXECUTABLES)

#LOCAL_MODULE_TAGS := debug

#LOCAL_MODULE := scp
#LOCAL_C_INCLUDES += $(LOCAL_PATH)/libtommath 
#LOCAL_C_INCLUDES += $(LOCAL_PATH)/libtomcrypt/src/headers
#LOCAL_CFLAGS += -DDROPBEAR_CLIENT -DPROGRESS_METER

#include $(BUILD_EXECUTABLE)

endif  # TARGET_SIMULATOR != true


include $(call all-makefiles-under,$(LOCAL_PATH))
