#!/bin/bash
export ARCH=arm
export ANDROID_ROOT=${PWD}/../../../../
export OPTPATH=${ANDROID_ROOT}/prebuilts/gcc/linux-x86/arm/arm-linux-androideabi-4.9/bin/
export COMPILER=arm-linux-androideabi-gcc
export CC=${OPTPATH}/arm-linux-androideabi-gcc
export CXX=${OPTPATH}/arm-linux-androideabi-g++
export LD=${OPTPATH}/arm-linux-androideabi-ld
export SYSROOT=${ANDROID_ROOT}/prebuilts/ndk/current/platforms/android-23/arch-arm/
#export SYSROOT=${ANDROID_ROOT}/prebuilts/gcc/linux-x86/host/x86_64-linux-glibc2.15-4.8/sysroot/
export PATH=$OPTPATH:$PATH
export CROSS_COMPILE=1
export ARCH=arm

export CFLAGS="-pie -fPIE --sysroot=${SYSROOT} \
    -DHAVE_PCRE_H=1 -DBUILD_ON_ARM -DHAVE_LIBPCRE=1 \
    -I${ANDROID_ROOT}/vendor/grandstream/external/openssl/include \
    -I${ANDROID_ROOT}/external/libxml2/include \
    -I${ANDROID_ROOT}/external/dbus \
    -I${ANDROID_ROOT}/external/zlib \
    -I${ANDROID_ROOT}/external/icu/icu4c/source/common/ \
    -I${ANDROID_ROOT}/external/bzip2 \
    -I${ANDROID_ROOT}/external/stlport/stlport \
    -I${ANDROID_ROOT}/bionic/libc/arch-arm/include \
    -I${ANDROID_ROOT}/bionic/libc/include \
    -I${ANDROID_ROOT}/bionic/libstdc++/include \
    -I${ANDROID_ROOT}/bionic/libc/kernel/common \
    -I${ANDROID_ROOT}/bionic/libc/kernel/arch-arm \
    -I${ANDROID_ROOT}/bionic/libm/include \
    -I${ANDROID_ROOT}/frameworks/base/include"

export LDFLAGS="-pie -fPIE -nostdlib --sysroot=${SYSROOT} \
    -Bdynamic -Wl,-dynamic-linker,/system/bin/linker \
    -Wl,-rpath-link=${ANDROID_ROOT}/out/target/product/bat/obj_arm/lib \
    -L${ANDROID_ROOT}/out/target/product/bat/system/lib/ \
"


#export LIBS=" -lc -ldl -lm -lnvram -ldbus -llog -licuuc"
export LIBS=" -lc -lstdc++"


./configure --host=arm-linux-androideabi  && make clean && make
