#!/system/bin/sh

set_pc_port_vlan() {
	local vlan_tag=`nvram get 229`
	local vlan_pri=`nvram get 230`

	if [ $vlan_tag -gt 0 -a $vlan_tag -lt 4095 ];then
		swconfig dev switch0 set pc_port_tag $vlan_tag
		swconfig dev switch0 set pc_port_pri $vlan_pri
	else
		echo "Invalid VLAN Tag"
	fi
}

pc_port_mode=`nvram get 1348`

case "$pc_port_mode" in
	0)
		echo "Enable PC Port"
		swconfig dev switch0 set pc_port_mirror 0
		swconfig dev switch0 port 2 set disable 1
		set_pc_port_vlan
		swconfig dev switch0 port 2 set disable 0
		;;
	1)
		echo "Disable PC Port"
		swconfig dev switch0 port 2 set disable 1
		;;
	2)
		echo "PC Port Mirrored"
		swconfig dev switch0 set pc_port_mirror 1
		;;
esac
