/*
 * Copyright (C) 2016 MediaTek Inc.

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 */

#include <linux/kernel.h>
#include <linux/module.h>

#include <mach/upmu_sw.h>
#include <mach/upmu_hw.h>
#include <mt-plat/upmu_common.h>

void mt6335_upmu_set_rg_thr_det_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_THR_DET_DIS_MASK),
				    (unsigned int)(PMIC_RG_THR_DET_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_thr_test(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_THR_TEST_MASK),
				    (unsigned int)(PMIC_RG_THR_TEST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_ther_deb_rmax(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_THER_DEB_RMAX_MASK),
				    (unsigned int)(PMIC_RG_STRUP_THER_DEB_RMAX_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_ther_deb_fmax(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_THER_DEB_FMAX_MASK),
				    (unsigned int)(PMIC_RG_STRUP_THER_DEB_FMAX_SHIFT)
	    );

}

void mt6335_upmu_set_dduvlo_deb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DDUVLO_DEB_EN_MASK),
				    (unsigned int)(PMIC_DDUVLO_DEB_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_osc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_OSC_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_OSC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_osc_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_OSC_EN_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_OSC_EN_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_ft_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_FT_CTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_FT_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_pwron_force(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_FORCE_MASK),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_FORCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_biasgen_force(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIASGEN_FORCE_MASK),
				    (unsigned int)(PMIC_RG_BIASGEN_FORCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_pwron(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_MASK),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_pwron_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_biasgen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIASGEN_MASK),
				    (unsigned int)(PMIC_RG_BIASGEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_biasgen_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIASGEN_SEL_MASK),
				    (unsigned int)(PMIC_RG_BIASGEN_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_xosc32_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_MASK),
				    (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_xosc32_enb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_SEL_MASK),
				    (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_strup_dig_io_pg_force(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_DIG_IO_PG_FORCE_MASK),
				    (unsigned int)(PMIC_STRUP_DIG_IO_PG_FORCE_SHIFT)
	    );

}

void mt6335_upmu_set_clr_just_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLR_JUST_RST_MASK),
				    (unsigned int)(PMIC_CLR_JUST_RST_SHIFT)
	    );

}

void mt6335_upmu_set_uvlo_l2h_deb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_UVLO_L2H_DEB_EN_MASK),
				    (unsigned int)(PMIC_UVLO_L2H_DEB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_just_pwrkey_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_STRUP_CON4),
				  (&val),
				  (unsigned int)(PMIC_JUST_PWRKEY_RST_MASK),
				  (unsigned int)(PMIC_JUST_PWRKEY_RST_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_osc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_STRUP_CON4),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_OSC_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_OSC_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_strup_ext_pmic_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_ext_pmic_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_strup_con8_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_CON8_RSV0_MASK),
				    (unsigned int)(PMIC_STRUP_CON8_RSV0_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_ext_pmic_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_STRUP_CON5),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_EXT_PMIC_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_EXT_PMIC_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_strup_auxadc_start_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SW_MASK),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_auxadc_rstb_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SW_MASK),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_auxadc_start_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_auxadc_rstb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_auxadc_rpcnt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RPCNT_MAX_MASK),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RPCNT_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_strup_pwroff_seq_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_PWROFF_SEQ_EN_MASK),
				    (unsigned int)(PMIC_STRUP_PWROFF_SEQ_EN_SHIFT)
	    );

}

void mt6335_upmu_set_strup_pwroff_preoff_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_PWROFF_PREOFF_EN_MASK),
				    (unsigned int)(PMIC_STRUP_PWROFF_PREOFF_EN_SHIFT)
	    );

}

void mt6335_upmu_set_strup_dig0_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_DIG0_RSV0_MASK),
				    (unsigned int)(PMIC_STRUP_DIG0_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_strup_dig1_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_DIG1_RSV0_MASK),
				    (unsigned int)(PMIC_STRUP_DIG1_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rsv_swreg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RSV_SWREG_MASK),
				    (unsigned int)(PMIC_RG_RSV_SWREG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_uvlo_u1u2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_uvlo_u1u2_sel_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_SWCTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_SWCTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_thr_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_THR_CLR_MASK),
				    (unsigned int)(PMIC_RG_STRUP_THR_CLR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_long_press_ext_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_long_press_ext_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_TD_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_long_press_ext_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_long_press_ext_chr_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_STRUP_LONG_PRESS_EXT_CHR_CTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_CHR_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_long_press_ext_pwrkey_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_STRUP_LONG_PRESS_EXT_PWRKEY_CTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_PWRKEY_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_long_press_ext_spar_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_STRUP_LONG_PRESS_EXT_SPAR_CTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_SPAR_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_long_press_ext_rtca_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_STRUP_LONG_PRESS_EXT_RTCA_CTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_RTCA_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_envtem(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_ENVTEM_MASK),
				    (unsigned int)(PMIC_RG_STRUP_ENVTEM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_envtem_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_ENVTEM_CTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_ENVTEM_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_pwrkey_count_reset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_PWRKEY_COUNT_RESET_MASK),
				    (unsigned int)(PMIC_RG_STRUP_PWRKEY_COUNT_RESET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vsram_dvfs2_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_DVFS2_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_DVFS2_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vsram_dvfs1_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_DVFS1_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_DVFS1_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vsram_core_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_CORE_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_CORE_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vsram_gpu_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_GPU_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_GPU_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vsram_md_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_MD_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_MD_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vufs18_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VUFS18_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VUFS18_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vemc_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VEMC_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VEMC_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_va12_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VA12_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VA12_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_va10_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VA10_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VA10_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_va18_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VA18_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VA18_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vdram_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vmodem_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VMODEM_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VMODEM_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vmd1_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VMD1_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VMD1_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vs2_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VS2_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VS2_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vs1_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VS1_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VS1_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vcore_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_ext_pmic_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vusb33_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_H2L_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vsram_dvfs2_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_DVFS2_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_DVFS2_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vsram_dvfs1_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_DVFS1_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_DVFS1_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vsram_core_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_CORE_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_CORE_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vsram_gpu_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_GPU_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_GPU_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vsram_md_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_MD_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_MD_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vufs18_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VUFS18_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VUFS18_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vemc_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VEMC_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VEMC_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_va12_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VA12_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VA12_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_va10_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VA10_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VA10_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_va18_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VA18_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VA18_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vdram_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vmodem_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VMODEM_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VMODEM_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vmd1_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VMD1_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VMD1_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vs2_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VS2_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VS2_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vs1_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VS1_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VS1_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vcore_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vxo22_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VXO22_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VXO22_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vio28_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VIO28_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VIO28_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vio18_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VIO18_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VIO18_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_ext_pmic_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vusb33_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vdram_oc_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VDRAM_OC_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VDRAM_OC_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vmodem_oc_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VMODEM_OC_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VMODEM_OC_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vmd1_oc_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VMD1_OC_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VMD1_OC_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vs2_oc_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VS2_OC_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VS2_OC_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vs1_oc_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VS1_OC_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VS1_OC_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_vcore_oc_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_OC_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_OC_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_long_press_reset_extend(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON19),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_STRUP_LONG_PRESS_RESET_EXTEND_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_RESET_EXTEND_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ext_pmic_pg_debtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON20),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EXT_PMIC_PG_DEBTD_MASK),
				    (unsigned int)(PMIC_RG_EXT_PMIC_PG_DEBTD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_spar_deb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON20),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_SPAR_DEB_EN_MASK),
				    (unsigned int)(PMIC_RG_RTC_SPAR_DEB_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_alarm_deb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_CON20),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_ALARM_DEB_EN_MASK),
				    (unsigned int)(PMIC_RG_RTC_ALARM_DEB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_ana_chip_id(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_STRUP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RGS_ANA_CHIP_ID_MASK),
				  (unsigned int)(PMIC_RGS_ANA_CHIP_ID_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_pp_en_drvsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PP_EN_DRVSEL_MASK),
				    (unsigned int)(PMIC_RG_PP_EN_DRVSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fchr_pu_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FCHR_PU_EN_MASK),
				    (unsigned int)(PMIC_RG_FCHR_PU_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pmu_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PMU_RSV_MASK),
				    (unsigned int)(PMIC_RG_PMU_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fchr_keydet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FCHR_KEYDET_EN_MASK),
				    (unsigned int)(PMIC_RG_FCHR_KEYDET_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_en_drvsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EN_DRVSEL_MASK),
				    (unsigned int)(PMIC_RG_EN_DRVSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rst_drvsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RST_DRVSEL_MASK),
				    (unsigned int)(PMIC_RG_RST_DRVSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_iref_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_IREF_TRIM_MASK),
				    (unsigned int)(PMIC_RG_STRUP_IREF_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vref_bg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VREF_BG_MASK),
				    (unsigned int)(PMIC_RG_VREF_BG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_thr_tmode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_THR_TMODE_MASK),
				    (unsigned int)(PMIC_RG_THR_TMODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_thr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_THR_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_THR_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_thrdet_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_STRUP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_THRDET_SEL_MASK),
				    (unsigned int)(PMIC_RG_THRDET_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pwrhold(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PWRHOLD_MASK),
				    (unsigned int)(PMIC_RG_PWRHOLD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_crst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CRST_MASK),
				    (unsigned int)(PMIC_RG_CRST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_wrst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WRST_MASK),
				    (unsigned int)(PMIC_RG_WRST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rstb_onintv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RSTB_ONINTV_MASK),
				    (unsigned int)(PMIC_RG_RSTB_ONINTV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_crst_intv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CRST_INTV_MASK),
				    (unsigned int)(PMIC_RG_CRST_INTV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_wrst_intv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WRST_INTV_MASK),
				    (unsigned int)(PMIC_RG_WRST_INTV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_ivgen_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_IVGEN_SEL_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_IVGEN_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_fsm_rst_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_FSM_RST_SEL_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_FSM_RST_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_pg_ck_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_PG_CK_SEL_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_PG_CK_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_1ms_tk_ext(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_1MS_TK_EXT_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_1MS_TK_EXT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_spar_xcpt_mask(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_SPAR_XCPT_MASK_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_SPAR_XCPT_MASK_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_rtca_xcpt_mask(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCTL2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_RTCA_XCPT_MASK_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_RTCA_XCPT_MASK_SHIFT)
	    );

}

void mt6335_upmu_set_rg_wdtrst_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WDTRST_EN_MASK),
				    (unsigned int)(PMIC_RG_WDTRST_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_wdtrst_act(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WDTRST_ACT_MASK),
				    (unsigned int)(PMIC_RG_WDTRST_ACT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pspg_shdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSPG_SHDN_EN_MASK),
				    (unsigned int)(PMIC_RG_PSPG_SHDN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_thm_shdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCCFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_THM_SHDN_EN_MASK),
				    (unsigned int)(PMIC_RG_THM_SHDN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_force_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCTST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_FORCE_ON_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_FORCE_ON_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_force_all_doff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCTST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_FORCE_ALL_DOFF_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_FORCE_ALL_DOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_f75k_force(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCTST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_F75K_FORCE_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_F75K_FORCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCRSV0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_RSV0_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCRSV0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_RSV1_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pseq_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PPCRSV0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PSEQ_RSV2_MASK),
				    (unsigned int)(PMIC_RG_PSEQ_RSV2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bwdt_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BWDTCTL0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BWDT_EN_MASK),
				    (unsigned int)(PMIC_RG_BWDT_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bwdt_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BWDTCTL0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BWDT_TD_MASK),
				    (unsigned int)(PMIC_RG_BWDT_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bwdt_chrtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BWDTCTL0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BWDT_CHRTD_MASK),
				    (unsigned int)(PMIC_RG_BWDT_CHRTD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bwdt_ddlo_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BWDTCTL0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BWDT_DDLO_TD_MASK),
				    (unsigned int)(PMIC_RG_BWDT_DDLO_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bwdt_srcsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BWDTCTL0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BWDT_SRCSEL_MASK),
				    (unsigned int)(PMIC_RG_BWDT_SRCSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_cps_w_key(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSWKEY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CPS_W_KEY_MASK),
				    (unsigned int)(PMIC_RG_CPS_W_KEY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_slot_intv_up(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSCFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SLOT_INTV_UP_MASK),
				    (unsigned int)(PMIC_RG_SLOT_INTV_UP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_seq_len(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSCFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SEQ_LEN_MASK),
				    (unsigned int)(PMIC_RG_SEQ_LEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_slot_intv_down(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSCFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SLOT_INTV_DOWN_MASK),
				    (unsigned int)(PMIC_RG_SLOT_INTV_DOWN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_dseq_len(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSCFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DSEQ_LEN_MASK),
				    (unsigned int)(PMIC_RG_DSEQ_LEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_USA_MASK),
				    (unsigned int)(PMIC_RG_VCORE_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_USA_MASK),
				    (unsigned int)(PMIC_RG_VS1_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_USA_MASK),
				    (unsigned int)(PMIC_RG_VS2_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_USA_MASK),
				    (unsigned int)(PMIC_RG_VMD1_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_USA_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_USA_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_USA_MASK),
				    (unsigned int)(PMIC_RG_VA10_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_USA_MASK),
				    (unsigned int)(PMIC_RG_VA12_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_USA_MASK),
				    (unsigned int)(PMIC_RG_VEMC_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_USA_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_md_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_MD_USA_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_MD_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_gpu_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_GPU_USA_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_GPU_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_core_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_CORE_USA_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_CORE_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_USA_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_USA_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_USA_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_extpmic_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EXTPMIC_USA_MASK),
				    (unsigned int)(PMIC_RG_EXTPMIC_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_USA_MASK),
				    (unsigned int)(PMIC_RG_VIO18_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_USA_MASK),
				    (unsigned int)(PMIC_RG_VIO28_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_USA_MASK),
				    (unsigned int)(PMIC_RG_VXO22_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrsv0_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRSV0_USA_MASK),
				    (unsigned int)(PMIC_RG_VRSV0_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrsv1_usa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSPSA10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRSV1_USA_MASK),
				    (unsigned int)(PMIC_RG_VRSV1_USA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_DSA_MASK),
				    (unsigned int)(PMIC_RG_VCORE_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_DSA_MASK),
				    (unsigned int)(PMIC_RG_VS1_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_DSA_MASK),
				    (unsigned int)(PMIC_RG_VS2_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_DSA_MASK),
				    (unsigned int)(PMIC_RG_VMD1_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_DSA_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_DSA_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_DSA_MASK),
				    (unsigned int)(PMIC_RG_VA10_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_DSA_MASK),
				    (unsigned int)(PMIC_RG_VA12_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_DSA_MASK),
				    (unsigned int)(PMIC_RG_VEMC_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_DSA_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_md_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_MD_DSA_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_MD_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_gpu_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_GPU_DSA_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_GPU_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_core_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_CORE_DSA_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_CORE_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_DSA_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_DSA_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_DSA_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_extpmic_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EXTPMIC_DSA_MASK),
				    (unsigned int)(PMIC_RG_EXTPMIC_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_DSA_MASK),
				    (unsigned int)(PMIC_RG_VIO18_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_DSA_MASK),
				    (unsigned int)(PMIC_RG_VIO28_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_DSA_MASK),
				    (unsigned int)(PMIC_RG_VXO22_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrsv0_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRSV0_DSA_MASK),
				    (unsigned int)(PMIC_RG_VRSV0_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrsv1_dsa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CPSDSA10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRSV1_DSA_MASK),
				    (unsigned int)(PMIC_RG_VRSV1_DSA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_por_flag(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PORFLAG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_POR_FLAG_MASK),
				    (unsigned int)(PMIC_RG_POR_FLAG_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_sts_pwrkey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PONSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_PWRKEY_MASK),
				  (unsigned int)(PMIC_STS_PWRKEY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_rtca(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PONSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_RTCA_MASK),
				  (unsigned int)(PMIC_STS_RTCA_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_chrin(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PONSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_CHRIN_MASK),
				  (unsigned int)(PMIC_STS_CHRIN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_spar(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PONSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_SPAR_MASK),
				  (unsigned int)(PMIC_STS_SPAR_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_rboot(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PONSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_RBOOT_MASK),
				  (unsigned int)(PMIC_STS_RBOOT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_uvlo(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_UVLO_MASK),
				  (unsigned int)(PMIC_STS_UVLO_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_pgfail(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_PGFAIL_MASK),
				  (unsigned int)(PMIC_STS_PGFAIL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_psoc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_PSOC_MASK),
				  (unsigned int)(PMIC_STS_PSOC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_thrdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_THRDN_MASK),
				  (unsigned int)(PMIC_STS_THRDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_wrst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_WRST_MASK),
				  (unsigned int)(PMIC_STS_WRST_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_crst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_CRST_MASK),
				  (unsigned int)(PMIC_STS_CRST_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_pkeylp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_PKEYLP_MASK),
				  (unsigned int)(PMIC_STS_PKEYLP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_normoff(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_NORMOFF_MASK),
				  (unsigned int)(PMIC_STS_NORMOFF_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_bwdt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_BWDT_MASK),
				  (unsigned int)(PMIC_STS_BWDT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_ddlo(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_DDLO_MASK),
				  (unsigned int)(PMIC_STS_DDLO_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_wdt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_WDT_MASK),
				  (unsigned int)(PMIC_STS_WDT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_sts_pupsrc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_POFFSTS),
				  (&val),
				  (unsigned int)(PMIC_STS_PUPSRC_MASK),
				  (unsigned int)(PMIC_STS_PUPSRC_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_poffsts_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PSTSCTL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_POFFSTS_CLR_MASK),
				    (unsigned int)(PMIC_RG_POFFSTS_CLR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ponsts_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_PSTSCTL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PONSTS_CLR_MASK),
				    (unsigned int)(PMIC_RG_PONSTS_CLR_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_hwcid(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_HWCID),
				  (&val),
				  (unsigned int)(PMIC_HWCID_MASK), (unsigned int)(PMIC_HWCID_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_swcid(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_SWCID),
				  (&val),
				  (unsigned int)(PMIC_SWCID_MASK), (unsigned int)(PMIC_SWCID_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_srclken_in0_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN0_EN_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN0_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_srclken_in1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN1_EN_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN1_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_osc_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_SEL_MASK),
				    (unsigned int)(PMIC_RG_OSC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_srclken_in0_hw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN0_HW_MODE_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN0_HW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_srclken_in1_hw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN1_HW_MODE_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN1_HW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_osc_sel_hw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_SEL_HW_MODE_MASK),
				    (unsigned int)(PMIC_RG_OSC_SEL_HW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_srclken_in_sync_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN_SYNC_EN_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN_SYNC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_osc_en_auto_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_EN_AUTO_OFF_MASK),
				    (unsigned int)(PMIC_RG_OSC_EN_AUTO_OFF_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_test_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_TEST_OUT),
				  (&val),
				  (unsigned int)(PMIC_TEST_OUT_MASK),
				  (unsigned int)(PMIC_TEST_OUT_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_mon_flag_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TEST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_MON_FLAG_SEL_MASK),
				    (unsigned int)(PMIC_RG_MON_FLAG_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_mon_grp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TEST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_MON_GRP_SEL_MASK),
				    (unsigned int)(PMIC_RG_MON_GRP_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_nandtree_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TEST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_NANDTREE_MODE_MASK),
				    (unsigned int)(PMIC_RG_NANDTREE_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_test_auxadc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TEST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TEST_AUXADC_MASK),
				    (unsigned int)(PMIC_RG_TEST_AUXADC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_efuse_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TEST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EFUSE_MODE_MASK),
				    (unsigned int)(PMIC_RG_EFUSE_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_test_strup(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TEST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TEST_STRUP_MASK),
				    (unsigned int)(PMIC_RG_TEST_STRUP_SHIFT)
	    );

}

void mt6335_upmu_set_testmode_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TESTMODE_SW),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TESTMODE_SW_MASK),
				    (unsigned int)(PMIC_TESTMODE_SW_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_vsram_dvfs2_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_DVFS2_PG_DEB_MASK),
				  (unsigned int)(PMIC_VSRAM_DVFS2_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vsram_dvfs1_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_DVFS1_PG_DEB_MASK),
				  (unsigned int)(PMIC_VSRAM_DVFS1_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vsram_core_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_CORE_PG_DEB_MASK),
				  (unsigned int)(PMIC_VSRAM_CORE_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vsram_gpu_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_GPU_PG_DEB_MASK),
				  (unsigned int)(PMIC_VSRAM_GPU_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vsram_md_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_MD_PG_DEB_MASK),
				  (unsigned int)(PMIC_VSRAM_MD_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vufs18_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VUFS18_PG_DEB_MASK),
				  (unsigned int)(PMIC_VUFS18_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vemc_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VEMC_PG_DEB_MASK),
				  (unsigned int)(PMIC_VEMC_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_va12_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VA12_PG_DEB_MASK),
				  (unsigned int)(PMIC_VA12_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_va10_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VA10_PG_DEB_MASK),
				  (unsigned int)(PMIC_VA10_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_va18_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VA18_PG_DEB_MASK),
				  (unsigned int)(PMIC_VA18_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vdram_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VDRAM_PG_DEB_MASK),
				  (unsigned int)(PMIC_VDRAM_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vmodem_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VMODEM_PG_DEB_MASK),
				  (unsigned int)(PMIC_VMODEM_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vmd1_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VMD1_PG_DEB_MASK),
				  (unsigned int)(PMIC_VMD1_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vs2_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VS2_PG_DEB_MASK),
				  (unsigned int)(PMIC_VS2_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vs1_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VS1_PG_DEB_MASK),
				  (unsigned int)(PMIC_VS1_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vcore_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VCORE_PG_DEB_MASK),
				  (unsigned int)(PMIC_VCORE_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vxo22_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATU1),
				  (&val),
				  (unsigned int)(PMIC_VXO22_PG_DEB_MASK),
				  (unsigned int)(PMIC_VXO22_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vio28_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATU1),
				  (&val),
				  (unsigned int)(PMIC_VIO28_PG_DEB_MASK),
				  (unsigned int)(PMIC_VIO28_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vio18_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATU1),
				  (&val),
				  (unsigned int)(PMIC_VIO18_PG_DEB_MASK),
				  (unsigned int)(PMIC_VIO18_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ext_pmic_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATU1),
				  (&val),
				  (unsigned int)(PMIC_EXT_PMIC_PG_DEB_MASK),
				  (unsigned int)(PMIC_EXT_PMIC_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vusb33_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGDEBSTATU1),
				  (&val),
				  (unsigned int)(PMIC_VUSB33_PG_DEB_MASK),
				  (unsigned int)(PMIC_VUSB33_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vsram_dvfs2_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VSRAM_DVFS2_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VSRAM_DVFS2_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vsram_dvfs1_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VSRAM_DVFS1_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VSRAM_DVFS1_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vsram_core_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VSRAM_CORE_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VSRAM_CORE_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vsram_gpu_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VSRAM_GPU_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VSRAM_GPU_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vsram_md_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VSRAM_MD_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VSRAM_MD_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vufs18_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VUFS18_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VUFS18_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vemc_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VEMC_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VEMC_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_va12_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VA12_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VA12_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_va10_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VA10_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VA10_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_va18_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VA18_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VA18_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vdram_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VDRAM_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VDRAM_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vmodem_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VMODEM_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VMODEM_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vmd1_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VMD1_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VMD1_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vs2_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VS2_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VS2_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vs1_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VS1_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VS1_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vcore_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VCORE_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VCORE_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vxo22_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VXO22_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VXO22_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vio28_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VIO28_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VIO28_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vio18_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VIO18_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VIO18_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_ext_pmic_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_STRUP_EXT_PMIC_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_EXT_PMIC_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vusb33_pg_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PGSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VUSB33_PG_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VUSB33_PG_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vdram_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PSOCSTATUS),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VDRAM_OC_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VDRAM_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vmodem_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PSOCSTATUS),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VMODEM_OC_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VMODEM_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vmd1_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PSOCSTATUS),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VMD1_OC_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VMD1_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vs2_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PSOCSTATUS),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VS2_OC_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VS2_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vs1_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PSOCSTATUS),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VS1_OC_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VS1_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_vcore_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_PSOCSTATUS),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VCORE_OC_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_VCORE_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_pmu_thermal_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_THERMALSTATUS),
				  (&val),
				  (unsigned int)(PMIC_PMU_THERMAL_DEB_MASK),
				  (unsigned int)(PMIC_PMU_THERMAL_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_strup_thermal_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_THERMALSTATUS),
				  (&val),
				  (unsigned int)(PMIC_STRUP_THERMAL_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_THERMAL_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_pmu_test_mode_scan(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_TOPSTATUS),
				  (&val),
				  (unsigned int)(PMIC_PMU_TEST_MODE_SCAN_MASK),
				  (unsigned int)(PMIC_PMU_TEST_MODE_SCAN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_pwrkey_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_TOPSTATUS),
				  (&val),
				  (unsigned int)(PMIC_PWRKEY_DEB_MASK),
				  (unsigned int)(PMIC_PWRKEY_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_homekey_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_TOPSTATUS),
				  (&val),
				  (unsigned int)(PMIC_HOMEKEY_DEB_MASK),
				  (unsigned int)(PMIC_HOMEKEY_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rtc_xtal_det_done(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_TOPSTATUS),
				  (&val),
				  (unsigned int)(PMIC_RTC_XTAL_DET_DONE_MASK),
				  (unsigned int)(PMIC_RTC_XTAL_DET_DONE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_xosc32_enb_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_TOPSTATUS),
				  (&val),
				  (unsigned int)(PMIC_XOSC32_ENB_DET_MASK),
				  (unsigned int)(PMIC_XOSC32_ENB_DET_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rtc_xtal_det_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOPSTATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RTC_XTAL_DET_RSV_MASK),
				    (unsigned int)(PMIC_RTC_XTAL_DET_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pmu_tdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PMU_TDSEL_MASK),
				    (unsigned int)(PMIC_RG_PMU_TDSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_spi_tdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_TDSEL_MASK),
				    (unsigned int)(PMIC_RG_SPI_TDSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_aud_tdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUD_TDSEL_MASK),
				    (unsigned int)(PMIC_RG_AUD_TDSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_e32cal_tdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_E32CAL_TDSEL_MASK),
				    (unsigned int)(PMIC_RG_E32CAL_TDSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pmu_rdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PMU_RDSEL_MASK),
				    (unsigned int)(PMIC_RG_PMU_RDSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_spi_rdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_RDSEL_MASK),
				    (unsigned int)(PMIC_RG_SPI_RDSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_aud_rdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUD_RDSEL_MASK),
				    (unsigned int)(PMIC_RG_AUD_RDSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_e32cal_rdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_E32CAL_RDSEL_MASK),
				    (unsigned int)(PMIC_RG_E32CAL_RDSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smt_wdtrstb_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_WDTRSTB_IN_MASK),
				    (unsigned int)(PMIC_RG_SMT_WDTRSTB_IN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smt_homekey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_HOMEKEY_MASK),
				    (unsigned int)(PMIC_RG_SMT_HOMEKEY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smt_srclken_in0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN0_MASK),
				    (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smt_srclken_in1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN1_MASK),
				    (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smt_rtc_32k1v8_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_0_MASK),
				    (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smt_rtc_32k1v8_1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_1_MASK),
				    (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smt_scp_vreq_vao(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SCP_VREQ_VAO_MASK),
				    (unsigned int)(PMIC_RG_SMT_SCP_VREQ_VAO_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smt_spi_clk(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SPI_CLK_MASK),
				    (unsigned int)(PMIC_RG_SMT_SPI_CLK_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smt_spi_csn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SPI_CSN_MASK),
				    (unsigned int)(PMIC_RG_SMT_SPI_CSN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smt_spi_mosi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SPI_MOSI_MASK),
				    (unsigned int)(PMIC_RG_SMT_SPI_MOSI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smt_spi_miso(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SPI_MISO_MASK),
				    (unsigned int)(PMIC_RG_SMT_SPI_MISO_SHIFT)
	    );

}

void mt6335_upmu_set_rg_octl_srclken_in0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DRV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN0_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_octl_srclken_in1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DRV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN1_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_octl_rtc_32k1v8_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DRV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_0_MASK),
				    (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_octl_rtc_32k1v8_1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DRV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_1_MASK),
				    (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_octl_spi_clk(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DRV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SPI_CLK_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SPI_CLK_SHIFT)
	    );

}

void mt6335_upmu_set_rg_octl_spi_csn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DRV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SPI_CSN_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SPI_CSN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_octl_spi_mosi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DRV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SPI_MOSI_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SPI_MOSI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_octl_spi_miso(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DRV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SPI_MISO_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SPI_MISO_SHIFT)
	    );

}

void mt6335_upmu_set_rg_octl_homekey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DRV_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_HOMEKEY_MASK),
				    (unsigned int)(PMIC_RG_OCTL_HOMEKEY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_octl_scp_vreq_vao(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DRV_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SCP_VREQ_VAO_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SCP_VREQ_VAO_SHIFT)
	    );

}

void mt6335_upmu_set_rg_spi_clk_filter_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FILTER_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_CLK_FILTER_EN_MASK),
				    (unsigned int)(PMIC_RG_SPI_CLK_FILTER_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_spi_csn_filter_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FILTER_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_CSN_FILTER_EN_MASK),
				    (unsigned int)(PMIC_RG_SPI_CSN_FILTER_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_spi_mosi_filter_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FILTER_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_MOSI_FILTER_EN_MASK),
				    (unsigned int)(PMIC_RG_SPI_MOSI_FILTER_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_spi_miso_filter_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FILTER_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_MISO_FILTER_EN_MASK),
				    (unsigned int)(PMIC_RG_SPI_MISO_FILTER_EN_SHIFT)
	    );

}

void mt6335_upmu_set_top_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_STATUS_MASK),
				    (unsigned int)(PMIC_TOP_STATUS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_srclken_in2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_SPI_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN2_EN_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN2_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_srclken_in3_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_SPI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN3_EN_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN3_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_g_smps_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_g_smps_test_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_G_SMPS_TEST_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_G_SMPS_TEST_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_intrp_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INTRP_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_INTRP_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_intrp_pre_oc_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INTRP_PRE_OC_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_INTRP_PRE_OC_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_g_bif_1m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_G_BIF_1M_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_G_BIF_1M_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bif_x1_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIF_X1_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_BIF_X1_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bif_x4_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIF_X4_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_BIF_X4_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bif_x72_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIF_X72_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_BIF_X72_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_auxadc_1m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_1M_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_1M_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_auxadc_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_auxadc_rng_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_RNG_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_RNG_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_drv_32k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DRV_32K_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_DRV_32K_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_drv_isink3_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DRV_ISINK3_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_DRV_ISINK3_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_drv_isink2_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DRV_ISINK2_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_DRV_ISINK2_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_drv_isink1_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DRV_ISINK1_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_DRV_ISINK1_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_drv_isink0_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DRV_ISINK0_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_DRV_ISINK0_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_9m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_9M_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_9M_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_1m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_1M_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_1M_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_18m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_18M_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_18M_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_32k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_32K_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_32K_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_9m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_9M_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_LDO_9M_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_1m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_1M_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_LDO_1M_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_cali_75k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_CALI_75K_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_LDO_CALI_75K_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_ana_clk_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_ANA_CLK_PDN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_ANA_CLK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_trim_75k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TRIM_75K_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_TRIM_75K_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_chdet_75k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHDET_75K_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_CHDET_75K_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_spi_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_SPI_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_reg_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_REG_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_REG_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bgr_test_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_TEST_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_BGR_TEST_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fqmtr_32k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FQMTR_32K_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_FQMTR_32K_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fqmtr_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FQMTR_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_FQMTR_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_ana_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_ANA_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_ANA_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_eosc_cali_test_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EOSC_CALI_TEST_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_EOSC_CALI_TEST_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_eosc32_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_EOSC32_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_RTC_EOSC32_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtcdet_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTCDET_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_RTCDET_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_75k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_75K_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_RTC_75K_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_mclk_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_MCLK_PDN_MASK),
				    (unsigned int)(PMIC_RG_RTC_MCLK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_32k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_32K_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_RTC_32K_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_26m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_26M_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_RTC_26M_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fgadc_ft_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGADC_FT_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_FGADC_FT_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fgadc_dig_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGADC_DIG_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_FGADC_DIG_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fgadc_ana_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGADC_ANA_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_FGADC_ANA_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_32k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_32K_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_32K_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_75k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_75K_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_75K_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc32k_1v8_0_o_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC32K_1V8_0_O_PDN_MASK),
				    (unsigned int)(PMIC_RG_RTC32K_1V8_0_O_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc32k_1v8_1_o_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC32K_1V8_1_O_PDN_MASK),
				    (unsigned int)(PMIC_RG_RTC32K_1V8_1_O_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_2sec_off_det_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_2SEC_OFF_DET_PDN_MASK),
				    (unsigned int)(PMIC_RG_RTC_2SEC_OFF_DET_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smps_ck_div_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMPS_CK_DIV_PDN_MASK),
				    (unsigned int)(PMIC_RG_SMPS_CK_DIV_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_75k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_75K_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_BATON_75K_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_efuse_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EFUSE_CK_PDN_MASK),
				    (unsigned int)(PMIC_RG_EFUSE_CK_PDN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_top_ckpdn_con3_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TOP_CKPDN_CON3_RSV_MASK),
				    (unsigned int)(PMIC_RG_TOP_CKPDN_CON3_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fqmtr_ck_cksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FQMTR_CK_CKSEL_MASK),
				    (unsigned int)(PMIC_RG_FQMTR_CK_CKSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_75k_32k_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_75K_32K_SEL_MASK),
				    (unsigned int)(PMIC_RG_75K_32K_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fgadc_ana_ck_cksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGADC_ANA_CK_CKSEL_MASK),
				    (unsigned int)(PMIC_RG_FGADC_ANA_CK_CKSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bgr_test_ck_cksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_TEST_CK_CKSEL_MASK),
				    (unsigned int)(PMIC_RG_BGR_TEST_CK_CKSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_top_cksel_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TOP_CKSEL_CON0_RSV_MASK),
				    (unsigned int)(PMIC_RG_TOP_CKSEL_CON0_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_srcvolten_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCVOLTEN_SW_MASK),
				    (unsigned int)(PMIC_RG_SRCVOLTEN_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_osc_sel_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_OSC_SEL_SW_MASK),
				    (unsigned int)(PMIC_RG_BUCK_OSC_SEL_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vowen_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VOWEN_SW_MASK),
				    (unsigned int)(PMIC_RG_VOWEN_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_srcvolten_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCVOLTEN_MODE_MASK),
				    (unsigned int)(PMIC_RG_SRCVOLTEN_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_osc_sel_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_OSC_SEL_MODE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_OSC_SEL_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vowen_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VOWEN_MODE_MASK),
				    (unsigned int)(PMIC_RG_VOWEN_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_top_cksel_con2_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKSEL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TOP_CKSEL_CON2_RSV_MASK),
				    (unsigned int)(PMIC_RG_TOP_CKSEL_CON2_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_auxadc_ck_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_CK_DIVSEL_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_CK_DIVSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_9m_ck_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_9M_CK_DIVSEL_MASK),
				    (unsigned int)(PMIC_RG_LDO_9M_CK_DIVSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_9m_ck_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_9M_CK_DIVSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_9M_CK_DIVSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bif_x4_ck_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIF_X4_CK_DIVSEL_MASK),
				    (unsigned int)(PMIC_RG_BIF_X4_CK_DIVSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_reg_ck_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_REG_CK_DIVSEL_MASK),
				    (unsigned int)(PMIC_RG_REG_CK_DIVSEL_SHIFT)
	    );

}

void mt6335_upmu_set_top_ckdivsel_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_CKDIVSEL_CON0_RSV_MASK),
				    (unsigned int)(PMIC_TOP_CKDIVSEL_CON0_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_g_smps_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smps_pd_1m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMPS_PD_1M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_SMPS_PD_1M_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_auxadc_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_auxadc_rng_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_RNG_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_RNG_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bif_x4_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIF_X4_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_BIF_X4_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bif_x72_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIF_X72_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_BIF_X72_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_26m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_26M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_RTC_26M_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_reg_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_REG_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_REG_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_efuse_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EFUSE_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_EFUSE_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_top_ckhwen_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_CKHWEN_CON0_RSV_MASK),
				    (unsigned int)(PMIC_TOP_CKHWEN_CON0_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_9m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_9M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_9M_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_1m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_1M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_1M_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_18m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_18M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_18M_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_1m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_1M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_LDO_1M_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_9m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_9M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_LDO_9M_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_1m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_1M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_1M_CK_PDN_HWEN_SHIFT)
	    );

}

void mt6335_upmu_set_top_ckhwen_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKHWEN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_CKHWEN_RSV_MASK),
				    (unsigned int)(PMIC_TOP_CKHWEN_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_freq_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_BUCK_ANACK_FREQ_SEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_FREQ_SEL_MASK),
				    (unsigned int)(PMIC_RG_VCORE_FREQ_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_freq_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_BUCK_ANACK_FREQ_SEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_FREQ_SEL_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_FREQ_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_freq_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_BUCK_ANACK_FREQ_SEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_FREQ_SEL_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_FREQ_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_freq_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_BUCK_ANACK_FREQ_SEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_FREQ_SEL_MASK),
				    (unsigned int)(PMIC_RG_VMD1_FREQ_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_top_buck_anack_freq_sel_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_BUCK_ANACK_FREQ_SEL_CON0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_TOP_BUCK_ANACK_FREQ_SEL_CON0_RSV_MASK),
				    (unsigned int)(PMIC_TOP_BUCK_ANACK_FREQ_SEL_CON0_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pmu75k_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PMU75K_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_RG_PMU75K_CK_TST_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smps_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMPS_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_RG_SMPS_CK_TST_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc32k_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC32K_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_RG_RTC32K_CK_TST_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fg_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FG_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_RG_FG_CK_TST_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc26m_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC26M_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_RG_RTC26M_CK_TST_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_top_cktst_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_CKTST_CON0_RSV_MASK),
				    (unsigned int)(PMIC_TOP_CKTST_CON0_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_ana_auto_off_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_ANA_AUTO_OFF_DIS_MASK),
				    (unsigned int)(PMIC_RG_BUCK_ANA_AUTO_OFF_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_auxadc_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fqmtr_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FQMTR_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_FQMTR_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtcdet_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTCDET_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_RTCDET_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_eosc32_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_EOSC32_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_RTC_EOSC32_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_eosc_cali_test_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EOSC_CALI_TEST_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_EOSC_CALI_TEST_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc26m_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC26M_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_RTC26M_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc32k_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC32K_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_RTC32K_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fg_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FG_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_FG_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fgadc_ana_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGADC_ANA_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_FGADC_ANA_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bgr_test_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_TEST_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_BGR_TEST_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pmu75k_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PMU75K_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_PMU75K_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smps_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMPS_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_RG_SMPS_CK_TSTSEL_SHIFT)
	    );

}

void mt6335_upmu_set_top_cktst_con1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CKTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_CKTST_CON1_RSV_MASK),
				    (unsigned int)(PMIC_TOP_CKTST_CON1_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clksq_en_aud(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUD_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clksq_en_fqr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_FQR_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_FQR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clksq_en_aux_ap(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clksq_en_aux_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clksq_en_aux_gps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_GPS_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_GPS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clksq_en_aux_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_RSV_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clksq_en_aux_ap_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_MODE_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clksq_en_aux_md_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_MODE_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clksq_in_sel_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clksq_in_sel_va18_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_SWCTRL_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_SWCTRL_SHIFT)
	    );

}

void mt6335_upmu_set_top_clksq_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_CLKSQ_RSV_MASK),
				    (unsigned int)(PMIC_TOP_CLKSQ_RSV_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_clksq_en_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_DA_CLKSQ_EN_VA18_MASK),
				  (unsigned int)(PMIC_DA_CLKSQ_EN_VA18_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_clksq_rtc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clksq_rtc_en_hw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_HW_MODE_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_HW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_top_clksq_rtc_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV0_MASK),
				    (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_enbb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ENBB_SEL_MASK),
				    (unsigned int)(PMIC_RG_ENBB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xosc_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XOSC_EN_SEL_MASK),
				    (unsigned int)(PMIC_RG_XOSC_EN_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_top_clksq_rtc_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV1_MASK),
				    (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV1_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_clksq_en_vdig18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_TOP_CLKSQ_RTC),
				  (&val),
				  (unsigned int)(PMIC_DA_CLKSQ_EN_VDIG18_MASK),
				  (unsigned int)(PMIC_DA_CLKSQ_EN_VDIG18_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_osc_75k_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_TRIM),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_75K_TRIM_MASK),
				    (unsigned int)(PMIC_RG_OSC_75K_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_osc_75k_trim_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_TRIM),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_75K_TRIM_EN_MASK),
				    (unsigned int)(PMIC_RG_OSC_75K_TRIM_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_osc_75k_trim_rate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_TRIM),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_75K_TRIM_RATE_MASK),
				    (unsigned int)(PMIC_RG_OSC_75K_TRIM_RATE_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_osc_75k_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_TOP_CLK_TRIM),
				  (&val),
				  (unsigned int)(PMIC_DA_OSC_75K_TRIM_MASK),
				  (unsigned int)(PMIC_DA_OSC_75K_TRIM_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_g_smps_ck_pdn_srclken0_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_SRCLKEN0_EN_MASK),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_SRCLKEN0_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_g_smps_ck_pdn_srclken1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_SRCLKEN1_EN_MASK),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_SRCLKEN1_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_g_smps_ck_pdn_srclken2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_SRCLKEN2_EN_MASK),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_SRCLKEN2_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_g_smps_ck_pdn_buck_osc_sel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_G_SMPS_CK_PDN_BUCK_OSC_SEL_EN_MASK),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_BUCK_OSC_SEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_g_smps_ck_pdn_vowen_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_VOWEN_EN_MASK),
				    (unsigned int)(PMIC_RG_G_SMPS_CK_PDN_VOWEN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_osc_sel_srclken0_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_SEL_SRCLKEN0_EN_MASK),
				    (unsigned int)(PMIC_RG_OSC_SEL_SRCLKEN0_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_osc_sel_srclken1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_SEL_SRCLKEN1_EN_MASK),
				    (unsigned int)(PMIC_RG_OSC_SEL_SRCLKEN1_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_osc_sel_srclken2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_SEL_SRCLKEN2_EN_MASK),
				    (unsigned int)(PMIC_RG_OSC_SEL_SRCLKEN2_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_osc_sel_buck_ldo_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_SEL_BUCK_LDO_EN_MASK),
				    (unsigned int)(PMIC_RG_OSC_SEL_BUCK_LDO_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_osc_sel_vowen_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_SEL_VOWEN_EN_MASK),
				    (unsigned int)(PMIC_RG_OSC_SEL_VOWEN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_osc_sel_spi_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_SEL_SPI_EN_MASK),
				    (unsigned int)(PMIC_RG_OSC_SEL_SPI_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clk_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLK_RSV_MASK),
				    (unsigned int)(PMIC_RG_CLK_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clkctl_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKCTL_RSV0_MASK),
				    (unsigned int)(PMIC_RG_CLKCTL_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_dcxo_pwrkey_rstb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_CLK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DCXO_PWRKEY_RSTB_SEL_MASK),
				    (unsigned int)(PMIC_RG_DCXO_PWRKEY_RSTB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_efuse_man_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EFUSE_MAN_RST_MASK),
				    (unsigned int)(PMIC_RG_EFUSE_MAN_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_auxadc_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_RST_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_auxadc_reg_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_REG_RST_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_REG_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_audio_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDIO_RST_MASK),
				    (unsigned int)(PMIC_RG_AUDIO_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_accdet_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ACCDET_RST_MASK),
				    (unsigned int)(PMIC_RG_ACCDET_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bif_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIF_RST_MASK),
				    (unsigned int)(PMIC_RG_BIF_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_driver_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DRIVER_RST_MASK),
				    (unsigned int)(PMIC_RG_DRIVER_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fgadc_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGADC_RST_MASK),
				    (unsigned int)(PMIC_RG_FGADC_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fqmtr_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FQMTR_RST_MASK),
				    (unsigned int)(PMIC_RG_FQMTR_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rtc_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_RST_MASK),
				    (unsigned int)(PMIC_RG_RTC_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_type_c_cc_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TYPE_C_CC_RST_MASK),
				    (unsigned int)(PMIC_RG_TYPE_C_CC_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_chrwdt_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRWDT_RST_MASK),
				    (unsigned int)(PMIC_RG_CHRWDT_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_zcd_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ZCD_RST_MASK),
				    (unsigned int)(PMIC_RG_ZCD_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_audncp_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDNCP_RST_MASK),
				    (unsigned int)(PMIC_RG_AUDNCP_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_clk_trim_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLK_TRIM_RST_MASK),
				    (unsigned int)(PMIC_RG_CLK_TRIM_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_srclken_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_SRCLKEN_RST_MASK),
				    (unsigned int)(PMIC_RG_BUCK_SRCLKEN_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_strup_long_press_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_RST_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_prot_pmpp_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_PROT_PMPP_RST_MASK),
				    (unsigned int)(PMIC_RG_BUCK_PROT_PMPP_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_spk_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_RST_MASK),
				    (unsigned int)(PMIC_RG_SPK_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_chrdet_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRDET_RST_MASK),
				    (unsigned int)(PMIC_RG_CHRDET_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_ldo_ft_testmode_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_LDO_FT_TESTMODE_RST_MASK),
				    (unsigned int)(PMIC_RG_BUCK_LDO_FT_TESTMODE_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_RST_MASK),
				    (unsigned int)(PMIC_RG_BATON_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fgadc_rst_src_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGADC_RST_SRC_SEL_MASK),
				    (unsigned int)(PMIC_RG_FGADC_RST_SRC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_cali_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_CALI_RST_MASK),
				    (unsigned int)(PMIC_RG_LDO_CALI_RST_SHIFT)
	    );

}

void mt6335_upmu_set_top_rst_con1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_CON1_RSV_MASK),
				    (unsigned int)(PMIC_TOP_RST_CON1_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_chr_ldo_det_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHR_LDO_DET_MODE_MASK),
				    (unsigned int)(PMIC_RG_CHR_LDO_DET_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_chr_ldo_det_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHR_LDO_DET_SW_MASK),
				    (unsigned int)(PMIC_RG_CHR_LDO_DET_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_chrwdt_flag_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRWDT_FLAG_MODE_MASK),
				    (unsigned int)(PMIC_RG_CHRWDT_FLAG_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_chrwdt_flag_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRWDT_FLAG_SW_MASK),
				    (unsigned int)(PMIC_RG_CHRWDT_FLAG_SW_SHIFT)
	    );

}

void mt6335_upmu_set_top_rst_con2_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_CON2_RSV_MASK),
				    (unsigned int)(PMIC_TOP_RST_CON2_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_wdtrstb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WDTRSTB_EN_MASK),
				    (unsigned int)(PMIC_RG_WDTRSTB_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_wdtrstb_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WDTRSTB_MODE_MASK),
				    (unsigned int)(PMIC_RG_WDTRSTB_MODE_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_wdtrstb_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_WDTRSTB_STATUS_MASK),
				  (unsigned int)(PMIC_WDTRSTB_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_wdtrstb_status_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_WDTRSTB_STATUS_CLR_MASK),
				    (unsigned int)(PMIC_WDTRSTB_STATUS_CLR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_wdtrstb_fb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WDTRSTB_FB_EN_MASK),
				    (unsigned int)(PMIC_RG_WDTRSTB_FB_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_wdtrstb_deb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WDTRSTB_DEB_MASK),
				    (unsigned int)(PMIC_RG_WDTRSTB_DEB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_homekey_rst_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HOMEKEY_RST_EN_MASK),
				    (unsigned int)(PMIC_RG_HOMEKEY_RST_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pwrkey_rst_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PWRKEY_RST_EN_MASK),
				    (unsigned int)(PMIC_RG_PWRKEY_RST_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pwrrst_tmr_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PWRRST_TMR_DIS_MASK),
				    (unsigned int)(PMIC_RG_PWRRST_TMR_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pwrkey_rst_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PWRKEY_RST_TD_MASK),
				    (unsigned int)(PMIC_RG_PWRKEY_RST_TD_SHIFT)
	    );

}

void mt6335_upmu_set_top_rst_misc_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_MISC_RSV_MASK),
				    (unsigned int)(PMIC_TOP_RST_MISC_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_vpwrin_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VPWRIN_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_VPWRIN_RSTB_STATUS_SHIFT)
	    );

}

void mt6335_upmu_set_ddlo_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DDLO_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_DDLO_RSTB_STATUS_SHIFT)
	    );

}

void mt6335_upmu_set_uvlo_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_UVLO_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_UVLO_RSTB_STATUS_SHIFT)
	    );

}

void mt6335_upmu_set_rtc_ddlo_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RTC_DDLO_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_RTC_DDLO_RSTB_STATUS_SHIFT)
	    );

}

void mt6335_upmu_set_chrwdt_reg_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRWDT_REG_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_CHRWDT_REG_RSTB_STATUS_SHIFT)
	    );

}

void mt6335_upmu_set_chrdet_reg_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRDET_REG_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_CHRDET_REG_RSTB_STATUS_SHIFT)
	    );

}

void mt6335_upmu_set_bwdt_ddlo_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BWDT_DDLO_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_BWDT_DDLO_RSTB_STATUS_SHIFT)
	    );

}

void mt6335_upmu_set_top_rst_status_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_STATUS_RSV_MASK),
				    (unsigned int)(PMIC_TOP_RST_STATUS_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_top_rst_rsv_con0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_RSV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_RSV_CON0_MASK),
				    (unsigned int)(PMIC_TOP_RST_RSV_CON0_SHIFT)
	    );

}

void mt6335_upmu_set_top_rst_rsv_con1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_TOP_RST_RSV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_RSV_CON1_MASK),
				    (unsigned int)(PMIC_TOP_RST_RSV_CON1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_pwrkey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_PWRKEY_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_PWRKEY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_homekey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_pwrkey_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_PWRKEY_R_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_PWRKEY_R_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_homekey_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_R_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_R_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_ni_lbat_int(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_NI_LBAT_INT_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_NI_LBAT_INT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_chrdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_CHRDET_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_CHRDET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_chrdet_edge(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_CHRDET_EDGE_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_CHRDET_EDGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_baton_lv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BATON_LV_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BATON_LV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_baton_hv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BATON_HV_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BATON_HV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_baton_bat_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BATON_BAT_IN_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BATON_BAT_IN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_baton_bat_out(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BATON_BAT_OUT_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BATON_BAT_OUT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_rtc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_RTC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_RTC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_bif(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BIF_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BIF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcdt_hv_det(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCDT_HV_DET_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCDT_HV_DET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_thr_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_THR_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_THR_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_thr_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_THR_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_THR_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_bat_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_bat_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_bat2_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BAT2_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BAT2_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_bat2_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BAT2_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BAT2_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_bat_temp_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_TEMP_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_TEMP_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_bat_temp_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_TEMP_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_TEMP_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_auxadc_imp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_AUXADC_IMP_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_AUXADC_IMP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_nag_c_dltv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_NAG_C_DLTV_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_NAG_C_DLTV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_jeita_hot(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_JEITA_HOT_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_JEITA_HOT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_jeita_warm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_JEITA_WARM_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_JEITA_WARM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_jeita_cool(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_JEITA_COOL_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_JEITA_COOL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_jeita_cold(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_JEITA_COLD_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_JEITA_COLD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcore_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCORE_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCORE_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vmd1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VMD1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VMD1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vmodem_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VMODEM_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VMODEM_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vs1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VS1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VS1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vs2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VS2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VS2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vdram_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VDRAM_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VDRAM_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vpa1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VPA1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VPA1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vpa2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VPA2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VPA2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcore_preoc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCORE_PREOC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCORE_PREOC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_va10_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VA10_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VA10_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_va12_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VA12_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VA12_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_va18_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VA18_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VA18_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vbif28_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VBIF28_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VBIF28_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcama1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMA1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMA1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcama2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMA2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMA2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcamaf_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMAF_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMAF_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcamd1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMD1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMD1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcamd2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMD2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMD2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcamio_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMIO_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCAMIO_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcn18_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCN18_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCN18_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcn28_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCN28_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCN28_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vcn33_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCN33_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCN33_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vefuse_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VEFUSE_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VEFUSE_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vemc_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VEMC_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VEMC_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vfe28_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VFE28_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VFE28_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vgp3_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VGP3_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VGP3_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vibr_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VIBR_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VIBR_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vio18_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VIO18_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VIO18_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vio28_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VIO28_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VIO28_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vmc_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VMC_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VMC_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vmch_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VMCH_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VMCH_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vmipi_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VMIPI_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VMIPI_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vrf12_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VRF12_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VRF12_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vrf18_1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VRF18_1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VRF18_1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vrf18_2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VRF18_2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VRF18_2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vsim1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VSIM1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VSIM1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vsim2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VSIM2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VSIM2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vsram_core_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VSRAM_CORE_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VSRAM_CORE_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vsram_dvfs1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VSRAM_DVFS1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VSRAM_DVFS1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vsram_dvfs2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VSRAM_DVFS2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VSRAM_DVFS2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vsram_gpu_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VSRAM_GPU_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VSRAM_GPU_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vsram_md_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VSRAM_MD_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VSRAM_MD_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vufs18_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VUFS18_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VUFS18_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vusb33_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VUSB33_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VUSB33_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_vxo22_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VXO22_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VXO22_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_con4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_CON4_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_CON4_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_bat0_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT0_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT0_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_bat0_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT0_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT0_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_cur_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_CUR_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_CUR_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_cur_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_CUR_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_CUR_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_zcv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_ZCV_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_ZCV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_bat1_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT1_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT1_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_bat1_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT1_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT1_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_n_charge_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_N_CHARGE_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_N_CHARGE_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_iavg_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_IAVG_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_IAVG_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_iavg_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_IAVG_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_IAVG_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_time_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_TIME_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_TIME_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_discharge(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_DISCHARGE_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_DISCHARGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_fg_charge(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_CHARGE_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_CHARGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_en_con5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_CON5_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_CON5_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_pwrkey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_PWRKEY_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_PWRKEY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_homekey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_HOMEKEY_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_HOMEKEY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_pwrkey_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_PWRKEY_R_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_PWRKEY_R_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_homekey_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_HOMEKEY_R_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_HOMEKEY_R_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_ni_lbat_int(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_NI_LBAT_INT_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_NI_LBAT_INT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_chrdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_CHRDET_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_CHRDET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_chrdet_edge(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_CHRDET_EDGE_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_CHRDET_EDGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_baton_lv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_BATON_LV_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_BATON_LV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_baton_hv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_BATON_HV_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_BATON_HV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_baton_bat_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_BATON_BAT_IN_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_BATON_BAT_IN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_baton_bat_out(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_BATON_BAT_OUT_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_BATON_BAT_OUT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_rtc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_RTC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_RTC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_bif(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_BIF_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_BIF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcdt_hv_det(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCDT_HV_DET_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCDT_HV_DET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_thr_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_THR_H_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_THR_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_thr_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_THR_L_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_THR_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_bat_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT_H_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_bat_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT_L_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_bat2_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT2_H_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT2_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_bat2_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT2_L_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT2_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_bat_temp_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT_TEMP_H_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT_TEMP_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_bat_temp_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT_TEMP_L_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_BAT_TEMP_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_auxadc_imp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_AUXADC_IMP_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_AUXADC_IMP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_nag_c_dltv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_NAG_C_DLTV_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_NAG_C_DLTV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_jeita_hot(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_JEITA_HOT_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_JEITA_HOT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_jeita_warm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_JEITA_WARM_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_JEITA_WARM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_jeita_cool(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_JEITA_COOL_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_JEITA_COOL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_jeita_cold(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_JEITA_COLD_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_JEITA_COLD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcore_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCORE_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCORE_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vmd1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VMD1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VMD1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vmodem_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VMODEM_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VMODEM_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vs1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VS1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VS1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vs2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VS2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VS2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vdram_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VDRAM_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VDRAM_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vpa1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VPA1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VPA1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vpa2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VPA2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VPA2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcore_preoc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCORE_PREOC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCORE_PREOC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_va10_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VA10_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VA10_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_va12_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VA12_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VA12_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_va18_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VA18_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VA18_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vbif28_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VBIF28_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VBIF28_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcama1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMA1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMA1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcama2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMA2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMA2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcamaf_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMAF_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMAF_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcamd1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMD1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMD1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcamd2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMD2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMD2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcamio_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMIO_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCAMIO_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcn18_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCN18_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCN18_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcn28_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCN28_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCN28_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vcn33_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VCN33_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VCN33_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vefuse_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VEFUSE_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VEFUSE_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vemc_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VEMC_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VEMC_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vfe28_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VFE28_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VFE28_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vgp3_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VGP3_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VGP3_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vibr_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VIBR_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VIBR_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vio18_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VIO18_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VIO18_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vio28_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VIO28_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VIO28_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vmc_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VMC_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VMC_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vmch_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VMCH_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VMCH_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vmipi_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VMIPI_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VMIPI_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vrf12_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VRF12_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VRF12_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vrf18_1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VRF18_1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VRF18_1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vrf18_2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VRF18_2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VRF18_2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vsim1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VSIM1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VSIM1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vsim2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VSIM2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VSIM2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vsram_core_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VSRAM_CORE_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VSRAM_CORE_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vsram_dvfs1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VSRAM_DVFS1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VSRAM_DVFS1_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vsram_dvfs2_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VSRAM_DVFS2_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VSRAM_DVFS2_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vsram_gpu_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VSRAM_GPU_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VSRAM_GPU_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vsram_md_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VSRAM_MD_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VSRAM_MD_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vufs18_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VUFS18_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VUFS18_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vusb33_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VUSB33_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VUSB33_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_vxo22_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_VXO22_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_VXO22_OC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_con4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_CON4_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_CON4_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_bat0_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_BAT0_H_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_BAT0_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_bat0_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_BAT0_L_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_BAT0_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_cur_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_CUR_H_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_CUR_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_cur_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_CUR_L_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_CUR_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_zcv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_ZCV_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_ZCV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_bat1_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_BAT1_H_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_BAT1_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_bat1_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_BAT1_L_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_BAT1_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_n_charge_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_N_CHARGE_L_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_N_CHARGE_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_iavg_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_IAVG_H_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_IAVG_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_iavg_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_IAVG_L_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_IAVG_L_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_time_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_TIME_H_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_TIME_H_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_discharge(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_DISCHARGE_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_DISCHARGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_fg_charge(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_CHARGE_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_FG_CHARGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_int_mask_con5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MASK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_MASK_CON5_MASK),
				    (unsigned int)(PMIC_RG_INT_MASK_CON5_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rg_int_status_pwrkey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_PWRKEY_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_PWRKEY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_homekey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_HOMEKEY_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_HOMEKEY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_pwrkey_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_PWRKEY_R_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_PWRKEY_R_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_homekey_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_HOMEKEY_R_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_HOMEKEY_R_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_ni_lbat_int(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_NI_LBAT_INT_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_NI_LBAT_INT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_chrdet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_CHRDET_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_CHRDET_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_chrdet_edge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_CHRDET_EDGE_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_CHRDET_EDGE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_baton_lv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BATON_LV_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BATON_LV_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_baton_hv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BATON_HV_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BATON_HV_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_baton_bat_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BATON_BAT_IN_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BATON_BAT_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_baton_bat_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BATON_BAT_OUT_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BATON_BAT_OUT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_rtc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_RTC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_RTC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_bif(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BIF_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BIF_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcdt_hv_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCDT_HV_DET_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCDT_HV_DET_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_thr_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_THR_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_THR_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_thr_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_THR_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_THR_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_bat_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_bat_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_bat2_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT2_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT2_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_bat2_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT2_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT2_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_bat_temp_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_TEMP_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_TEMP_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_bat_temp_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_TEMP_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_TEMP_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_auxadc_imp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_AUXADC_IMP_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_AUXADC_IMP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_nag_c_dltv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_NAG_C_DLTV_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_NAG_C_DLTV_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_jeita_hot(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_JEITA_HOT_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_JEITA_HOT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_jeita_warm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_JEITA_WARM_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_JEITA_WARM_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_jeita_cool(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_JEITA_COOL_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_JEITA_COOL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_jeita_cold(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_JEITA_COLD_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_JEITA_COLD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcore_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCORE_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCORE_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vmd1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VMD1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VMD1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vmodem_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VMODEM_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VMODEM_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vs1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VS1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VS1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vs2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VS2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VS2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vdram_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VDRAM_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VDRAM_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vpa1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VPA1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VPA1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vpa2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VPA2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VPA2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcore_preoc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCORE_PREOC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCORE_PREOC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_va10_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VA10_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VA10_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_va12_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VA12_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VA12_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_va18_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VA18_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VA18_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vbif28_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VBIF28_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VBIF28_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcama1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMA1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMA1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcama2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMA2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMA2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcamaf_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMAF_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMAF_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcamd1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMD1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMD1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcamd2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMD2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMD2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcamio_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMIO_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCAMIO_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcn18_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCN18_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCN18_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcn28_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCN28_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCN28_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vcn33_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCN33_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCN33_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vefuse_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VEFUSE_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VEFUSE_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vemc_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VEMC_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VEMC_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vfe28_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VFE28_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VFE28_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vgp3_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VGP3_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VGP3_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vibr_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VIBR_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VIBR_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vio18_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VIO18_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VIO18_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vio28_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VIO28_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VIO28_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vmc_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VMC_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VMC_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vmch_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VMCH_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VMCH_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vmipi_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VMIPI_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VMIPI_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vrf12_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VRF12_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VRF12_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vrf18_1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VRF18_1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VRF18_1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vrf18_2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VRF18_2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VRF18_2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vsim1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSIM1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSIM1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vsim2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSIM2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSIM2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vsram_core_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSRAM_CORE_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSRAM_CORE_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vsram_dvfs1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSRAM_DVFS1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSRAM_DVFS1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vsram_dvfs2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSRAM_DVFS2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSRAM_DVFS2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vsram_gpu_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSRAM_GPU_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSRAM_GPU_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vsram_md_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSRAM_MD_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VSRAM_MD_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vufs18_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VUFS18_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VUFS18_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vusb33_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VUSB33_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VUSB33_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_vxo22_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VXO22_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VXO22_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_con4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_CON4_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_CON4_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_bat0_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT0_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT0_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_bat0_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT0_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT0_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_cur_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_CUR_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_CUR_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_cur_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_CUR_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_CUR_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_zcv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_ZCV_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_ZCV_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_bat1_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT1_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT1_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_bat1_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT1_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT1_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_n_charge_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_N_CHARGE_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_N_CHARGE_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_iavg_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_IAVG_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_IAVG_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_iavg_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_IAVG_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_IAVG_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_time_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_TIME_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_TIME_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_discharge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_DISCHARGE_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_DISCHARGE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_fg_charge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_CHARGE_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_CHARGE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_status_con5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_CON5_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_CON5_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_pwrkey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_PWRKEY_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_PWRKEY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_homekey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_HOMEKEY_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_HOMEKEY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_pwrkey_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_PWRKEY_R_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_PWRKEY_R_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_homekey_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_HOMEKEY_R_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_HOMEKEY_R_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_ni_lbat_int(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_NI_LBAT_INT_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_NI_LBAT_INT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_chrdet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_CHRDET_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_CHRDET_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_chrdet_edge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_CHRDET_EDGE_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_CHRDET_EDGE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_baton_lv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BATON_LV_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BATON_LV_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_baton_hv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BATON_HV_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BATON_HV_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_baton_bat_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BATON_BAT_IN_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BATON_BAT_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_baton_bat_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BATON_BAT_OUT_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BATON_BAT_OUT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_rtc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_RTC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_RTC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_bif(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BIF_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BIF_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcdt_hv_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCDT_HV_DET_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCDT_HV_DET_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_thr_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_THR_H_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_THR_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_thr_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_THR_L_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_THR_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_bat_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT_H_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_bat_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT_L_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_bat2_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT2_H_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT2_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_bat2_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT2_L_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT2_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_bat_temp_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT_TEMP_H_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT_TEMP_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_bat_temp_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT_TEMP_L_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_BAT_TEMP_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_auxadc_imp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_AUXADC_IMP_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_AUXADC_IMP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_nag_c_dltv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_NAG_C_DLTV_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_NAG_C_DLTV_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_jeita_hot(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_JEITA_HOT_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_JEITA_HOT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_jeita_warm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_JEITA_WARM_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_JEITA_WARM_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_jeita_cool(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_JEITA_COOL_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_JEITA_COOL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_jeita_cold(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_JEITA_COLD_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_JEITA_COLD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcore_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCORE_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCORE_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vmd1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VMD1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VMD1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vmodem_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VMODEM_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VMODEM_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vs1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VS1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VS1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vs2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VS2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VS2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vdram_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VDRAM_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VDRAM_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vpa1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VPA1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VPA1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vpa2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VPA2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VPA2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcore_preoc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCORE_PREOC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCORE_PREOC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_va10_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VA10_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VA10_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_va12_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VA12_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VA12_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_va18_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VA18_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VA18_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vbif28_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VBIF28_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VBIF28_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcama1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMA1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMA1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcama2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMA2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMA2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcamaf_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMAF_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMAF_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcamd1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMD1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMD1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcamd2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMD2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMD2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcamio_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMIO_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCAMIO_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcn18_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCN18_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCN18_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcn28_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCN28_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCN28_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vcn33_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCN33_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VCN33_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vefuse_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VEFUSE_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VEFUSE_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vemc_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VEMC_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VEMC_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vfe28_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VFE28_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VFE28_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vgp3_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VGP3_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VGP3_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vibr_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VIBR_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VIBR_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vio18_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VIO18_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VIO18_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vio28_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VIO28_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VIO28_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vmc_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VMC_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VMC_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vmch_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VMCH_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VMCH_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vmipi_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VMIPI_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VMIPI_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vrf12_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VRF12_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VRF12_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vrf18_1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VRF18_1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VRF18_1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vrf18_2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VRF18_2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VRF18_2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vsim1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSIM1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSIM1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vsim2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSIM2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSIM2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vsram_core_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSRAM_CORE_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSRAM_CORE_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vsram_dvfs1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSRAM_DVFS1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSRAM_DVFS1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vsram_dvfs2_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSRAM_DVFS2_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSRAM_DVFS2_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vsram_gpu_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSRAM_GPU_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSRAM_GPU_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vsram_md_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSRAM_MD_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VSRAM_MD_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vufs18_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VUFS18_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VUFS18_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vusb33_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VUSB33_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VUSB33_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_vxo22_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VXO22_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_VXO22_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_con4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS4),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_CON4_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_CON4_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_bat0_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_BAT0_H_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_BAT0_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_bat0_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_BAT0_L_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_BAT0_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_cur_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_CUR_H_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_CUR_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_cur_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_CUR_L_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_CUR_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_zcv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_ZCV_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_ZCV_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_bat1_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_BAT1_H_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_BAT1_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_bat1_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_BAT1_L_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_BAT1_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_n_charge_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_N_CHARGE_L_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_N_CHARGE_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_iavg_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_IAVG_H_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_IAVG_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_iavg_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_IAVG_L_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_IAVG_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_time_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_TIME_H_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_TIME_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_discharge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_DISCHARGE_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_DISCHARGE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_fg_charge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_CHARGE_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_FG_CHARGE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_int_raw_status_con5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_RAW_STATUS5),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_CON5_MASK),
				  (unsigned int)(PMIC_RG_INT_RAW_STATUS_CON5_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_polarity(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_POLARITY_MASK),
				    (unsigned int)(PMIC_POLARITY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_homekey_int_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HOMEKEY_INT_SEL_MASK),
				    (unsigned int)(PMIC_RG_HOMEKEY_INT_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pwrkey_int_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PWRKEY_INT_SEL_MASK),
				    (unsigned int)(PMIC_RG_PWRKEY_INT_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_chrdet_int_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRDET_INT_SEL_MASK),
				    (unsigned int)(PMIC_RG_CHRDET_INT_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pchr_cm_vinc_polarity_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_CM_VINC_POLARITY_RSV_MASK),
				    (unsigned int)(PMIC_RG_PCHR_CM_VINC_POLARITY_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pchr_cm_vdec_polarity_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_CM_VDEC_POLARITY_RSV_MASK),
				    (unsigned int)(PMIC_RG_PCHR_CM_VDEC_POLARITY_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_fqmtr_tcksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FQMTR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FQMTR_TCKSEL_MASK),
				    (unsigned int)(PMIC_FQMTR_TCKSEL_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fqmtr_busy(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FQMTR_CON0),
				  (&val),
				  (unsigned int)(PMIC_FQMTR_BUSY_MASK),
				  (unsigned int)(PMIC_FQMTR_BUSY_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_fqmtr_dcxo26m_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FQMTR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FQMTR_DCXO26M_EN_MASK),
				    (unsigned int)(PMIC_FQMTR_DCXO26M_EN_SHIFT)
	    );

}

void mt6335_upmu_set_fqmtr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FQMTR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FQMTR_EN_MASK),
				    (unsigned int)(PMIC_FQMTR_EN_SHIFT)
	    );

}

void mt6335_upmu_set_fqmtr_winset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FQMTR_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FQMTR_WINSET_MASK),
				    (unsigned int)(PMIC_FQMTR_WINSET_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fqmtr_data(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FQMTR_CON2),
				  (&val),
				  (unsigned int)(PMIC_FQMTR_DATA_MASK),
				  (unsigned int)(PMIC_FQMTR_DATA_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_slp_rw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RG_SPI_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SLP_RW_EN_MASK),
				    (unsigned int)(PMIC_RG_SLP_RW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_spi_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RG_SPI_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_RSV_MASK),
				    (unsigned int)(PMIC_RG_SPI_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_dew_dio_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DEW_DIO_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_DIO_EN_MASK),
				    (unsigned int)(PMIC_DEW_DIO_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_dew_read_test(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_DEW_READ_TEST),
				  (&val),
				  (unsigned int)(PMIC_DEW_READ_TEST_MASK),
				  (unsigned int)(PMIC_DEW_READ_TEST_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_dew_write_test(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DEW_WRITE_TEST),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_WRITE_TEST_MASK),
				    (unsigned int)(PMIC_DEW_WRITE_TEST_SHIFT)
	    );

}

void mt6335_upmu_set_dew_crc_swrst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DEW_CRC_SWRST),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CRC_SWRST_MASK),
				    (unsigned int)(PMIC_DEW_CRC_SWRST_SHIFT)
	    );

}

void mt6335_upmu_set_dew_crc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DEW_CRC_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CRC_EN_MASK),
				    (unsigned int)(PMIC_DEW_CRC_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_dew_crc_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_DEW_CRC_VAL),
				  (&val),
				  (unsigned int)(PMIC_DEW_CRC_VAL_MASK),
				  (unsigned int)(PMIC_DEW_CRC_VAL_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_dew_dbg_mon_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DEW_DBG_MON_SEL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_DBG_MON_SEL_MASK),
				    (unsigned int)(PMIC_DEW_DBG_MON_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_dew_cipher_key_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DEW_CIPHER_KEY_SEL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CIPHER_KEY_SEL_MASK),
				    (unsigned int)(PMIC_DEW_CIPHER_KEY_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_dew_cipher_iv_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DEW_CIPHER_IV_SEL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CIPHER_IV_SEL_MASK),
				    (unsigned int)(PMIC_DEW_CIPHER_IV_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_dew_cipher_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DEW_CIPHER_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CIPHER_EN_MASK),
				    (unsigned int)(PMIC_DEW_CIPHER_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_dew_cipher_rdy(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_DEW_CIPHER_RDY),
				  (&val),
				  (unsigned int)(PMIC_DEW_CIPHER_RDY_MASK),
				  (unsigned int)(PMIC_DEW_CIPHER_RDY_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_dew_cipher_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DEW_CIPHER_MODE),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CIPHER_MODE_MASK),
				    (unsigned int)(PMIC_DEW_CIPHER_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_dew_cipher_swrst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DEW_CIPHER_SWRST),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CIPHER_SWRST_MASK),
				    (unsigned int)(PMIC_DEW_CIPHER_SWRST_SHIFT)
	    );

}

void mt6335_upmu_set_dew_rddmy_no(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DEW_RDDMY_NO),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_RDDMY_NO_MASK),
				    (unsigned int)(PMIC_DEW_RDDMY_NO_SHIFT)
	    );

}

void mt6335_upmu_set_int_type_con0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_TYPE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_INT_TYPE_CON0_MASK),
				    (unsigned int)(PMIC_INT_TYPE_CON0_SHIFT)
	    );

}

void mt6335_upmu_set_int_type_con1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_TYPE_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_INT_TYPE_CON1_MASK),
				    (unsigned int)(PMIC_INT_TYPE_CON1_SHIFT)
	    );

}

void mt6335_upmu_set_int_type_con2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_TYPE_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_INT_TYPE_CON2_MASK),
				    (unsigned int)(PMIC_INT_TYPE_CON2_SHIFT)
	    );

}

void mt6335_upmu_set_int_type_con3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_TYPE_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_INT_TYPE_CON3_MASK),
				    (unsigned int)(PMIC_INT_TYPE_CON3_SHIFT)
	    );

}

void mt6335_upmu_set_int_type_con4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_TYPE_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_INT_TYPE_CON4_MASK),
				    (unsigned int)(PMIC_INT_TYPE_CON4_SHIFT)
	    );

}

void mt6335_upmu_set_int_type_con5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_INT_TYPE_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_INT_TYPE_CON5_MASK),
				    (unsigned int)(PMIC_INT_TYPE_CON5_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_cpu_int_sta(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STA),
				  (&val),
				  (unsigned int)(PMIC_CPU_INT_STA_MASK),
				  (unsigned int)(PMIC_CPU_INT_STA_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_md32_int_sta(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_INT_STA),
				  (&val),
				  (unsigned int)(PMIC_MD32_INT_STA_MASK),
				  (unsigned int)(PMIC_MD32_INT_STA_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_srclken_in3_smps_clk_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RG_SPI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN3_SMPS_CLK_MODE_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN3_SMPS_CLK_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_srclken_in3_en_smps_test(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RG_SPI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN3_EN_SMPS_TEST_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN3_EN_SMPS_TEST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_srclken_in2_smps_clk_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RG_SPI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN2_SMPS_CLK_MODE_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN2_SMPS_CLK_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_srclken_in2_en_smps_test(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RG_SPI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN2_EN_SMPS_TEST_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN2_EN_SMPS_TEST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_spi_dly_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RG_SPI_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_DLY_SEL_MASK),
				    (unsigned int)(PMIC_RG_SPI_DLY_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_ldo_ft_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_ALL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_LDO_FT_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_LDO_FT_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_dcm_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_ALL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_DCM_MODE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_DCM_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_all_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_ALL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_ALL_CON0_RSV_MASK),
				    (unsigned int)(PMIC_RG_BUCK_ALL_CON0_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_stb_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_STB_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_STB_MAX_MASK),
				    (unsigned int)(PMIC_RG_BUCK_STB_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_lp_prot_disable(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_STB_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_LP_PROT_DISABLE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_LP_PROT_DISABLE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vsleep_src0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_SLP_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VSLEEP_SRC0_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VSLEEP_SRC0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vsleep_src1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_SLP_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VSLEEP_SRC1_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VSLEEP_SRC1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_r2r_src0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_SLP_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_R2R_SRC0_MASK),
				    (unsigned int)(PMIC_RG_BUCK_R2R_SRC0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_r2r_src1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_SLP_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_R2R_SRC1_MASK),
				    (unsigned int)(PMIC_RG_BUCK_R2R_SRC1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_lp_seq_count(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_SLP_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_LP_SEQ_COUNT_MASK),
				    (unsigned int)(PMIC_RG_BUCK_LP_SEQ_COUNT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_on_seq_count(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_SLP_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_ON_SEQ_COUNT_MASK),
				    (unsigned int)(PMIC_RG_BUCK_ON_SEQ_COUNT_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rg_buck_vcore_oc_sdn_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_BUCK_VCORE_OC_SDN_STATUS_MASK),
				  (unsigned int)(PMIC_RG_BUCK_VCORE_OC_SDN_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_buck_vdram_oc_sdn_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_SDN_STATUS_MASK),
				  (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_SDN_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_buck_vmodem_oc_sdn_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_SDN_STATUS_MASK),
				  (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_SDN_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_buck_vmd1_oc_sdn_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_BUCK_VMD1_OC_SDN_STATUS_MASK),
				  (unsigned int)(PMIC_RG_BUCK_VMD1_OC_SDN_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_buck_vs1_oc_sdn_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_BUCK_VS1_OC_SDN_STATUS_MASK),
				  (unsigned int)(PMIC_RG_BUCK_VS1_OC_SDN_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_buck_vs2_oc_sdn_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_BUCK_VS2_OC_SDN_STATUS_MASK),
				  (unsigned int)(PMIC_RG_BUCK_VS2_OC_SDN_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_buck_vpa1_oc_sdn_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_BUCK_VPA1_OC_SDN_STATUS_MASK),
				  (unsigned int)(PMIC_RG_BUCK_VPA1_OC_SDN_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_buck_vpa2_oc_sdn_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_BUCK_VPA2_OC_SDN_STATUS_MASK),
				  (unsigned int)(PMIC_RG_BUCK_VPA2_OC_SDN_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_buck_vcore_oc_sdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OC_SDN_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OC_SDN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_oc_sdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_SDN_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_SDN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_oc_sdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_SDN_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_SDN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_oc_sdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OC_SDN_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OC_SDN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_oc_sdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OC_SDN_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OC_SDN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_oc_sdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OC_SDN_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OC_SDN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_oc_sdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OC_SDN_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OC_SDN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_oc_sdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OC_SDN_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OC_SDN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_k_rst_done(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_K_RST_DONE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_K_RST_DONE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_k_map_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_K_MAP_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_K_MAP_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_k_once_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_K_ONCE_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_K_ONCE_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_k_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_K_ONCE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_K_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_k_start_manual(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_K_START_MANUAL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_K_START_MANUAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_k_src_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_K_SRC_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_K_SRC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_k_auto_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_K_AUTO_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_K_AUTO_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_k_inv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_K_INV_MASK),
				    (unsigned int)(PMIC_RG_BUCK_K_INV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_k_ck_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_K_CK_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_K_CK_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_k_control_smps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_K_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_K_CONTROL_SMPS_MASK),
				    (unsigned int)(PMIC_RG_BUCK_K_CONTROL_SMPS_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_buck_k_result(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_K_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_RESULT_MASK),
				  (unsigned int)(PMIC_BUCK_K_RESULT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_buck_k_done(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_K_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_DONE_MASK),
				  (unsigned int)(PMIC_BUCK_K_DONE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_buck_k_control(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_K_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_CONTROL_MASK),
				  (unsigned int)(PMIC_BUCK_K_CONTROL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_smps_osc_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_K_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_SMPS_OSC_CAL_MASK),
				  (unsigned int)(PMIC_DA_QI_SMPS_OSC_CAL_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_buck_k_buck_ck_cnt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_K_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_K_BUCK_CK_CNT_MASK),
				    (unsigned int)(PMIC_RG_BUCK_K_BUCK_CK_CNT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_sshub_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_SSHUB_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SSHUB_MODE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SSHUB_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_sshub_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_SSHUB_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SSHUB_ON_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SSHUB_ON_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_sshub_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_SSHUB_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SSHUB_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SSHUB_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_LP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_VOSEL_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_LP_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_sp_sw_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_SP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SP_SW_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SP_SW_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_sp_sw_vosel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_SP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SP_SW_VOSEL_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SP_SW_VOSEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_sp_on_vosel_mux_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_SP_CFG),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_BUCK_VCORE_SP_ON_VOSEL_MUX_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_SP_ON_VOSEL_MUX_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OC_DEG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OC_WND_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OC_WND_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OC_THD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OC_THD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_ni_vcore_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VCORE_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VCORE_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VCORE_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vcore_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VCORE_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VCORE_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VCORE_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcore_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VCORE_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_vcore_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VCORE_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_VCORE_STB_MASK),
				  (unsigned int)(PMIC_DA_VCORE_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vcore_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VCORE_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VCORE_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VCORE_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vcore_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VCORE_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VCORE_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VCORE_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcore_dvs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VCORE_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE_DVS_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE_DVS_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_buck_vcore_lp_auto_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_LP_AUTO_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_LP_AUTO_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_lp_dbg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_LP_DBG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_LP_DBG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_vsleep_sel_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_VSLEEP_SEL_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_VSLEEP_SEL_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_r2r_pdn_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_R2R_PDN_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_R2R_PDN_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vcore_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VCORE_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VCORE_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_LP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_VOSEL_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_LP_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_sp_sw_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_SP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SP_SW_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SP_SW_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_sp_sw_vosel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_SP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SP_SW_VOSEL_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SP_SW_VOSEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_sp_on_vosel_mux_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_SP_CFG),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_BUCK_VDRAM_SP_ON_VOSEL_MUX_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_SP_ON_VOSEL_MUX_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_DEG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_WND_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_WND_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_THD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_THD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_ni_vdram_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VDRAM_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VDRAM_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vdram_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VDRAM_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VDRAM_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vdram_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VDRAM_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VDRAM_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_vdram_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_VDRAM_STB_MASK),
				  (unsigned int)(PMIC_DA_VDRAM_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vdram_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VDRAM_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VDRAM_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vdram_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VDRAM_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VDRAM_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vdram_dvs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VDRAM_DVS_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VDRAM_DVS_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_buck_vdram_lp_auto_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_LP_AUTO_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_LP_AUTO_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_lp_dbg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_LP_DBG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_LP_DBG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_vsleep_sel_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_VSLEEP_SEL_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_VSLEEP_SEL_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_r2r_pdn_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_R2R_PDN_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_R2R_PDN_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vdram_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VDRAM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VDRAM_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_LP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_VOSEL_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_LP_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_sp_sw_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_SP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SP_SW_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SP_SW_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_sp_sw_vosel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_SP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SP_SW_VOSEL_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SP_SW_VOSEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_sp_on_vosel_mux_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_SP_CFG),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_BUCK_VMD1_SP_ON_VOSEL_MUX_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_SP_ON_VOSEL_MUX_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OC_DEG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OC_WND_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OC_WND_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OC_THD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OC_THD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_ni_vmd1_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMD1_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VMD1_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VMD1_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vmd1_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMD1_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VMD1_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VMD1_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vmd1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMD1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMD1_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMD1_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_vmd1_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMD1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_VMD1_STB_MASK),
				  (unsigned int)(PMIC_DA_VMD1_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vmd1_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMD1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VMD1_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VMD1_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vmd1_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMD1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VMD1_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VMD1_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vmd1_dvs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMD1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMD1_DVS_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMD1_DVS_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_buck_vmd1_lp_auto_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_LP_AUTO_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_LP_AUTO_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_lp_dbg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_LP_DBG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_LP_DBG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_vsleep_sel_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_VSLEEP_SEL_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_VSLEEP_SEL_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_r2r_pdn_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_R2R_PDN_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_R2R_PDN_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmd1_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMD1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMD1_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_LP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_VOSEL_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_LP_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_sp_sw_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_SP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SP_SW_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SP_SW_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_sp_sw_vosel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_SP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SP_SW_VOSEL_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SP_SW_VOSEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_sp_on_vosel_mux_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_SP_CFG),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_BUCK_VMODEM_SP_ON_VOSEL_MUX_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_SP_ON_VOSEL_MUX_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_DEG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_WND_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_WND_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_THD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_THD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_ni_vmodem_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VMODEM_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VMODEM_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vmodem_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VMODEM_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VMODEM_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vmodem_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMODEM_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMODEM_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_vmodem_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_VMODEM_STB_MASK),
				  (unsigned int)(PMIC_DA_VMODEM_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vmodem_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VMODEM_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VMODEM_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vmodem_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VMODEM_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VMODEM_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vmodem_dvs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMODEM_DVS_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMODEM_DVS_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_buck_vmodem_lp_auto_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_LP_AUTO_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_LP_AUTO_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_lp_dbg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_LP_DBG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_LP_DBG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_vsleep_sel_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_VSLEEP_SEL_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_VSLEEP_SEL_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_r2r_pdn_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_R2R_PDN_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_R2R_PDN_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vmodem_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VMODEM_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VMODEM_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_LP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_VOSEL_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_LP_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_sp_sw_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_SP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SP_SW_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SP_SW_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_sp_sw_vosel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_SP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SP_SW_VOSEL_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SP_SW_VOSEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_sp_on_vosel_mux_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_SP_CFG),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_BUCK_VS1_SP_ON_VOSEL_MUX_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_SP_ON_VOSEL_MUX_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OC_DEG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OC_WND_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OC_WND_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OC_THD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OC_THD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_ni_vs1_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS1_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VS1_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VS1_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vs1_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS1_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VS1_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VS1_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vs1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VS1_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VS1_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_vs1_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_VS1_STB_MASK),
				  (unsigned int)(PMIC_DA_VS1_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vs1_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VS1_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VS1_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vs1_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VS1_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VS1_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vs1_dvs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VS1_DVS_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VS1_DVS_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_buck_vs1_lp_auto_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_LP_AUTO_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_LP_AUTO_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_lp_dbg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_LP_DBG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_LP_DBG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_vsleep_sel_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_VSLEEP_SEL_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_VSLEEP_SEL_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_r2r_pdn_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_R2R_PDN_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_R2R_PDN_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs1_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS1_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS1_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_LP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_VOSEL_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_LP_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_sp_sw_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_SP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SP_SW_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SP_SW_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_sp_sw_vosel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_SP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SP_SW_VOSEL_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SP_SW_VOSEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_sp_on_vosel_mux_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_SP_CFG),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_BUCK_VS2_SP_ON_VOSEL_MUX_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_SP_ON_VOSEL_MUX_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OC_DEG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OC_WND_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OC_WND_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OC_THD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OC_THD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_ni_vs2_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS2_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VS2_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VS2_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vs2_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS2_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VS2_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VS2_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vs2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VS2_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VS2_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_vs2_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_VS2_STB_MASK),
				  (unsigned int)(PMIC_DA_VS2_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vs2_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VS2_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VS2_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vs2_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VS2_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VS2_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vs2_dvs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VS2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VS2_DVS_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VS2_DVS_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_buck_vs2_lp_auto_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_LP_AUTO_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_LP_AUTO_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_lp_dbg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_LP_DBG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_LP_DBG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_vsleep_sel_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_VSLEEP_SEL_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_VSLEEP_SEL_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_r2r_pdn_dbg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_R2R_PDN_DBG_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_R2R_PDN_DBG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vs2_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VS2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VS2_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VS2_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_dvs_bw_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CFG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_BW_TD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_BW_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_dvs_bw_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CFG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_BW_CTRL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_BW_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_dvs_bw_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_CFG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_BW_ONCE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DVS_BW_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OC_DEG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OC_WND_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OC_WND_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OC_THD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OC_THD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_ni_vpa1_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA1_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA1_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA1_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vpa1_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA1_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA1_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA1_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vpa1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VPA1_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VPA1_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_vpa1_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_VPA1_STB_MASK),
				  (unsigned int)(PMIC_DA_VPA1_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vpa1_dvs_transt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA1_DVS_TRANST_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA1_DVS_TRANST_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vpa1_dvs_bw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA1_DVS_BW_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA1_DVS_BW_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vpa1_dlc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA1_DLC_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA1_DLC_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_buck_vpa1_lp_dbg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_LP_DBG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_LP_DBG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_vosel_dlc011(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_DLC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_VOSEL_DLC011_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_VOSEL_DLC011_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_vosel_dlc111(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_DLC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_VOSEL_DLC111_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_VOSEL_DLC111_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_vosel_dlc001(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_DLC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_VOSEL_DLC001_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_VOSEL_DLC001_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_dlc_map_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_DLC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DLC_MAP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DLC_MAP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_DLC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DLC_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_DLC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rdelta2go(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RDELTA2GO_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RDELTA2GO_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_fdelta2go(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FDELTA2GO_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FDELTA2GO_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rrate0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_RRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE0_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rrate1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_RRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE1_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rrate2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_RRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE2_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rrate3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_RRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE3_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE3_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rrate4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_RRATE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE4_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE4_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rrate5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_RRATE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE5_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RRATE5_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rthd0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_RTHD0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RTHD0_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RTHD0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rthd1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_RTHD0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RTHD1_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RTHD1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rthd2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_RTHD1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RTHD2_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RTHD2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rthd3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_RTHD1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RTHD3_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RTHD3_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_rthd4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_RTHD2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RTHD4_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_RTHD4_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_frate0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_FRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE0_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_frate1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_FRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE1_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_frate2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_FRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE2_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_frate3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_FRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE3_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE3_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_frate4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_FRATE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE4_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE4_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_frate5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_FRATE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE5_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FRATE5_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_fthd0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_FTHD0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FTHD0_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FTHD0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_fthd1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_FTHD0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FTHD1_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FTHD1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_fthd2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_FTHD1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FTHD2_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FTHD2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_fthd3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_FTHD1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FTHD3_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FTHD3_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa1_msfg_fthd4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA1_MSFG_FTHD2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FTHD4_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA1_MSFG_FTHD4_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_dvs_bw_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CFG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_BW_TD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_BW_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_dvs_bw_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CFG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_BW_CTRL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_BW_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_dvs_bw_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_CFG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_BW_ONCE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DVS_BW_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OC_DEG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OC_WND_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OC_WND_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_OC_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OC_THD_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OC_THD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_ni_vpa2_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA2_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA2_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA2_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vpa2_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA2_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA2_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA2_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vpa2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VPA2_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VPA2_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_vpa2_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_VPA2_STB_MASK),
				  (unsigned int)(PMIC_DA_VPA2_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vpa2_dvs_transt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA2_DVS_TRANST_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA2_DVS_TRANST_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vpa2_dvs_bw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA2_DVS_BW_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA2_DVS_BW_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vpa2_dlc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BUCK_VPA2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA2_DLC_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA2_DLC_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_buck_vpa2_lp_dbg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_LP_DBG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_LP_DBG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_DBG2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_vosel_dlc011(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_DLC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_VOSEL_DLC011_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_VOSEL_DLC011_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_vosel_dlc111(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_DLC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_VOSEL_DLC111_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_VOSEL_DLC111_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_vosel_dlc001(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_DLC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_VOSEL_DLC001_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_VOSEL_DLC001_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_dlc_map_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_DLC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DLC_MAP_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DLC_MAP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_DLC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DLC_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_DLC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_EN_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rdelta2go(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RDELTA2GO_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RDELTA2GO_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_fdelta2go(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FDELTA2GO_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FDELTA2GO_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rrate0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_RRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE0_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rrate1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_RRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE1_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rrate2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_RRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE2_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rrate3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_RRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE3_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE3_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rrate4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_RRATE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE4_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE4_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rrate5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_RRATE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE5_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RRATE5_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rthd0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_RTHD0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RTHD0_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RTHD0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rthd1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_RTHD0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RTHD1_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RTHD1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rthd2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_RTHD1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RTHD2_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RTHD2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rthd3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_RTHD1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RTHD3_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RTHD3_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_rthd4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_RTHD2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RTHD4_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_RTHD4_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_frate0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_FRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE0_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_frate1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_FRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE1_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_frate2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_FRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE2_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_frate3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_FRATE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE3_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE3_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_frate4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_FRATE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE4_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE4_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_frate5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_FRATE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE5_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FRATE5_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_fthd0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_FTHD0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FTHD0_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FTHD0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_fthd1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_FTHD0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FTHD1_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FTHD1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_fthd2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_FTHD1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FTHD2_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FTHD2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_fthd3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_FTHD1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FTHD3_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FTHD3_SHIFT)
	    );

}

void mt6335_upmu_set_rg_buck_vpa2_msfg_fthd4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BUCK_VPA2_MSFG_FTHD2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FTHD4_MASK),
				    (unsigned int)(PMIC_RG_BUCK_VPA2_MSFG_FTHD4_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smps_testmode_b(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMPS_TESTMODE_B_MASK),
				    (unsigned int)(PMIC_RG_SMPS_TESTMODE_B_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_bursth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_BURSTH_MASK),
				    (unsigned int)(PMIC_RG_VPA1_BURSTH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_burstl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_BURSTL_MASK),
				    (unsigned int)(PMIC_RG_VPA1_BURSTL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VPA1_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VPA1_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_trim_ref(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_TRIM_REF_MASK),
				    (unsigned int)(PMIC_RG_VPA1_TRIM_REF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_bursth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_BURSTH_MASK),
				    (unsigned int)(PMIC_RG_VPA2_BURSTH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_burstl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_BURSTL_MASK),
				    (unsigned int)(PMIC_RG_VPA2_BURSTL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VPA2_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VPA2_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_trim_ref(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_TRIM_REF_MASK),
				    (unsigned int)(PMIC_RG_VPA2_TRIM_REF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VCORE_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VCORE_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VCORE_VSLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_VSLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_VSLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VMD1_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VMD1_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VMD1_VSLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VS1_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VS1_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VS1_VSLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VS2_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VS2_VSLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_TRIML_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_VSLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_VSLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VSLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_VSLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_VSLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_sleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_SLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VCORE_SLEEP_VOLTAGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_sleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_SLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_SLEEP_VOLTAGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_sleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_SLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_SLEEP_VOLTAGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_sleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_SLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VMD1_SLEEP_VOLTAGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_sleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_SLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VS1_SLEEP_VOLTAGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_sleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_SLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VS2_SLEEP_VOLTAGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_sleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SLEEP_VOLTAGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_sleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SLEEP_VOLTAGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SLEEP_VOLTAGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_sleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SLEEP_VOLTAGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_sleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SLEEP_VOLTAGE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_voutdet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VOUTDET_EN_MASK),
				    (unsigned int)(PMIC_RG_VOUTDET_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_smps_ivgd_det(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMPS_IVGD_DET_MASK),
				    (unsigned int)(PMIC_RG_SMPS_IVGD_DET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SMPS_ANA_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VS2_TRIMH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VCORE_MODESET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCORE_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_vrf18_sstart_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_VRF18_SSTART_EN_MASK),
				    (unsigned int)(PMIC_RG_VCORE_VRF18_SSTART_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCORE_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_rzsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_RZSEL0_MASK),
				    (unsigned int)(PMIC_RG_VCORE_RZSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_rzsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_RZSEL1_MASK),
				    (unsigned int)(PMIC_RG_VCORE_RZSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_ccsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_CCSEL0_MASK),
				    (unsigned int)(PMIC_RG_VCORE_CCSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_ccsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_CCSEL1_MASK),
				    (unsigned int)(PMIC_RG_VCORE_CCSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_CSL_MASK),
				    (unsigned int)(PMIC_RG_VCORE_CSL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_SLP_MASK),
				    (unsigned int)(PMIC_RG_VCORE_SLP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_adrc_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_ADRC_FEN_MASK),
				    (unsigned int)(PMIC_RG_VCORE_ADRC_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_vccap_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_VCCAP_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VCORE_VCCAP_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_vc_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_VC_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VCORE_VC_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_preoc_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_PREOC_SEL_MASK),
				    (unsigned int)(PMIC_RG_VCORE_PREOC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_pfmoc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_PFMOC_MASK),
				    (unsigned int)(PMIC_RG_VCORE_PFMOC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_CSR_MASK),
				    (unsigned int)(PMIC_RG_VCORE_CSR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_zxos_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_ZXOS_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VCORE_ZXOS_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_csm_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_CSM_N_MASK),
				    (unsigned int)(PMIC_RG_VCORE_CSM_N_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_csm_p(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_CSM_P_MASK),
				    (unsigned int)(PMIC_RG_VCORE_CSM_P_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_pfmsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_PFMSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VCORE_PFMSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_nlim_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_NLIM_GATING_MASK),
				    (unsigned int)(PMIC_RG_VCORE_NLIM_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_pwrsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_PWRSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VCORE_PWRSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_hs_vthdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_HS_VTHDET_MASK),
				    (unsigned int)(PMIC_RG_VCORE_HS_VTHDET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_pg_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_PG_GATING_MASK),
				    (unsigned int)(PMIC_RG_VCORE_PG_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_hs_onspeed_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_HS_ONSPEED_EH_MASK),
				    (unsigned int)(PMIC_RG_VCORE_HS_ONSPEED_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_nlim_trimming(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_NLIM_TRIMMING_MASK),
				    (unsigned int)(PMIC_RG_VCORE_NLIM_TRIMMING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_DLC_MASK),
				    (unsigned int)(PMIC_RG_VCORE_DLC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_dlc_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_DLC_N_MASK),
				    (unsigned int)(PMIC_RG_VCORE_DLC_N_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_pfm_rip(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_PFM_RIP_MASK),
				    (unsigned int)(PMIC_RG_VCORE_PFM_RIP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_tran_bst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_TRAN_BST_MASK),
				    (unsigned int)(PMIC_RG_VCORE_TRAN_BST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_dts_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_DTS_ENB_MASK),
				    (unsigned int)(PMIC_RG_VCORE_DTS_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_min_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_MIN_OFF_MASK),
				    (unsigned int)(PMIC_RG_VCORE_MIN_OFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_1p35up_sel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_1P35UP_SEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VCORE_1P35UP_SEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_dlc_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_DLC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCORE_DLC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_dlc_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_DLC_SEL_MASK),
				    (unsigned int)(PMIC_RG_VCORE_DLC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_src_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_SRC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCORE_SRC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_ugp_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_UGP_SR_MASK),
				    (unsigned int)(PMIC_RG_VCORE_UGP_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_lgn_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_LGN_SR_MASK),
				    (unsigned int)(PMIC_RG_VCORE_LGN_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_ugp_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_UGP_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VCORE_UGP_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_lgn_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_LGN_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VCORE_LGN_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_ugd_vthsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_UGD_VTHSEL_MASK),
				    (unsigned int)(PMIC_RG_VCORE_UGD_VTHSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_fnlx_sns(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_FNLX_SNS_MASK),
				    (unsigned int)(PMIC_RG_VCORE_FNLX_SNS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_vdiff_enlowiq(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_VDIFF_ENLOWIQ_MASK),
				    (unsigned int)(PMIC_RG_VCORE_VDIFF_ENLOWIQ_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_pfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_PFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VCORE_PFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_pwfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_PWFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VCORE_PWFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_cp_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_CP_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VCORE_CP_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_zx_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_ZX_GATING_MASK),
				    (unsigned int)(PMIC_RG_VCORE_ZX_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_RSV_MASK),
				    (unsigned int)(PMIC_RG_VCORE_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_preoc_trimming(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_PREOC_TRIMMING_MASK),
				    (unsigned int)(PMIC_RG_VCORE_PREOC_TRIMMING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_azc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_AZC_EN_MASK),
				    (unsigned int)(PMIC_RG_VCORE_AZC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_azc_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_AZC_DELAY_MASK),
				    (unsigned int)(PMIC_RG_VCORE_AZC_DELAY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcore_azc_hold_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VCORE_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_AZC_HOLD_ENB_MASK),
				    (unsigned int)(PMIC_RG_VCORE_AZC_HOLD_ENB_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_qi_vcore_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VCORE_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VCORE_OC_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_QI_VCORE_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_qi_vcore_dig_mon(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VCORE_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VCORE_DIG_MON_MASK),
				  (unsigned int)(PMIC_RGS_QI_VCORE_DIG_MON_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_vcore_enpwm_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VCORE_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_VCORE_ENPWM_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_VCORE_ENPWM_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_qi_vcore_preoc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VCORE_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VCORE_PREOC_MASK),
				  (unsigned int)(PMIC_RGS_QI_VCORE_PREOC_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vdram_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_MODESET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_vrf18_sstart_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_VRF18_SSTART_EN_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_VRF18_SSTART_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_rzsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_RZSEL0_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_RZSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_rzsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_RZSEL1_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_RZSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_ccsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_CCSEL0_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_CCSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_ccsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_CCSEL1_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_CCSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_CSL_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_CSL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_SLP_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_SLP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_adrc_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_ADRC_FEN_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_ADRC_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_vccap_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_VCCAP_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_VCCAP_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_vc_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_VC_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_VC_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_pfmoc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_PFMOC_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_PFMOC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_CSR_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_CSR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_zxos_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_ZXOS_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_ZXOS_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_pfmsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_PFMSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_PFMSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_nlim_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_NLIM_GATING_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_NLIM_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_pwrsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_PWRSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_PWRSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_hs_vthdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_HS_VTHDET_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_HS_VTHDET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_pg_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_PG_GATING_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_PG_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_hs_onspeed_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_HS_ONSPEED_EH_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_HS_ONSPEED_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_nlim_trimming(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_NLIM_TRIMMING_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_NLIM_TRIMMING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_DLC_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_DLC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_dlc_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_DLC_N_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_DLC_N_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_pfm_rip(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_PFM_RIP_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_PFM_RIP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_tran_bst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_TRAN_BST_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_TRAN_BST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_dts_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_DTS_ENB_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_DTS_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_min_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_MIN_OFF_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_MIN_OFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_1p35up_sel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_1P35UP_SEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_1P35UP_SEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_dlc_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_DLC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_DLC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_dlc_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_DLC_SEL_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_DLC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_src_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_SRC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_SRC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_ugp_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_UGP_SR_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_UGP_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_lgn_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_LGN_SR_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_LGN_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_ugp_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_UGP_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_UGP_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_lgn_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_LGN_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_LGN_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_ugd_vthsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_UGD_VTHSEL_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_UGD_VTHSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_fnlx_sns(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_FNLX_SNS_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_FNLX_SNS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_vdiff_enlowiq(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_VDIFF_ENLOWIQ_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_VDIFF_ENLOWIQ_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_pfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_PFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_PFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_pwfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_PWFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_PWFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_cp_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_CP_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_CP_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_zx_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_ZX_GATING_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_ZX_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_RSV_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_azc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_AZC_EN_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_AZC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_azc_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_AZC_DELAY_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_AZC_DELAY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vdram_azc_hold_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VDRAM_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_AZC_HOLD_ENB_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_AZC_HOLD_ENB_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_qi_vdram_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VDRAM_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VDRAM_OC_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_QI_VDRAM_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_qi_vdram_dig_mon(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VDRAM_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VDRAM_DIG_MON_MASK),
				  (unsigned int)(PMIC_RGS_QI_VDRAM_DIG_MON_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_vdram_enpwm_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VDRAM_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_VDRAM_ENPWM_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_VDRAM_ENPWM_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmodem_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_MODESET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_vrf18_sstart_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_VRF18_SSTART_EN_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_VRF18_SSTART_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_rzsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_RZSEL0_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_RZSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_rzsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_RZSEL1_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_RZSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_ccsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_CCSEL0_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_CCSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_ccsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_CCSEL1_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_CCSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_CSL_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_CSL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_SLP_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_SLP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_adrc_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_ADRC_FEN_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_ADRC_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_vccap_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_VCCAP_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_VCCAP_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_vc_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_VC_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_VC_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_pfmoc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_PFMOC_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_PFMOC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_CSR_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_CSR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_zxos_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_ZXOS_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_ZXOS_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_pfmsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_PFMSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_PFMSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_nlim_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_NLIM_GATING_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_NLIM_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_pwrsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_PWRSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_PWRSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_hs_vthdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_HS_VTHDET_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_HS_VTHDET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_pg_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_PG_GATING_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_PG_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_hs_onspeed_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_HS_ONSPEED_EH_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_HS_ONSPEED_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_nlim_trimming(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_NLIM_TRIMMING_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_NLIM_TRIMMING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_DLC_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_DLC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_dlc_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_DLC_N_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_DLC_N_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_pfm_rip(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_PFM_RIP_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_PFM_RIP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_tran_bst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_TRAN_BST_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_TRAN_BST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_dts_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_DTS_ENB_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_DTS_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_min_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_MIN_OFF_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_MIN_OFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_1p35up_sel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_1P35UP_SEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_1P35UP_SEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_dlc_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_DLC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_DLC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_dlc_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_DLC_SEL_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_DLC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_src_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_SRC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_SRC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_ugp_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_UGP_SR_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_UGP_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_lgn_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_LGN_SR_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_LGN_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_ugp_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_UGP_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_UGP_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_lgn_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_LGN_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_LGN_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_ugd_vthsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_UGD_VTHSEL_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_UGD_VTHSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_fnlx_sns(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_FNLX_SNS_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_FNLX_SNS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_vdiff_enlowiq(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_VDIFF_ENLOWIQ_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_VDIFF_ENLOWIQ_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_pfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_PFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_PFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_pwfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_PWFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_PWFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_cp_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_CP_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_CP_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_zx_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_ZX_GATING_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_ZX_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_RSV_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_azc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_AZC_EN_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_AZC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_azc_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_AZC_DELAY_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_AZC_DELAY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmodem_azc_hold_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMODEM_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMODEM_AZC_HOLD_ENB_MASK),
				    (unsigned int)(PMIC_RG_VMODEM_AZC_HOLD_ENB_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_qi_vmodem_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VMODEM_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VMODEM_OC_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_QI_VMODEM_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_qi_vmodem_dig_mon(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VMODEM_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VMODEM_DIG_MON_MASK),
				  (unsigned int)(PMIC_RGS_QI_VMODEM_DIG_MON_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_vmodem_enpwm_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VMODEM_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_VMODEM_ENPWM_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_VMODEM_ENPWM_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmd1_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VMD1_MODESET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VMD1_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_vrf18_sstart_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_VRF18_SSTART_EN_MASK),
				    (unsigned int)(PMIC_RG_VMD1_VRF18_SSTART_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VMD1_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_rzsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_RZSEL0_MASK),
				    (unsigned int)(PMIC_RG_VMD1_RZSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_rzsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_RZSEL1_MASK),
				    (unsigned int)(PMIC_RG_VMD1_RZSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_ccsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_CCSEL0_MASK),
				    (unsigned int)(PMIC_RG_VMD1_CCSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_ccsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_CCSEL1_MASK),
				    (unsigned int)(PMIC_RG_VMD1_CCSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_CSL_MASK),
				    (unsigned int)(PMIC_RG_VMD1_CSL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_SLP_MASK),
				    (unsigned int)(PMIC_RG_VMD1_SLP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_adrc_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_ADRC_FEN_MASK),
				    (unsigned int)(PMIC_RG_VMD1_ADRC_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_vccap_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_VCCAP_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VMD1_VCCAP_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_vc_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_VC_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VMD1_VC_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_pfmoc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_PFMOC_MASK),
				    (unsigned int)(PMIC_RG_VMD1_PFMOC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_CSR_MASK),
				    (unsigned int)(PMIC_RG_VMD1_CSR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_zxos_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_ZXOS_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VMD1_ZXOS_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_pfmsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_PFMSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VMD1_PFMSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_nlim_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_NLIM_GATING_MASK),
				    (unsigned int)(PMIC_RG_VMD1_NLIM_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_pwrsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_PWRSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VMD1_PWRSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_hs_vthdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_HS_VTHDET_MASK),
				    (unsigned int)(PMIC_RG_VMD1_HS_VTHDET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_pg_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_PG_GATING_MASK),
				    (unsigned int)(PMIC_RG_VMD1_PG_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_hs_onspeed_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_HS_ONSPEED_EH_MASK),
				    (unsigned int)(PMIC_RG_VMD1_HS_ONSPEED_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_nlim_trimming(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_NLIM_TRIMMING_MASK),
				    (unsigned int)(PMIC_RG_VMD1_NLIM_TRIMMING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_DLC_MASK),
				    (unsigned int)(PMIC_RG_VMD1_DLC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_dlc_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_DLC_N_MASK),
				    (unsigned int)(PMIC_RG_VMD1_DLC_N_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_pfm_rip(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_PFM_RIP_MASK),
				    (unsigned int)(PMIC_RG_VMD1_PFM_RIP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_tran_bst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_TRAN_BST_MASK),
				    (unsigned int)(PMIC_RG_VMD1_TRAN_BST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_dts_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_DTS_ENB_MASK),
				    (unsigned int)(PMIC_RG_VMD1_DTS_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_min_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_MIN_OFF_MASK),
				    (unsigned int)(PMIC_RG_VMD1_MIN_OFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_1p35up_sel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_1P35UP_SEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VMD1_1P35UP_SEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_dlc_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_DLC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VMD1_DLC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_dlc_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_DLC_SEL_MASK),
				    (unsigned int)(PMIC_RG_VMD1_DLC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_src_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_SRC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VMD1_SRC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_ugp_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_UGP_SR_MASK),
				    (unsigned int)(PMIC_RG_VMD1_UGP_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_lgn_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_LGN_SR_MASK),
				    (unsigned int)(PMIC_RG_VMD1_LGN_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_ugp_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_UGP_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VMD1_UGP_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_lgn_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_LGN_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VMD1_LGN_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_ugd_vthsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_UGD_VTHSEL_MASK),
				    (unsigned int)(PMIC_RG_VMD1_UGD_VTHSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_fnlx_sns(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_FNLX_SNS_MASK),
				    (unsigned int)(PMIC_RG_VMD1_FNLX_SNS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_vdiff_enlowiq(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_VDIFF_ENLOWIQ_MASK),
				    (unsigned int)(PMIC_RG_VMD1_VDIFF_ENLOWIQ_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_pfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_PFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VMD1_PFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_pwfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_PWFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VMD1_PWFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_cp_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_CP_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VMD1_CP_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_zx_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_ZX_GATING_MASK),
				    (unsigned int)(PMIC_RG_VMD1_ZX_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_RSV_MASK),
				    (unsigned int)(PMIC_RG_VMD1_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_azc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_AZC_EN_MASK),
				    (unsigned int)(PMIC_RG_VMD1_AZC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_azc_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_AZC_DELAY_MASK),
				    (unsigned int)(PMIC_RG_VMD1_AZC_DELAY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmd1_azc_hold_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VMD1_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMD1_AZC_HOLD_ENB_MASK),
				    (unsigned int)(PMIC_RG_VMD1_AZC_HOLD_ENB_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_qi_vmd1_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VMD1_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VMD1_OC_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_QI_VMD1_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_qi_vmd1_dig_mon(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VMD1_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VMD1_DIG_MON_MASK),
				  (unsigned int)(PMIC_RGS_QI_VMD1_DIG_MON_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_vmd1_enpwm_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VMD1_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_VMD1_ENPWM_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_VMD1_ENPWM_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vs1_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VS1_MODESET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VS1_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_vrf18_sstart_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_VRF18_SSTART_EN_MASK),
				    (unsigned int)(PMIC_RG_VS1_VRF18_SSTART_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VS1_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_rzsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_RZSEL0_MASK),
				    (unsigned int)(PMIC_RG_VS1_RZSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_rzsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_RZSEL1_MASK),
				    (unsigned int)(PMIC_RG_VS1_RZSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_ccsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_CCSEL0_MASK),
				    (unsigned int)(PMIC_RG_VS1_CCSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_ccsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_CCSEL1_MASK),
				    (unsigned int)(PMIC_RG_VS1_CCSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_CSL_MASK),
				    (unsigned int)(PMIC_RG_VS1_CSL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_SLP_MASK),
				    (unsigned int)(PMIC_RG_VS1_SLP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_adrc_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_ADRC_FEN_MASK),
				    (unsigned int)(PMIC_RG_VS1_ADRC_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_vccap_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_VCCAP_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VS1_VCCAP_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_vc_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_VC_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VS1_VC_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_pfmoc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_PFMOC_MASK),
				    (unsigned int)(PMIC_RG_VS1_PFMOC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_CSR_MASK),
				    (unsigned int)(PMIC_RG_VS1_CSR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_zxos_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_ZXOS_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VS1_ZXOS_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_pfmsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_PFMSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VS1_PFMSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_nlim_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_NLIM_GATING_MASK),
				    (unsigned int)(PMIC_RG_VS1_NLIM_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_pwrsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_PWRSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VS1_PWRSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_hs_vthdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_HS_VTHDET_MASK),
				    (unsigned int)(PMIC_RG_VS1_HS_VTHDET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_pg_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_PG_GATING_MASK),
				    (unsigned int)(PMIC_RG_VS1_PG_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_hs_onspeed_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_HS_ONSPEED_EH_MASK),
				    (unsigned int)(PMIC_RG_VS1_HS_ONSPEED_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_nlim_trimming(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_NLIM_TRIMMING_MASK),
				    (unsigned int)(PMIC_RG_VS1_NLIM_TRIMMING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_DLC_MASK),
				    (unsigned int)(PMIC_RG_VS1_DLC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_dlc_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_DLC_N_MASK),
				    (unsigned int)(PMIC_RG_VS1_DLC_N_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_pfm_rip(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_PFM_RIP_MASK),
				    (unsigned int)(PMIC_RG_VS1_PFM_RIP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_tran_bst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_TRAN_BST_MASK),
				    (unsigned int)(PMIC_RG_VS1_TRAN_BST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_dts_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_DTS_ENB_MASK),
				    (unsigned int)(PMIC_RG_VS1_DTS_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_min_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_MIN_OFF_MASK),
				    (unsigned int)(PMIC_RG_VS1_MIN_OFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_1p35up_sel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_1P35UP_SEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VS1_1P35UP_SEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_dlc_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_DLC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VS1_DLC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_dlc_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_DLC_SEL_MASK),
				    (unsigned int)(PMIC_RG_VS1_DLC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_src_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_SRC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VS1_SRC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_ugp_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_UGP_SR_MASK),
				    (unsigned int)(PMIC_RG_VS1_UGP_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_lgn_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_LGN_SR_MASK),
				    (unsigned int)(PMIC_RG_VS1_LGN_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_ugp_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_UGP_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VS1_UGP_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_lgn_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_LGN_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VS1_LGN_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_ugd_vthsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_UGD_VTHSEL_MASK),
				    (unsigned int)(PMIC_RG_VS1_UGD_VTHSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_fnlx_sns(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_FNLX_SNS_MASK),
				    (unsigned int)(PMIC_RG_VS1_FNLX_SNS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_vdiff_enlowiq(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_VDIFF_ENLOWIQ_MASK),
				    (unsigned int)(PMIC_RG_VS1_VDIFF_ENLOWIQ_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_pfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_PFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VS1_PFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_pwfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_PWFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VS1_PWFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_cp_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_CP_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VS1_CP_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_zx_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_ZX_GATING_MASK),
				    (unsigned int)(PMIC_RG_VS1_ZX_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_RSV_MASK),
				    (unsigned int)(PMIC_RG_VS1_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_azc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_AZC_EN_MASK),
				    (unsigned int)(PMIC_RG_VS1_AZC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_azc_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_AZC_DELAY_MASK),
				    (unsigned int)(PMIC_RG_VS1_AZC_DELAY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs1_azc_hold_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS1_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_AZC_HOLD_ENB_MASK),
				    (unsigned int)(PMIC_RG_VS1_AZC_HOLD_ENB_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_qi_vs1_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VS1_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VS1_OC_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_QI_VS1_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_qi_vs1_dig_mon(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VS1_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VS1_DIG_MON_MASK),
				  (unsigned int)(PMIC_RGS_QI_VS1_DIG_MON_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_vs1_enpwm_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VS1_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_VS1_ENPWM_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_VS1_ENPWM_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vs2_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VS2_MODESET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VS2_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_vrf18_sstart_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_VRF18_SSTART_EN_MASK),
				    (unsigned int)(PMIC_RG_VS2_VRF18_SSTART_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VS2_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_rzsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_RZSEL0_MASK),
				    (unsigned int)(PMIC_RG_VS2_RZSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_rzsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_RZSEL1_MASK),
				    (unsigned int)(PMIC_RG_VS2_RZSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_ccsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_CCSEL0_MASK),
				    (unsigned int)(PMIC_RG_VS2_CCSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_ccsel1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_CCSEL1_MASK),
				    (unsigned int)(PMIC_RG_VS2_CCSEL1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_CSL_MASK),
				    (unsigned int)(PMIC_RG_VS2_CSL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_SLP_MASK),
				    (unsigned int)(PMIC_RG_VS2_SLP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_adrc_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_ADRC_FEN_MASK),
				    (unsigned int)(PMIC_RG_VS2_ADRC_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_vccap_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_VCCAP_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VS2_VCCAP_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_vc_clamp_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_VC_CLAMP_FEN_MASK),
				    (unsigned int)(PMIC_RG_VS2_VC_CLAMP_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_pfmoc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_PFMOC_MASK),
				    (unsigned int)(PMIC_RG_VS2_PFMOC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_CSR_MASK),
				    (unsigned int)(PMIC_RG_VS2_CSR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_zxos_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_ZXOS_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VS2_ZXOS_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_pfmsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_PFMSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VS2_PFMSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_nlim_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_NLIM_GATING_MASK),
				    (unsigned int)(PMIC_RG_VS2_NLIM_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_pwrsr_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_PWRSR_EH_MASK),
				    (unsigned int)(PMIC_RG_VS2_PWRSR_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_hs_vthdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_HS_VTHDET_MASK),
				    (unsigned int)(PMIC_RG_VS2_HS_VTHDET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_pg_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_PG_GATING_MASK),
				    (unsigned int)(PMIC_RG_VS2_PG_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_hs_onspeed_eh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_HS_ONSPEED_EH_MASK),
				    (unsigned int)(PMIC_RG_VS2_HS_ONSPEED_EH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_nlim_trimming(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_NLIM_TRIMMING_MASK),
				    (unsigned int)(PMIC_RG_VS2_NLIM_TRIMMING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_DLC_MASK),
				    (unsigned int)(PMIC_RG_VS2_DLC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_dlc_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_DLC_N_MASK),
				    (unsigned int)(PMIC_RG_VS2_DLC_N_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_pfm_rip(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_PFM_RIP_MASK),
				    (unsigned int)(PMIC_RG_VS2_PFM_RIP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_tran_bst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_TRAN_BST_MASK),
				    (unsigned int)(PMIC_RG_VS2_TRAN_BST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_dts_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_DTS_ENB_MASK),
				    (unsigned int)(PMIC_RG_VS2_DTS_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_min_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_MIN_OFF_MASK),
				    (unsigned int)(PMIC_RG_VS2_MIN_OFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_1p35up_sel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_1P35UP_SEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VS2_1P35UP_SEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_dlc_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_DLC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VS2_DLC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_dlc_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_DLC_SEL_MASK),
				    (unsigned int)(PMIC_RG_VS2_DLC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_src_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_SRC_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VS2_SRC_AUTO_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_ugp_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_UGP_SR_MASK),
				    (unsigned int)(PMIC_RG_VS2_UGP_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_lgn_sr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_LGN_SR_MASK),
				    (unsigned int)(PMIC_RG_VS2_LGN_SR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_ugp_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_UGP_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VS2_UGP_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_lgn_sr_pfm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_LGN_SR_PFM_MASK),
				    (unsigned int)(PMIC_RG_VS2_LGN_SR_PFM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_ugd_vthsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_UGD_VTHSEL_MASK),
				    (unsigned int)(PMIC_RG_VS2_UGD_VTHSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_fnlx_sns(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_FNLX_SNS_MASK),
				    (unsigned int)(PMIC_RG_VS2_FNLX_SNS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_vdiff_enlowiq(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_VDIFF_ENLOWIQ_MASK),
				    (unsigned int)(PMIC_RG_VS2_VDIFF_ENLOWIQ_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_pfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_PFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VS2_PFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_pwfmoc_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_PWFMOC_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VS2_PWFMOC_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_cp_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_CP_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VS2_CP_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_zx_gating(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_ZX_GATING_MASK),
				    (unsigned int)(PMIC_RG_VS2_ZX_GATING_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_RSV_MASK),
				    (unsigned int)(PMIC_RG_VS2_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_azc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_AZC_EN_MASK),
				    (unsigned int)(PMIC_RG_VS2_AZC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_azc_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_AZC_DELAY_MASK),
				    (unsigned int)(PMIC_RG_VS2_AZC_DELAY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vs2_azc_hold_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VS2_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS2_AZC_HOLD_ENB_MASK),
				    (unsigned int)(PMIC_RG_VS2_AZC_HOLD_ENB_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_qi_vs2_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VS2_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VS2_OC_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_QI_VS2_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_qi_vs2_dig_mon(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VS2_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VS2_DIG_MON_MASK),
				  (unsigned int)(PMIC_RGS_QI_VS2_DIG_MON_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_vs2_enpwm_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VS2_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RGS_VS2_ENPWM_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_VS2_ENPWM_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vpa1_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VPA1_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VPA1_MODESET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_cc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_CC_MASK),
				    (unsigned int)(PMIC_RG_VPA1_CC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_CSR_MASK),
				    (unsigned int)(PMIC_RG_VPA1_CSR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_csmir(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_CSMIR_MASK),
				    (unsigned int)(PMIC_RG_VPA1_CSMIR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_CSL_MASK),
				    (unsigned int)(PMIC_RG_VPA1_CSL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_SLP_MASK),
				    (unsigned int)(PMIC_RG_VPA1_SLP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_azc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_AZC_EN_MASK),
				    (unsigned int)(PMIC_RG_VPA1_AZC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_cp_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_CP_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VPA1_CP_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_azc_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_AZC_DELAY_MASK),
				    (unsigned int)(PMIC_RG_VPA1_AZC_DELAY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_rzsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_RZSEL_MASK),
				    (unsigned int)(PMIC_RG_VPA1_RZSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_zxref(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_ZXREF_MASK),
				    (unsigned int)(PMIC_RG_VPA1_ZXREF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_nlim_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_NLIM_SEL_MASK),
				    (unsigned int)(PMIC_RG_VPA1_NLIM_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_hzp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_HZP_MASK),
				    (unsigned int)(PMIC_RG_VPA1_HZP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_bwex_gat(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_BWEX_GAT_MASK),
				    (unsigned int)(PMIC_RG_VPA1_BWEX_GAT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_slew(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_SLEW_MASK),
				    (unsigned int)(PMIC_RG_VPA1_SLEW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_slew_nmos(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_SLEW_NMOS_MASK),
				    (unsigned int)(PMIC_RG_VPA1_SLEW_NMOS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_min_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_MIN_ON_MASK),
				    (unsigned int)(PMIC_RG_VPA1_MIN_ON_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_vbat_del(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_VBAT_DEL_MASK),
				    (unsigned int)(PMIC_RG_VPA1_VBAT_DEL_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_vpa1_azc_vos_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VPA1_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RGS_VPA1_AZC_VOS_SEL_MASK),
				  (unsigned int)(PMIC_RGS_VPA1_AZC_VOS_SEL_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vpa1_min_pk(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_MIN_PK_MASK),
				    (unsigned int)(PMIC_RG_VPA1_MIN_PK_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_RSV1_MASK),
				    (unsigned int)(PMIC_RG_VPA1_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa1_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA1_RSV2_MASK),
				    (unsigned int)(PMIC_RG_VPA1_RSV2_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_qi_vpa1_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VPA1_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VPA1_OC_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_QI_VPA1_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_ni_vpa1_azc_zx(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VPA1_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RGS_NI_VPA1_AZC_ZX_MASK),
				  (unsigned int)(PMIC_RGS_NI_VPA1_AZC_ZX_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vpa2_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VPA2_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VPA2_MODESET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_cc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_CC_MASK),
				    (unsigned int)(PMIC_RG_VPA2_CC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_CSR_MASK),
				    (unsigned int)(PMIC_RG_VPA2_CSR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_csmir(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_CSMIR_MASK),
				    (unsigned int)(PMIC_RG_VPA2_CSMIR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_CSL_MASK),
				    (unsigned int)(PMIC_RG_VPA2_CSL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_SLP_MASK),
				    (unsigned int)(PMIC_RG_VPA2_SLP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_azc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_AZC_EN_MASK),
				    (unsigned int)(PMIC_RG_VPA2_AZC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_cp_fwupoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_CP_FWUPOFF_MASK),
				    (unsigned int)(PMIC_RG_VPA2_CP_FWUPOFF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_azc_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_AZC_DELAY_MASK),
				    (unsigned int)(PMIC_RG_VPA2_AZC_DELAY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_rzsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_RZSEL_MASK),
				    (unsigned int)(PMIC_RG_VPA2_RZSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_zxref(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_ZXREF_MASK),
				    (unsigned int)(PMIC_RG_VPA2_ZXREF_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_nlim_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_NLIM_SEL_MASK),
				    (unsigned int)(PMIC_RG_VPA2_NLIM_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_hzp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_HZP_MASK),
				    (unsigned int)(PMIC_RG_VPA2_HZP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_bwex_gat(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_BWEX_GAT_MASK),
				    (unsigned int)(PMIC_RG_VPA2_BWEX_GAT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_slew(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_SLEW_MASK),
				    (unsigned int)(PMIC_RG_VPA2_SLEW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_slew_nmos(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_SLEW_NMOS_MASK),
				    (unsigned int)(PMIC_RG_VPA2_SLEW_NMOS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_min_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_MIN_ON_MASK),
				    (unsigned int)(PMIC_RG_VPA2_MIN_ON_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_vbat_del(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_VBAT_DEL_MASK),
				    (unsigned int)(PMIC_RG_VPA2_VBAT_DEL_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_vpa2_azc_vos_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VPA2_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RGS_VPA2_AZC_VOS_SEL_MASK),
				  (unsigned int)(PMIC_RGS_VPA2_AZC_VOS_SEL_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vpa2_min_pk(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_MIN_PK_MASK),
				    (unsigned int)(PMIC_RG_VPA2_MIN_PK_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_RSV1_MASK),
				    (unsigned int)(PMIC_RG_VPA2_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vpa2_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VPA2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA2_RSV2_MASK),
				    (unsigned int)(PMIC_RG_VPA2_RSV2_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_qi_vpa2_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VPA2_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RGS_QI_VPA2_OC_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_QI_VPA2_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_ni_vpa2_azc_zx(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VPA2_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RGS_NI_VPA2_AZC_ZX_MASK),
				  (unsigned int)(PMIC_RGS_NI_VPA2_AZC_ZX_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_wdtdbg_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_WDTDBG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_WDTDBG_CLR_MASK),
				    (unsigned int)(PMIC_WDTDBG_CLR_SHIFT)
	    );

}

void mt6335_upmu_set_wdtdbg_con0_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_WDTDBG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_WDTDBG_CON0_RSV0_MASK),
				    (unsigned int)(PMIC_WDTDBG_CON0_RSV0_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_vcore_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON0),
				  (&val),
				  (unsigned int)(PMIC_VCORE_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VCORE_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vdram_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON0),
				  (&val),
				  (unsigned int)(PMIC_VDRAM_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VDRAM_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vmd1_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON1),
				  (&val),
				  (unsigned int)(PMIC_VMD1_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VMD1_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vmodem_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON1),
				  (&val),
				  (unsigned int)(PMIC_VMODEM_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VMODEM_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vs1_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON2),
				  (&val),
				  (unsigned int)(PMIC_VS1_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VS1_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vs2_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON2),
				  (&val),
				  (unsigned int)(PMIC_VS2_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VS2_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vpa1_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON3),
				  (&val),
				  (unsigned int)(PMIC_VPA1_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VPA1_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vpa2_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON3),
				  (&val),
				  (unsigned int)(PMIC_VPA2_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VPA2_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vsram_dvfs1_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON4),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_DVFS1_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VSRAM_DVFS1_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vsram_dvfs2_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON4),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_DVFS2_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VSRAM_DVFS2_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vsram_gpu_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON5),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_GPU_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VSRAM_GPU_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vsram_md_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON5),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_MD_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VSRAM_MD_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_vsram_core_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_WDTDBG_MON6),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_CORE_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VSRAM_CORE_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_a_trim_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINKA_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_A_TRIM_EN_MASK),
				    (unsigned int)(PMIC_RG_A_TRIM_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_a_trim_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINKA_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_A_TRIM_SEL_MASK),
				    (unsigned int)(PMIC_RG_A_TRIM_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_a_isinks_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINKA_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_A_ISINKS_RSV_MASK),
				    (unsigned int)(PMIC_RG_A_ISINKS_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_b_trim_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINKB_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_B_TRIM_EN_MASK),
				    (unsigned int)(PMIC_RG_B_TRIM_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_b_trim_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINKB_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_B_TRIM_SEL_MASK),
				    (unsigned int)(PMIC_RG_B_TRIM_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_b_isinks_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINKB_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_B_ISINKS_RSV_MASK),
				    (unsigned int)(PMIC_RG_B_ISINKS_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_isink_dim0_fsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK0_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM0_FSEL_MASK),
				    (unsigned int)(PMIC_ISINK_DIM0_FSEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink0_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK0_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK0_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK0_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_isink_dim0_duty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK0_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM0_DUTY_MASK),
				    (unsigned int)(PMIC_ISINK_DIM0_DUTY_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch0_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK0_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH0_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH0_STEP_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath0_tf2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK0_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TF2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TF2_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath0_tf1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK0_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TF1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TF1_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath0_tr2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK0_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TR2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TR2_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath0_tr1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK0_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TR1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TR1_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath0_toff_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK0_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TOFF_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TOFF_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath0_ton_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK0_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TON_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TON_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_dim1_fsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM1_FSEL_MASK),
				    (unsigned int)(PMIC_ISINK_DIM1_FSEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink1_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK1_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK1_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_isink_dim1_duty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM1_DUTY_MASK),
				    (unsigned int)(PMIC_ISINK_DIM1_DUTY_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch1_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH1_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH1_STEP_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath1_tf2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TF2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TF2_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath1_tf1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TF1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TF1_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath1_tr2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TR2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TR2_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath1_tr1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TR1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TR1_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath1_toff_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK1_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TOFF_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TOFF_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath1_ton_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK1_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TON_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TON_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_dim2_fsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM2_FSEL_MASK),
				    (unsigned int)(PMIC_ISINK_DIM2_FSEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink2_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK2_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK2_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_isink_dim2_duty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM2_DUTY_MASK),
				    (unsigned int)(PMIC_ISINK_DIM2_DUTY_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch2_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH2_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH2_STEP_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath2_tf2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK2_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH2_TF2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH2_TF2_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath2_tf1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK2_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH2_TF1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH2_TF1_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath2_tr2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK2_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH2_TR2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH2_TR2_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath2_tr1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK2_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH2_TR1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH2_TR1_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath2_toff_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK2_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH2_TOFF_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH2_TOFF_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath2_ton_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK2_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH2_TON_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH2_TON_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_dim3_fsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK3_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM3_FSEL_MASK),
				    (unsigned int)(PMIC_ISINK_DIM3_FSEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink3_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK3_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK3_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK3_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_isink_dim3_duty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK3_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM3_DUTY_MASK),
				    (unsigned int)(PMIC_ISINK_DIM3_DUTY_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch3_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK3_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH3_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH3_STEP_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath3_tf2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK3_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH3_TF2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH3_TF2_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath3_tf1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK3_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH3_TF1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH3_TF1_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath3_tr2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK3_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH3_TR2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH3_TR2_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath3_tr1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK3_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH3_TR1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH3_TR1_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath3_toff_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK3_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH3_TOFF_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH3_TOFF_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_isink_breath3_ton_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK3_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH3_TON_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH3_TON_SEL_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_ad_ni_b_isink1_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA1),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_B_ISINK1_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_B_ISINK1_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ad_ni_b_isink0_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA1),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_B_ISINK0_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_B_ISINK0_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ad_ni_a_isink1_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA1),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_A_ISINK1_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_A_ISINK1_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ad_ni_a_isink0_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA1),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_A_ISINK0_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_A_ISINK0_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_isink_phase0_dly_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_PHASE0_DLY_EN_MASK),
				    (unsigned int)(PMIC_ISINK_PHASE0_DLY_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_phase1_dly_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_PHASE1_DLY_EN_MASK),
				    (unsigned int)(PMIC_ISINK_PHASE1_DLY_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_phase2_dly_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_PHASE2_DLY_EN_MASK),
				    (unsigned int)(PMIC_ISINK_PHASE2_DLY_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_phase3_dly_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_PHASE3_DLY_EN_MASK),
				    (unsigned int)(PMIC_ISINK_PHASE3_DLY_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_phase_dly_tc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_PHASE_DLY_TC_MASK),
				    (unsigned int)(PMIC_ISINK_PHASE_DLY_TC_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop0_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP0_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP0_SW_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop1_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP1_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP1_SW_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop2_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP2_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP2_SW_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop3_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP3_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP3_SW_SHIFT)
	    );

}

void mt6335_upmu_set_isink_sfstr3_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR3_EN_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR3_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_sfstr3_tc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR3_TC_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR3_TC_SHIFT)
	    );

}

void mt6335_upmu_set_isink_sfstr2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR2_EN_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR2_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_sfstr2_tc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR2_TC_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR2_TC_SHIFT)
	    );

}

void mt6335_upmu_set_isink_sfstr1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR1_EN_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR1_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_sfstr1_tc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR1_TC_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR1_TC_SHIFT)
	    );

}

void mt6335_upmu_set_isink_sfstr0_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR0_EN_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR0_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_sfstr0_tc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR0_TC_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR0_TC_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch0_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH0_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH0_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH1_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH1_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH2_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH2_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch3_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH3_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH3_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop0_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP0_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP0_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP1_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP1_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP2_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP2_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop3_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP3_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP3_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch0_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH0_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH0_BIAS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch1_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH1_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH1_BIAS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch2_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH2_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH2_BIAS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch3_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH3_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH3_BIAS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_MODE_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_RSV_MASK),
				    (unsigned int)(PMIC_ISINK_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch3_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_MODE_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH3_MODE_MASK),
				    (unsigned int)(PMIC_ISINK_CH3_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch2_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_MODE_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH2_MODE_MASK),
				    (unsigned int)(PMIC_ISINK_CH2_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch1_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_MODE_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH1_MODE_MASK),
				    (unsigned int)(PMIC_ISINK_CH1_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch0_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_MODE_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH0_MODE_MASK),
				    (unsigned int)(PMIC_ISINK_CH0_MODE_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_a_isinks_ch0_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_A_ISINKS_CH0_STEP_MASK),
				  (unsigned int)(PMIC_DA_QI_A_ISINKS_CH0_STEP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_a_isinks_ch1_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_A_ISINKS_CH1_STEP_MASK),
				  (unsigned int)(PMIC_DA_QI_A_ISINKS_CH1_STEP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_b_isinks_ch0_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_B_ISINKS_CH0_STEP_MASK),
				  (unsigned int)(PMIC_DA_QI_B_ISINKS_CH0_STEP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_b_isinks_ch1_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_B_ISINKS_CH1_STEP_MASK),
				  (unsigned int)(PMIC_DA_QI_B_ISINKS_CH1_STEP_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_isink4_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK4_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK4_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK4_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_isink4_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK4_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK4_RSV0_MASK),
				    (unsigned int)(PMIC_ISINK4_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch4_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK4_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH4_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH4_STEP_SHIFT)
	    );

}

void mt6335_upmu_set_isink5_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK5_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK5_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK5_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_isink5_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK5_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK5_RSV0_MASK),
				    (unsigned int)(PMIC_ISINK5_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch5_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK5_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH5_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH5_STEP_SHIFT)
	    );

}

void mt6335_upmu_set_isink6_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK6_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK6_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK6_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_isink6_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK6_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK6_RSV0_MASK),
				    (unsigned int)(PMIC_ISINK6_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch6_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK6_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH6_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH6_STEP_SHIFT)
	    );

}

void mt6335_upmu_set_isink7_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK7_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK7_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK7_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_isink7_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK7_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK7_RSV0_MASK),
				    (unsigned int)(PMIC_ISINK7_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch7_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK7_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH7_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH7_STEP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_ad_ni_b_isink3_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA1_SMPL),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_B_ISINK3_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_B_ISINK3_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ad_ni_b_isink2_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA1_SMPL),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_B_ISINK2_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_B_ISINK2_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ad_ni_a_isink3_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA1_SMPL),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_A_ISINK3_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_A_ISINK3_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ad_ni_a_isink2_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_ISINK_ANA1_SMPL),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_A_ISINK2_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_A_ISINK2_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_isink_chop7_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP7_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP7_SW_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop6_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP6_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP6_SW_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop5_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP5_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP5_SW_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop4_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_PHASE_DLY_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP4_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP4_SW_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch7_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH7_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH7_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch6_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH6_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH6_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch5_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH5_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH5_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch4_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH4_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH4_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop7_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP7_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP7_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop6_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP6_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP6_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop5_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP5_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP5_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_chop4_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP4_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP4_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch7_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH7_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH7_BIAS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch6_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH6_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH6_BIAS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch5_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH5_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH5_BIAS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_isink_ch4_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH4_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH4_BIAS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO28_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VIO28_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO28_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO28_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO28_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO28_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VIO28_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VIO28_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VIO28_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VIO28_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VIO28_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vio28_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIO28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO28_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO28_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vio28_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VIO28_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vio28_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIO28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO28_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO28_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vio28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIO28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO28_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO28_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vio28_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO28_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vio28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIO28_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO28_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vio28_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VIO28_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vio28_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIO28_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO28_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO28_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vio18_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO18_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VIO18_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO18_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO18_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO18_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO18_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VIO18_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VIO18_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VIO18_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VIO18_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VIO18_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vio18_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIO18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO18_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO18_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vio18_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VIO18_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vio18_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIO18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO18_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO18_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vio18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIO18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO18_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO18_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vio18_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO18_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vio18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIO18_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO18_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vio18_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VIO18_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vio18_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIO18_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO18_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO18_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vufs18_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vufs18_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VUFS18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUFS18_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VUFS18_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vufs18_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vufs18_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VUFS18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUFS18_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VUFS18_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vufs18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VUFS18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUFS18_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VUFS18_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vufs18_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vufs18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VUFS18_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUFS18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VUFS18_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vufs18_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vufs18_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VUFS18_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUFS18_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VUFS18_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_va10_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VA10_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VA10_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA10_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA10_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA10_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA10_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VA10_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VA10_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VA10_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VA10_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VA10_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_va10_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA10_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA10_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VA10_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_va10_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VA10_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_va10_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA10_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA10_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VA10_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_va10_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA10_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA10_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VA10_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_va10_wk_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_WK_TD_MASK),
				    (unsigned int)(PMIC_RG_VA10_WK_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_slp_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_SLP_TD_MASK),
				    (unsigned int)(PMIC_RG_VA10_SLP_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VA10_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_va10_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA10_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA10_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VA10_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_va10_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VA10_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_va10_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA10_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA10_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VA10_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_va12_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VA12_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VA12_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA12_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA12_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA12_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA12_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VA12_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VA12_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VA12_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VA12_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VA12_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_va12_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA12_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA12_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VA12_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_va12_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VA12_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_va12_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA12_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA12_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VA12_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_va12_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA12_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA12_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VA12_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_va12_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VA12_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_va12_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA12_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA12_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VA12_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_va12_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VA12_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_va12_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA12_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA12_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VA12_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_va18_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VA18_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VA18_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA18_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA18_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA18_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VA18_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VA18_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VA18_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VA18_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VA18_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VA18_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_va18_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA18_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VA18_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_va18_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VA18_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_va18_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA18_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VA18_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_va18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA18_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VA18_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_va18_auxadc_pwdb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_AUXADC_PWDB_EN_MASK),
				    (unsigned int)(PMIC_RG_VA18_AUXADC_PWDB_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VA18_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_va18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VA18_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VA18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VA18_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vusb33_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vusb33_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VUSB33_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUSB33_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VUSB33_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vusb33_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vusb33_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VUSB33_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUSB33_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VUSB33_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vusb33_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VUSB33_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUSB33_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VUSB33_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vusb33_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vusb33_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VUSB33_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUSB33_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VUSB33_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vemc_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VEMC_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VEMC_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VEMC_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VEMC_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VEMC_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VEMC_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VEMC_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VEMC_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VEMC_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VEMC_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VEMC_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vemc_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VEMC_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEMC_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VEMC_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vemc_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VEMC_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vemc_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VEMC_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEMC_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VEMC_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vemc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VEMC_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEMC_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VEMC_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vemc_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VEMC_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vemc_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VEMC_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEMC_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VEMC_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vemc_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VEMC_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vemc_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VEMC_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEMC_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VEMC_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vxo22_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VXO22_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VXO22_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VXO22_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VXO22_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VXO22_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VXO22_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VXO22_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VXO22_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VXO22_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VXO22_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VXO22_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vxo22_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VXO22_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VXO22_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VXO22_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vxo22_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VXO22_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vxo22_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VXO22_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VXO22_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VXO22_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vxo22_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VXO22_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VXO22_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VXO22_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vxo22_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VXO22_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vxo22_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VXO22_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VXO22_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VXO22_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vefuse_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vefuse_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VEFUSE_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEFUSE_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VEFUSE_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vefuse_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vefuse_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VEFUSE_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEFUSE_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VEFUSE_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vefuse_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VEFUSE_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEFUSE_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VEFUSE_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vefuse_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vefuse_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VEFUSE_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEFUSE_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VEFUSE_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vefuse_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vefuse_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VEFUSE_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEFUSE_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VEFUSE_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsim1_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsim1_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSIM1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM1_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM1_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsim1_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsim1_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSIM1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM1_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM1_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsim1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSIM1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM1_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM1_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsim1_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsim1_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSIM1_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM1_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM1_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsim1_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsim1_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSIM1_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM1_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM1_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsim2_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsim2_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSIM2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM2_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM2_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsim2_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsim2_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSIM2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM2_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM2_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsim2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSIM2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM2_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM2_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsim2_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsim2_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSIM2_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM2_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM2_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsim2_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsim2_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSIM2_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM2_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM2_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamaf_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamaf_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMAF_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMAF_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMAF_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamaf_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamaf_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMAF_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMAF_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMAF_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcamaf_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMAF_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMAF_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMAF_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamaf_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamaf_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMAF_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMAF_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMAF_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamaf_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamaf_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMAF_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMAF_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMAF_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vtouch_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vtouch_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VTOUCH_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTOUCH_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VTOUCH_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vtouch_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vtouch_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VTOUCH_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTOUCH_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VTOUCH_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vtouch_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VTOUCH_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTOUCH_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VTOUCH_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vtouch_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vtouch_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VTOUCH_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTOUCH_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VTOUCH_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vtouch_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vtouch_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VTOUCH_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTOUCH_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VTOUCH_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamd1_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamd1_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMD1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD1_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD1_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamd1_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamd1_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMD1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD1_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD1_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcamd1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMD1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD1_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD1_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamd1_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamd1_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMD1_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD1_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD1_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamd1_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamd1_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMD1_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD1_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD1_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamd2_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamd2_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMD2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD2_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD2_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamd2_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamd2_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMD2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD2_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD2_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcamd2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMD2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD2_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD2_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamd2_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamd2_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMD2_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD2_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD2_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamd2_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamd2_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMD2_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD2_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD2_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamio_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamio_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMIO_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamio_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamio_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMIO_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcamio_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMIO_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamio_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamio_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMIO_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcamio_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcamio_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMIO_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmipi_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmipi_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMIPI_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMIPI_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VMIPI_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmipi_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmipi_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMIPI_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMIPI_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VMIPI_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vmipi_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMIPI_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMIPI_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMIPI_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmipi_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmipi_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMIPI_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMIPI_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMIPI_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmipi_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmipi_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMIPI_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMIPI_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VMIPI_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vgp3_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VGP3_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VGP3_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VGP3_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VGP3_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VGP3_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VGP3_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VGP3_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VGP3_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VGP3_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VGP3_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VGP3_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vgp3_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VGP3_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VGP3_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VGP3_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vgp3_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VGP3_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vgp3_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VGP3_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VGP3_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VGP3_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vgp3_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VGP3_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VGP3_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VGP3_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vgp3_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VGP3_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vgp3_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VGP3_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VGP3_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VGP3_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vgp3_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VGP3_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vgp3_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VGP3_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VGP3_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VGP3_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcn33_sw_en_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_CON0_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_SW_EN_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN33_SW_EN_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_sw_lp_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_CON0_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_SW_LP_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN33_SW_LP_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_sw_op_en_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_EN_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_SW_OP_EN_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN33_SW_OP_EN_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw0_op_en_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_EN_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW0_OP_EN_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW0_OP_EN_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw1_op_en_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_EN_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW1_OP_EN_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW1_OP_EN_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw2_op_en_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_EN_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW2_OP_EN_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW2_OP_EN_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw0_op_cfg_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_CFG_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW0_OP_CFG_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW0_OP_CFG_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw1_op_cfg_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_CFG_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW1_OP_CFG_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW1_OP_CFG_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw2_op_cfg_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_CFG_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW2_OP_CFG_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW2_OP_CFG_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_go_on_op_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_CFG_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_GO_ON_OP_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN33_GO_ON_OP_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_go_lp_op_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_CFG_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_GO_LP_OP_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN33_GO_LP_OP_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_sw_en_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_CON0_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_SW_EN_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN33_SW_EN_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_sw_lp_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_CON0_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_SW_LP_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN33_SW_LP_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_sw_op_en_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_EN_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_SW_OP_EN_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN33_SW_OP_EN_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw0_op_en_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_EN_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW0_OP_EN_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW0_OP_EN_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw1_op_en_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_EN_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW1_OP_EN_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW1_OP_EN_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw2_op_en_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_EN_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW2_OP_EN_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW2_OP_EN_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw0_op_cfg_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_CFG_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW0_OP_CFG_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW0_OP_CFG_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw1_op_cfg_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_CFG_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW1_OP_CFG_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW1_OP_CFG_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_hw2_op_cfg_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_CFG_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_HW2_OP_CFG_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN33_HW2_OP_CFG_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_go_on_op_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_CFG_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_GO_ON_OP_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN33_GO_ON_OP_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_go_lp_op_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_OP_CFG_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_GO_LP_OP_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN33_GO_LP_OP_WIFI_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcn33_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN33_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN33_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN33_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcn33_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VCN33_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcn33_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN33_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN33_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN33_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcn33_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN33_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN33_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN33_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcn33_wifi_en(void)
{
	return mt6335_upmu_get_da_qi_vcn33_en();
}

unsigned int mt6335_upmu_get_da_qi_vcn33_bt_en(void)
{
	return mt6335_upmu_get_da_qi_vcn33_en();
}

void mt6335_upmu_set_rg_vcn33_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN33_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcn33_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN33_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN33_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN33_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcn33_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VCN33_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcn33_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN33_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN33_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN33_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcn18_sw_en_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_CON0_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_SW_EN_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN18_SW_EN_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_sw_lp_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_CON0_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_SW_LP_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN18_SW_LP_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_sw_op_en_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_EN_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_SW_OP_EN_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN18_SW_OP_EN_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw0_op_en_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_EN_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW0_OP_EN_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW0_OP_EN_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw1_op_en_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_EN_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW1_OP_EN_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW1_OP_EN_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw2_op_en_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_EN_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW2_OP_EN_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW2_OP_EN_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw0_op_cfg_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_CFG_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW0_OP_CFG_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW0_OP_CFG_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw1_op_cfg_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_CFG_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW1_OP_CFG_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW1_OP_CFG_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw2_op_cfg_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_CFG_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW2_OP_CFG_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW2_OP_CFG_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_go_on_op_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_CFG_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_GO_ON_OP_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN18_GO_ON_OP_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_go_lp_op_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_CFG_BT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_GO_LP_OP_BT_MASK),
				    (unsigned int)(PMIC_RG_VCN18_GO_LP_OP_BT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_sw_en_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_CON0_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_SW_EN_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN18_SW_EN_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_sw_lp_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_CON0_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_SW_LP_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN18_SW_LP_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_sw_op_en_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_EN_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_SW_OP_EN_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN18_SW_OP_EN_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw0_op_en_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_EN_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW0_OP_EN_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW0_OP_EN_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw1_op_en_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_EN_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW1_OP_EN_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW1_OP_EN_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw2_op_en_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_EN_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW2_OP_EN_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW2_OP_EN_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw0_op_cfg_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_CFG_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW0_OP_CFG_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW0_OP_CFG_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw1_op_cfg_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_CFG_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW1_OP_CFG_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW1_OP_CFG_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_hw2_op_cfg_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_CFG_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_HW2_OP_CFG_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN18_HW2_OP_CFG_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_go_on_op_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_CFG_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_GO_ON_OP_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN18_GO_ON_OP_WIFI_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_go_lp_op_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_OP_CFG_WIFI),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_GO_LP_OP_WIFI_MASK),
				    (unsigned int)(PMIC_RG_VCN18_GO_LP_OP_WIFI_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcn18_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN18_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN18_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcn18_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VCN18_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcn18_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN18_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN18_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcn18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN18_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN18_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN18_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcn18_wifi_en(void)
{
	return mt6335_upmu_get_da_qi_vcn18_en();
}

unsigned int mt6335_upmu_get_da_qi_vcn18_bt_en(void)
{
	return mt6335_upmu_get_da_qi_vcn18_en();
}

void mt6335_upmu_set_rg_vcn18_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN18_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcn18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN18_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN18_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcn18_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VCN18_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcn18_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN18_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN18_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN18_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcn28_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN28_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VCN28_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN28_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN28_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN28_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN28_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_hw3_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_HW3_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN28_HW3_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCN28_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCN28_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCN28_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_hw3_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_HW3_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VCN28_HW3_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VCN28_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VCN28_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcn28_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN28_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN28_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcn28_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VCN28_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcn28_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN28_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN28_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcn28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN28_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN28_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcn28_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN28_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcn28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCN28_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN28_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vibr_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VIBR_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VIBR_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIBR_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIBR_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIBR_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VIBR_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VIBR_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VIBR_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VIBR_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VIBR_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VIBR_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vibr_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIBR_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIBR_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VIBR_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vibr_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VIBR_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vibr_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIBR_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIBR_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VIBR_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vibr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIBR_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIBR_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIBR_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vibr_ther_sdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_THER_SDN_EN_MASK),
				    (unsigned int)(PMIC_RG_VIBR_THER_SDN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VIBR_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vibr_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VIBR_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIBR_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIBR_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vbif28_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vbif28_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VBIF28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VBIF28_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VBIF28_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vbif28_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vbif28_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VBIF28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VBIF28_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VBIF28_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vbif28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VBIF28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VBIF28_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VBIF28_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vbif28_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vbif28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VBIF28_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VBIF28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VBIF28_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vfe28_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VFE28_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VFE28_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VFE28_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VFE28_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VFE28_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VFE28_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VFE28_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VFE28_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VFE28_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VFE28_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VFE28_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vfe28_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VFE28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VFE28_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VFE28_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vfe28_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VFE28_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vfe28_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VFE28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VFE28_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VFE28_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vfe28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VFE28_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VFE28_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VFE28_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vfe28_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VFE28_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vfe28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VFE28_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VFE28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VFE28_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmch_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VMCH_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VMCH_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMCH_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMCH_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMCH_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMCH_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VMCH_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VMCH_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VMCH_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VMCH_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VMCH_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmch_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMCH_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMCH_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VMCH_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmch_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VMCH_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmch_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMCH_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMCH_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VMCH_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vmch_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMCH_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMCH_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMCH_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmch_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VMCH_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmch_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMCH_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMCH_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMCH_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmch_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VMCH_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmch_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMCH_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMCH_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VMCH_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmc_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VMC_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VMC_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMC_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMC_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMC_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VMC_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VMC_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VMC_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VMC_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VMC_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VMC_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmc_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMC_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMC_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VMC_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmc_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VMC_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmc_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMC_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMC_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VMC_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vmc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMC_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMC_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMC_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmc_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VMC_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmc_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMC_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMC_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMC_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vmc_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VMC_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vmc_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VMC_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMC_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VMC_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf18_1_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf18_1_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF18_1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_1_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_1_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf18_1_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf18_1_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF18_1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_1_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_1_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vrf18_1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF18_1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_1_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_1_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf18_1_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf18_1_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF18_1_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_1_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_1_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf18_1_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf18_1_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF18_1_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_1_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_1_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf18_2_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf18_2_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF18_2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_2_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_2_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf18_2_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf18_2_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF18_2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_2_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_2_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vrf18_2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF18_2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_2_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_2_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf18_2_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf18_2_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF18_2_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_2_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_2_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf18_2_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf18_2_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF18_2_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_2_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_2_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf12_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VRF12_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VRF12_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VRF12_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VRF12_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VRF12_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VRF12_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf12_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF12_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF12_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF12_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf12_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VRF12_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf12_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF12_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF12_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF12_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vrf12_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF12_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF12_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF12_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf12_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf12_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF12_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF12_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF12_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vrf12_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VRF12_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrf12_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VRF12_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF12_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF12_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcama1_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama1_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama1_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama1_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama1_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcama1_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMA1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA1_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA1_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcama1_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcama1_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMA1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA1_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA1_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcama1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMA1_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA1_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA1_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcama1_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcama1_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMA1_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA1_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA1_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcama2_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama2_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama2_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama2_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama2_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcama2_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMA2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA2_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA2_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcama2_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_STBTD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcama2_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMA2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA2_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA2_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vcama2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMA2_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA2_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA2_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcama2_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA2_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vcama2_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VCAMA2_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA2_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA2_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_ldo_manual_ofs_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_MANUAL_OFS_SEL_MASK),
				    (unsigned int)(PMIC_RG_LDO_MANUAL_OFS_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_manual_ofs_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_MANUAL_OFS_EN_MASK),
				    (unsigned int)(PMIC_RG_LDO_MANUAL_OFS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_cali_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_CALI_RSV_MASK),
				    (unsigned int)(PMIC_RG_LDO_CALI_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_cali_mode_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_CALI_MODE_SEL_MASK),
				    (unsigned int)(PMIC_RG_LDO_CALI_MODE_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_manual_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_MANUAL_MODE_MASK),
				    (unsigned int)(PMIC_RG_LDO_MANUAL_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_auto_start(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_AUTO_START_MASK),
				    (unsigned int)(PMIC_RG_LDO_AUTO_START_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_cali_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_K_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_CALI_CLR_MASK),
				    (unsigned int)(PMIC_RG_LDO_CALI_CLR_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_ldo_cali_inc_count(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_K_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_CALI_INC_COUNT_MASK),
				  (unsigned int)(PMIC_LDO_CALI_INC_COUNT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ldo_k_start(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_K_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_K_START_MASK),
				  (unsigned int)(PMIC_LDO_K_START_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ldo_cali_done(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_K_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_CALI_DONE_MASK),
				  (unsigned int)(PMIC_LDO_CALI_DONE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ldo_cali_cnt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_K_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_CALI_CNT_MASK),
				  (unsigned int)(PMIC_LDO_CALI_CNT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ldo_cali_efuse_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_K_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_CALI_EFUSE_EN_MASK),
				  (unsigned int)(PMIC_LDO_CALI_EFUSE_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vio18_ofs_cal_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_K_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO18_OFS_CAL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO18_OFS_CAL_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ad_qi_vio18_cal_indi(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_K_CON2),
				  (&val),
				  (unsigned int)(PMIC_AD_QI_VIO18_CAL_INDI_MASK),
				  (unsigned int)(PMIC_AD_QI_VIO18_CAL_INDI_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vio18_ofs_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_K_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO18_OFS_SEL_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO18_OFS_SEL_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_ldo_degtd_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_OCFB0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_DEGTD_SEL_MASK),
				    (unsigned int)(PMIC_LDO_DEGTD_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrtc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VRTC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRTC_EN_MASK),
				    (unsigned int)(PMIC_RG_VRTC_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vrtc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_VRTC_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRTC_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRTC_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_ldo_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_RSV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_RSV1_MASK),
				    (unsigned int)(PMIC_RG_LDO_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_RSV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_RSV0_MASK),
				    (unsigned int)(PMIC_RG_LDO_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ldo_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_RSV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LDO_RSV2_MASK),
				    (unsigned int)(PMIC_RG_LDO_RSV2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_VOSEL_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_dvfs1_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS1_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS1_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_dvfs1_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_STBTD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_dvfs1_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CON4),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS1_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS1_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_dvfs1_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_dvfs1_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CON5),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS1_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS1_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_dvfs1_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS1_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS1_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_dvfs1_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS1_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS1_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsram_dvfs1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS1_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS1_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsram_dvfs1_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS1_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS1_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_dvfs1_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS1_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS1_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_dvfs1_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS1_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS1_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_dvfs1_track_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS1_TRACK_NDIS_EN_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS1_TRACK_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_dvfs2_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_VOSEL_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_dvfs2_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS2_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS2_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_dvfs2_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_STBTD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_dvfs2_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CON4),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS2_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS2_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_dvfs2_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_dvfs2_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CON5),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS2_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS2_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_dvfs2_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS2_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS2_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_dvfs2_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS2_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS2_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsram_dvfs2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS2_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS2_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsram_dvfs2_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS2_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_DVFS2_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_dvfs2_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS2_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS2_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_dvfs2_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS2_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS2_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_dvfs2_track_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS2_TRACK_NDIS_EN_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_DVFS2_TRACK_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_vcore_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_vcore_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VCORE_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VCORE_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_vcore_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_STBTD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_vcore_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CON4),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VCORE_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VCORE_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_vcore_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_vcore_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CON5),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VCORE_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VCORE_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vcore_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VCORE_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VCORE_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vcore_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VCORE_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VCORE_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsram_vcore_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VCORE_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VCORE_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsram_vcore_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VCORE_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VCORE_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vcore_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VCORE_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VCORE_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vcore_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VCORE_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VCORE_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vcore_track_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VCORE_TRACK_NDIS_EN_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VCORE_TRACK_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_vgpu_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_VOSEL_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_vgpu_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VGPU_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VGPU_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_vgpu_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_STBTD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_vgpu_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CON4),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VGPU_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VGPU_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_vgpu_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_vgpu_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CON5),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VGPU_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VGPU_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vgpu_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VGPU_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VGPU_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vgpu_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VGPU_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VGPU_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsram_vgpu_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VGPU_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VGPU_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsram_vgpu_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VGPU_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VGPU_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vgpu_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VGPU_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VGPU_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vgpu_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VGPU_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VGPU_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vgpu_track_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VGPU_TRACK_NDIS_EN_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VGPU_TRACK_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_vmd_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_sw_lp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SW_LP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SW_LP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_VOSEL_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SFCHG_FRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SFCHG_FEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SFCHG_RRATE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CFG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SFCHG_REN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_dvs_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_DVS_TRANS_TD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_DVS_TRANS_TD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_dvs_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_DVS_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_DVS_TRANS_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_dvs_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CFG1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_DVS_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_DVS_TRANS_ONCE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_sw_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SW_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SW_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_hw0_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW0_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW0_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_hw1_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW1_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW1_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_hw2_op_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_OP_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW2_OP_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW2_OP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_hw0_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW0_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW0_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_hw1_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW1_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW1_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_hw2_op_cfg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW2_OP_CFG_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_HW2_OP_CFG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_go_on_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_GO_ON_OP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_GO_ON_OP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_go_lp_op(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_OP_CFG),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_GO_LP_OP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_GO_LP_OP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_vmd_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CON3),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VMD_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VMD_MODE_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_vmd_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_STBTD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_STBTD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_OCFB_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_vmd_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CON4),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VMD_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VMD_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_vmd_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_vsram_vmd_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CON5),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VMD_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VMD_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vmd_vosel_gray(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VMD_VOSEL_GRAY_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VMD_VOSEL_GRAY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vmd_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_DBG0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VMD_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VMD_VOSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsram_vmd_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VMD_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VMD_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_vsram_vmd_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VMD_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_VMD_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vmd_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VMD_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VMD_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vmd_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VMD_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VMD_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_ni_vsram_vmd_track_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_DBG1),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VMD_TRACK_NDIS_EN_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_VMD_TRACK_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vsram_vcore_track_sleep_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_TRACKING_CON0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_VSRAM_VCORE_TRACK_SLEEP_CTRL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_TRACK_SLEEP_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_track_on_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_TRACKING_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_TRACK_ON_CTRL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_TRACK_ON_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_track_vbuck_on_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_TRACKING_CON0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_RG_VSRAM_VCORE_TRACK_VBUCK_ON_CTRL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_TRACK_VBUCK_ON_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_vosel_delta(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_TRACKING_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_DELTA_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_DELTA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_vosel_offset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_TRACKING_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_OFFSET_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_OFFSET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_vosel_on_lb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_TRACKING_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_ON_LB_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_ON_LB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_vosel_on_hb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_TRACKING_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_ON_HB_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_ON_HB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_vosel_sleep_lb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_TRACKING_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_SLEEP_LB_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_VOSEL_SLEEP_LB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_dcm_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_DCM),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DCM_MODE_MASK),
				    (unsigned int)(PMIC_RG_DCM_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VIO28_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO28_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VIO28_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VIO18_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO18_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIO18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VIO18_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUFS18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VA10_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VA10_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA10_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VA10_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VA12_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VA12_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA12_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VA12_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VA18_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VA18_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VA18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VA18_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VUSB33_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VEMC_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VEMC_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEMC_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VEMC_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VXO22_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VXO22_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VXO22_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VXO22_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VEFUSE_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSIM2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMAF_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VTOUCH_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMD2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMIO_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMIPI_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VGP3_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VGP3_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VGP3_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VGP3_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCN33_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN33_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN33_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VCN33_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCN18_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN18_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN18_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VCN18_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCN28_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN28_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCN28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VCN28_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VIBR_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VIBR_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VIBR_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VIBR_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VBIF28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VFE28_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VFE28_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VFE28_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VFE28_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VMCH_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VMCH_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMCH_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VMCH_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VMC_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VMC_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VMC_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VMC_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF18_2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VRF12_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VRF12_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VRF12_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama1_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama1_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama1_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA1_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama2_ck_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_CK_SW_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_CK_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama2_ck_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_CK_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_CK_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama2_osc_sel_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VCAMA2_CG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_OSC_SEL_DIS_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_OSC_SEL_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_sp_sw_vosel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_SP),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SP_SW_VOSEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SP_SW_VOSEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_sp_sw_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS1_SP),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SP_SW_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_SP_SW_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_sp_sw_vosel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_SP),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SP_SW_VOSEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SP_SW_VOSEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_sp_sw_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_DVFS2_SP),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SP_SW_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_SP_SW_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_sp_sw_vosel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_SP),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SP_SW_VOSEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SP_SW_VOSEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_sp_sw_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VGPU_SP),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SP_SW_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_SP_SW_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_sp_sw_vosel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_SP),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SP_SW_VOSEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SP_SW_VOSEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_sp_sw_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VMD_SP),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SP_SW_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_SP_SW_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sp_sw_vosel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_SP),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SP_SW_VOSEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SP_SW_VOSEL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sp_sw_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_SP),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SP_SW_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SP_SW_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sshub_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_SSHUB),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SSHUB_ON_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SSHUB_ON_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sshub_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_SSHUB),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SSHUB_MODE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SSHUB_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_sshub_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_LDO_VSRAM_VCORE_SSHUB),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SSHUB_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_SSHUB_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_aldo_1_resev(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ALDO_1_RESEV_MASK),
				    (unsigned int)(PMIC_RG_ALDO_1_RESEV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_CAL_MASK),
				    (unsigned int)(PMIC_RG_VFE28_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VFE28_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vfe28_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VFE28_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VFE28_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_CAL_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbif28_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBIF28_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VBIF28_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCN28_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCN28_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn28_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN28_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_CAL_MASK),
				    (unsigned int)(PMIC_RG_VXO22_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VXO22_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vxo22_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VXO22_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_CAL_MASK),
				    (unsigned int)(PMIC_RG_VA18_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VA18_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va18_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA18_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VA18_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_aldo_2_resev(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ALDO_2_RESEV_MASK),
				    (unsigned int)(PMIC_RG_ALDO_2_RESEV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_OC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamaf_n2lp_ehc_v18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMAF_N2LP_EHC_V18_MASK),
				    (unsigned int)(PMIC_RG_VCAMAF_N2LP_EHC_V18_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama1_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama1_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama1_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama1_fbsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA1_FBSEL_MASK),
				    (unsigned int)(PMIC_RG_VCAMA1_FBSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama2_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama2_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama2_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcama2_fbsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_ALDO_2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA2_FBSEL_MASK),
				    (unsigned int)(PMIC_RG_VCAMA2_FBSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_dldo_resev(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DLDO_RESEV_MASK),
				    (unsigned int)(PMIC_RG_DLDO_RESEV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_CAL_MASK),
				    (unsigned int)(PMIC_RG_VMC_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VMC_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VMC_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VMC_OC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmc_n2lp_ehc_v18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_N2LP_EHC_V18_MASK),
				    (unsigned int)(PMIC_RG_VMC_N2LP_EHC_V18_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCN33_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCN33_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_bt_vosel(unsigned int val)
{
	mt6335_upmu_set_rg_vcn33_vosel(val);
}

void mt6335_upmu_set_rg_vcn33_wifi_vosel(unsigned int val)
{
	mt6335_upmu_set_rg_vcn33_vosel(val);
}

void mt6335_upmu_set_rg_vcn33_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN33_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn33_n2lp_ehc_v18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_N2LP_EHC_V18_MASK),
				    (unsigned int)(PMIC_RG_VCN33_N2LP_EHC_V18_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_CAL_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_stb_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_STB_CAL_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_STB_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_OC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_ndis_en_int(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_NDIS_EN_INT_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_NDIS_EN_INT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim1_lp_high_speed_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_LP_HIGH_SPEED_ENB_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_LP_HIGH_SPEED_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_CAL_MASK),
				    (unsigned int)(PMIC_RG_VEMC_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VEMC_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VEMC_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VEMC_OC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vemc_n2lp_ehc_v18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC_N2LP_EHC_V18_MASK),
				    (unsigned int)(PMIC_RG_VEMC_N2LP_EHC_V18_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_CAL_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vusb33_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_OC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_CAL_MASK),
				    (unsigned int)(PMIC_RG_VIBR_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VIBR_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VIBR_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vibr_lp_high_speed_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_LP_HIGH_SPEED_ENB_MASK),
				    (unsigned int)(PMIC_RG_VIBR_LP_HIGH_SPEED_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_CAL_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_OC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vtouch_n2lp_ehc_v18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTOUCH_N2LP_EHC_V18_MASK),
				    (unsigned int)(PMIC_RG_VTOUCH_N2LP_EHC_V18_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_CAL_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_stb_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_STB_CAL_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_STB_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_OC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_ndis_en_int(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_NDIS_EN_INT_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_NDIS_EN_INT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vefuse_lp_high_speed_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEFUSE_LP_HIGH_SPEED_ENB_MASK),
				    (unsigned int)(PMIC_RG_VEFUSE_LP_HIGH_SPEED_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_CAL_MASK),
				    (unsigned int)(PMIC_RG_VIO28_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VIO28_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO28_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio28_lp_high_speed_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_LP_HIGH_SPEED_ENB_MASK),
				    (unsigned int)(PMIC_RG_VIO28_LP_HIGH_SPEED_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_CAL_MASK),
				    (unsigned int)(PMIC_RG_VMCH_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VMCH_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VMCH_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VMCH_OC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmch_n2lp_ehc_v18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_N2LP_EHC_V18_MASK),
				    (unsigned int)(PMIC_RG_VMCH_N2LP_EHC_V18_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_CAL_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_stb_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_STB_CAL_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_STB_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_OC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_ndis_en_int(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_NDIS_EN_INT_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_NDIS_EN_INT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsim2_lp_high_speed_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DLDO_ANA_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_LP_HIGH_SPEED_ENB_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_LP_HIGH_SPEED_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_sldo14_resev(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SLDO14_RESEV_MASK),
				    (unsigned int)(PMIC_RG_SLDO14_RESEV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_ndis_plcur(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_NDIS_PLCUR_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_NDIS_PLCUR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs1_plcur_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_PLCUR_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS1_PLCUR_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_ndis_plcur(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_NDIS_PLCUR_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_NDIS_PLCUR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_dvfs2_plcur_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_PLCUR_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_DVFS2_PLCUR_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_ndis_plcur(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_NDIS_PLCUR_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_NDIS_PLCUR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vcore_plcur_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_PLCUR_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VCORE_PLCUR_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_ndis_plcur(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_NDIS_PLCUR_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_NDIS_PLCUR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vgpu_plcur_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_PLCUR_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VGPU_PLCUR_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_ndis_plcur(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_NDIS_PLCUR_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_NDIS_PLCUR_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vsram_vmd_plcur_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_PLCUR_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_VMD_PLCUR_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_CAL_MASK),
				    (unsigned int)(PMIC_RG_VA12_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VA12_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VA12_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va12_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA12_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VA12_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_RSV_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd1_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD1_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VCAMD1_OC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_CAL_MASK),
				    (unsigned int)(PMIC_RG_VA10_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VA10_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VA10_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VA10_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_lp_vsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_LP_VSEL_MASK),
				    (unsigned int)(PMIC_RG_VA10_LP_VSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_va10_lp_vsel_option(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA10_LP_VSEL_OPTION_MASK),
				    (unsigned int)(PMIC_RG_VA10_LP_VSEL_OPTION_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_CAL_MASK),
				    (unsigned int)(PMIC_RG_VRF12_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VRF12_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf12_ft_dnmc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_FT_DNMC_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_FT_DNMC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_RSV_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamd2_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO14_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD2_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VCAMD2_OC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_sldo20_resev(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SLDO20_RESEV_MASK),
				    (unsigned int)(PMIC_RG_SLDO20_RESEV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_CAL_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_1_ft_dnmc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_1_FT_DNMC_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_1_FT_DNMC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_CAL_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vrf18_2_ft_dnmc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_2_FT_DNMC_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_2_FT_DNMC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCN18_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCN18_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN18_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcn18_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VCN18_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_CAL_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vmipi_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMIPI_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VMIPI_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_CAL_MASK),
				    (unsigned int)(PMIC_RG_VIO18_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO18_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vio18_ft_dnmc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_FT_DNMC_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO18_FT_DNMC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcamio_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_STB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_CAL_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vufs18_ft_dnmc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUFS18_FT_DNMC_EN_MASK),
				    (unsigned int)(PMIC_RG_VUFS18_FT_DNMC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_CAL_MASK),
				    (unsigned int)(PMIC_RG_VGP3_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VGP3_VOSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VGP3_NDIS_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vgp3_ft_dnmc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SLDO20_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VGP3_FT_DNMC_EN_MASK),
				    (unsigned int)(PMIC_RG_VGP3_FT_DNMC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_0_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_0_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_1_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_1_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_2_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_2_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_3_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_3_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_4_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_4_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_5_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_5_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_6(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_6_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_6_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_7(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_7_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_7_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_8(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_8_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_8_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_9(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_9_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_9_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_10(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_10_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_10_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_11(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_11_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_11_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_12(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_12_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_12_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_13(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_13_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_13_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_14(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_14_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_14_SHIFT)
	    );

}

void mt6335_upmu_set_bif_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_RSV_MASK),
				    (unsigned int)(PMIC_BIF_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_bif_command_type(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_COMMAND_TYPE_MASK),
				    (unsigned int)(PMIC_BIF_COMMAND_TYPE_SHIFT)
	    );

}

void mt6335_upmu_set_bif_trasfer_num(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TRASFER_NUM_MASK),
				    (unsigned int)(PMIC_BIF_TRASFER_NUM_SHIFT)
	    );

}

void mt6335_upmu_set_bif_logic_0_set(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_LOGIC_0_SET_MASK),
				    (unsigned int)(PMIC_BIF_LOGIC_0_SET_SHIFT)
	    );

}

void mt6335_upmu_set_bif_logic_1_set(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_LOGIC_1_SET_MASK),
				    (unsigned int)(PMIC_BIF_LOGIC_1_SET_SHIFT)
	    );

}

void mt6335_upmu_set_bif_stop_set(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_STOP_SET_MASK),
				    (unsigned int)(PMIC_BIF_STOP_SET_SHIFT)
	    );

}

void mt6335_upmu_set_bif_debounce_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_DEBOUNCE_EN_MASK),
				    (unsigned int)(PMIC_BIF_DEBOUNCE_EN_SHIFT)
	    );

}

void mt6335_upmu_set_bif_read_expect_num(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_READ_EXPECT_NUM_MASK),
				    (unsigned int)(PMIC_BIF_READ_EXPECT_NUM_SHIFT)
	    );

}

void mt6335_upmu_set_bif_trasact_trigger(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TRASACT_TRIGGER_MASK),
				    (unsigned int)(PMIC_BIF_TRASACT_TRIGGER_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_bif_data_num(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON19),
				  (&val),
				  (unsigned int)(PMIC_BIF_DATA_NUM_MASK),
				  (unsigned int)(PMIC_BIF_DATA_NUM_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_response(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON19),
				  (&val),
				  (unsigned int)(PMIC_BIF_RESPONSE_MASK),
				  (unsigned int)(PMIC_BIF_RESPONSE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_data_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON20),
				  (&val),
				  (unsigned int)(PMIC_BIF_DATA_0_MASK),
				  (unsigned int)(PMIC_BIF_DATA_0_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_ack_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON20),
				  (&val),
				  (unsigned int)(PMIC_BIF_ACK_0_MASK),
				  (unsigned int)(PMIC_BIF_ACK_0_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_error_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON20),
				  (&val),
				  (unsigned int)(PMIC_BIF_ERROR_0_MASK),
				  (unsigned int)(PMIC_BIF_ERROR_0_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_data_1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON21),
				  (&val),
				  (unsigned int)(PMIC_BIF_DATA_1_MASK),
				  (unsigned int)(PMIC_BIF_DATA_1_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_ack_1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON21),
				  (&val),
				  (unsigned int)(PMIC_BIF_ACK_1_MASK),
				  (unsigned int)(PMIC_BIF_ACK_1_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_error_1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON21),
				  (&val),
				  (unsigned int)(PMIC_BIF_ERROR_1_MASK),
				  (unsigned int)(PMIC_BIF_ERROR_1_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_data_2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON22),
				  (&val),
				  (unsigned int)(PMIC_BIF_DATA_2_MASK),
				  (unsigned int)(PMIC_BIF_DATA_2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_ack_2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON22),
				  (&val),
				  (unsigned int)(PMIC_BIF_ACK_2_MASK),
				  (unsigned int)(PMIC_BIF_ACK_2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_error_2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON22),
				  (&val),
				  (unsigned int)(PMIC_BIF_ERROR_2_MASK),
				  (unsigned int)(PMIC_BIF_ERROR_2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_data_3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON23),
				  (&val),
				  (unsigned int)(PMIC_BIF_DATA_3_MASK),
				  (unsigned int)(PMIC_BIF_DATA_3_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_ack_3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON23),
				  (&val),
				  (unsigned int)(PMIC_BIF_ACK_3_MASK),
				  (unsigned int)(PMIC_BIF_ACK_3_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_error_3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON23),
				  (&val),
				  (unsigned int)(PMIC_BIF_ERROR_3_MASK),
				  (unsigned int)(PMIC_BIF_ERROR_3_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_data_4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON24),
				  (&val),
				  (unsigned int)(PMIC_BIF_DATA_4_MASK),
				  (unsigned int)(PMIC_BIF_DATA_4_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_ack_4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON24),
				  (&val),
				  (unsigned int)(PMIC_BIF_ACK_4_MASK),
				  (unsigned int)(PMIC_BIF_ACK_4_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_error_4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON24),
				  (&val),
				  (unsigned int)(PMIC_BIF_ERROR_4_MASK),
				  (unsigned int)(PMIC_BIF_ERROR_4_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_data_5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON25),
				  (&val),
				  (unsigned int)(PMIC_BIF_DATA_5_MASK),
				  (unsigned int)(PMIC_BIF_DATA_5_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_ack_5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON25),
				  (&val),
				  (unsigned int)(PMIC_BIF_ACK_5_MASK),
				  (unsigned int)(PMIC_BIF_ACK_5_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_error_5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON25),
				  (&val),
				  (unsigned int)(PMIC_BIF_ERROR_5_MASK),
				  (unsigned int)(PMIC_BIF_ERROR_5_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_data_6(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON26),
				  (&val),
				  (unsigned int)(PMIC_BIF_DATA_6_MASK),
				  (unsigned int)(PMIC_BIF_DATA_6_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_ack_6(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON26),
				  (&val),
				  (unsigned int)(PMIC_BIF_ACK_6_MASK),
				  (unsigned int)(PMIC_BIF_ACK_6_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_error_6(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON26),
				  (&val),
				  (unsigned int)(PMIC_BIF_ERROR_6_MASK),
				  (unsigned int)(PMIC_BIF_ERROR_6_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_data_7(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON27),
				  (&val),
				  (unsigned int)(PMIC_BIF_DATA_7_MASK),
				  (unsigned int)(PMIC_BIF_DATA_7_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_ack_7(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON27),
				  (&val),
				  (unsigned int)(PMIC_BIF_ACK_7_MASK),
				  (unsigned int)(PMIC_BIF_ACK_7_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_error_7(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON27),
				  (&val),
				  (unsigned int)(PMIC_BIF_ERROR_7_MASK),
				  (unsigned int)(PMIC_BIF_ERROR_7_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_data_8(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON28),
				  (&val),
				  (unsigned int)(PMIC_BIF_DATA_8_MASK),
				  (unsigned int)(PMIC_BIF_DATA_8_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_ack_8(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON28),
				  (&val),
				  (unsigned int)(PMIC_BIF_ACK_8_MASK),
				  (unsigned int)(PMIC_BIF_ACK_8_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_error_8(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON28),
				  (&val),
				  (unsigned int)(PMIC_BIF_ERROR_8_MASK),
				  (unsigned int)(PMIC_BIF_ERROR_8_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_data_9(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON29),
				  (&val),
				  (unsigned int)(PMIC_BIF_DATA_9_MASK),
				  (unsigned int)(PMIC_BIF_DATA_9_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_ack_9(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON29),
				  (&val),
				  (unsigned int)(PMIC_BIF_ACK_9_MASK),
				  (unsigned int)(PMIC_BIF_ACK_9_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_error_9(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON29),
				  (&val),
				  (unsigned int)(PMIC_BIF_ERROR_9_MASK),
				  (unsigned int)(PMIC_BIF_ERROR_9_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_bif_test_mode0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TEST_MODE0_MASK),
				    (unsigned int)(PMIC_BIF_TEST_MODE0_SHIFT)
	    );

}

void mt6335_upmu_set_bif_test_mode1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TEST_MODE1_MASK),
				    (unsigned int)(PMIC_BIF_TEST_MODE1_SHIFT)
	    );

}

void mt6335_upmu_set_bif_test_mode2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TEST_MODE2_MASK),
				    (unsigned int)(PMIC_BIF_TEST_MODE2_SHIFT)
	    );

}

void mt6335_upmu_set_bif_test_mode3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TEST_MODE3_MASK),
				    (unsigned int)(PMIC_BIF_TEST_MODE3_SHIFT)
	    );

}

void mt6335_upmu_set_bif_test_mode4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TEST_MODE4_MASK),
				    (unsigned int)(PMIC_BIF_TEST_MODE4_SHIFT)
	    );

}

void mt6335_upmu_set_bif_test_mode5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TEST_MODE5_MASK),
				    (unsigned int)(PMIC_BIF_TEST_MODE5_SHIFT)
	    );

}

void mt6335_upmu_set_bif_test_mode6(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TEST_MODE6_MASK),
				    (unsigned int)(PMIC_BIF_TEST_MODE6_SHIFT)
	    );

}

void mt6335_upmu_set_bif_test_mode7(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TEST_MODE7_MASK),
				    (unsigned int)(PMIC_BIF_TEST_MODE7_SHIFT)
	    );

}

void mt6335_upmu_set_bif_test_mode8(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TEST_MODE8_MASK),
				    (unsigned int)(PMIC_BIF_TEST_MODE8_SHIFT)
	    );

}

void mt6335_upmu_set_bif_bat_lost_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_BAT_LOST_SW_MASK),
				    (unsigned int)(PMIC_BIF_BAT_LOST_SW_SHIFT)
	    );

}

void mt6335_upmu_set_bif_rx_data_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_RX_DATA_SW_MASK),
				    (unsigned int)(PMIC_BIF_RX_DATA_SW_SHIFT)
	    );

}

void mt6335_upmu_set_bif_tx_data_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TX_DATA_SW_MASK),
				    (unsigned int)(PMIC_BIF_TX_DATA_SW_SHIFT)
	    );

}

void mt6335_upmu_set_bif_rx_en_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_RX_EN_SW_MASK),
				    (unsigned int)(PMIC_BIF_RX_EN_SW_SHIFT)
	    );

}

void mt6335_upmu_set_bif_tx_en_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TX_EN_SW_MASK),
				    (unsigned int)(PMIC_BIF_TX_EN_SW_SHIFT)
	    );

}

void mt6335_upmu_set_bif_back_normal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON31),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_BACK_NORMAL_MASK),
				    (unsigned int)(PMIC_BIF_BACK_NORMAL_SHIFT)
	    );

}

void mt6335_upmu_set_bif_irq_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON31),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_IRQ_CLR_MASK),
				    (unsigned int)(PMIC_BIF_IRQ_CLR_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_bif_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON31),
				  (&val),
				  (unsigned int)(PMIC_BIF_IRQ_MASK),
				  (unsigned int)(PMIC_BIF_IRQ_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_timeout(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON31),
				  (&val),
				  (unsigned int)(PMIC_BIF_TIMEOUT_MASK),
				  (unsigned int)(PMIC_BIF_TIMEOUT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_bat_undet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON31),
				  (&val),
				  (unsigned int)(PMIC_BIF_BAT_UNDET_MASK),
				  (unsigned int)(PMIC_BIF_BAT_UNDET_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_total_valid(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON31),
				  (&val),
				  (unsigned int)(PMIC_BIF_TOTAL_VALID_MASK),
				  (unsigned int)(PMIC_BIF_TOTAL_VALID_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_bus_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON31),
				  (&val),
				  (unsigned int)(PMIC_BIF_BUS_STATUS_MASK),
				  (unsigned int)(PMIC_BIF_BUS_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_bif_power_up_count(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON32),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_POWER_UP_COUNT_MASK),
				    (unsigned int)(PMIC_BIF_POWER_UP_COUNT_SHIFT)
	    );

}

void mt6335_upmu_set_bif_power_up(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON32),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_POWER_UP_MASK),
				    (unsigned int)(PMIC_BIF_POWER_UP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_bif_rx_error_unknown(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON33),
				  (&val),
				  (unsigned int)(PMIC_BIF_RX_ERROR_UNKNOWN_MASK),
				  (unsigned int)(PMIC_BIF_RX_ERROR_UNKNOWN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_rx_error_insuff(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON33),
				  (&val),
				  (unsigned int)(PMIC_BIF_RX_ERROR_INSUFF_MASK),
				  (unsigned int)(PMIC_BIF_RX_ERROR_INSUFF_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_rx_error_lowphase(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON33),
				  (&val),
				  (unsigned int)(PMIC_BIF_RX_ERROR_LOWPHASE_MASK),
				  (unsigned int)(PMIC_BIF_RX_ERROR_LOWPHASE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_rx_state(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON33),
				  (&val),
				  (unsigned int)(PMIC_BIF_RX_STATE_MASK),
				  (unsigned int)(PMIC_BIF_RX_STATE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_flow_ctl_state(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON33),
				  (&val),
				  (unsigned int)(PMIC_BIF_FLOW_CTL_STATE_MASK),
				  (unsigned int)(PMIC_BIF_FLOW_CTL_STATE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_tx_state(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON33),
				  (&val),
				  (unsigned int)(PMIC_BIF_TX_STATE_MASK),
				  (unsigned int)(PMIC_BIF_TX_STATE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_ad_qi_bif_rx_data(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON33),
				  (&val),
				  (unsigned int)(PMIC_AD_QI_BIF_RX_DATA_MASK),
				  (unsigned int)(PMIC_AD_QI_BIF_RX_DATA_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_bif_rx_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON33),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_BIF_RX_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_BIF_RX_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_bif_tx_data(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON33),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_BIF_TX_DATA_MASK),
				  (unsigned int)(PMIC_DA_QI_BIF_TX_DATA_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_qi_bif_tx_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON33),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_BIF_TX_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_BIF_TX_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_tx_data_fianl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON34),
				  (&val),
				  (unsigned int)(PMIC_BIF_TX_DATA_FIANL_MASK),
				  (unsigned int)(PMIC_BIF_TX_DATA_FIANL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_rx_data_sampling(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON35),
				  (&val),
				  (unsigned int)(PMIC_BIF_RX_DATA_SAMPLING_MASK),
				  (unsigned int)(PMIC_BIF_RX_DATA_SAMPLING_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_bif_rx_data_recovery(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON36),
				  (&val),
				  (unsigned int)(PMIC_BIF_RX_DATA_RECOVERY_MASK),
				  (unsigned int)(PMIC_BIF_RX_DATA_RECOVERY_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_baton_ht_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON36),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_HT_EN_MASK),
				    (unsigned int)(PMIC_RG_BATON_HT_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_ht_en_dly_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON36),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_HT_EN_DLY_TIME_MASK),
				    (unsigned int)(PMIC_RG_BATON_HT_EN_DLY_TIME_SHIFT)
	    );

}

void mt6335_upmu_set_bif_timeout_set(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON37),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_TIMEOUT_SET_MASK),
				    (unsigned int)(PMIC_BIF_TIMEOUT_SET_SHIFT)
	    );

}

void mt6335_upmu_set_bif_rx_deg_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON38),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_RX_DEG_WND_MASK),
				    (unsigned int)(PMIC_BIF_RX_DEG_WND_SHIFT)
	    );

}

void mt6335_upmu_set_bif_rx_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON38),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_RX_DEG_EN_MASK),
				    (unsigned int)(PMIC_BIF_RX_DEG_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_bif_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_CON39),
				  (&val),
				  (unsigned int)(PMIC_BIF_RSV1_MASK),
				  (unsigned int)(PMIC_BIF_RSV1_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_bif_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_CON39),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BIF_RSV0_MASK),
				    (unsigned int)(PMIC_BIF_RSV0_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_qi_baton_ht_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_BATON_HT_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_BATON_HT_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_baton_debounce_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_DEBOUNCE_WND_MASK),
				    (unsigned int)(PMIC_RG_BATON_DEBOUNCE_WND_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_debounce_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_DEBOUNCE_THD_MASK),
				    (unsigned int)(PMIC_RG_BATON_DEBOUNCE_THD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_vbif_stb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_VBIF_STB_MASK),
				    (unsigned int)(PMIC_RG_BATON_VBIF_STB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_chrdet_test_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_CHRDET_TEST_MODE_MASK),
				    (unsigned int)(PMIC_RG_BATON_CHRDET_TEST_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_undet_test_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_UNDET_TEST_MODE_MASK),
				    (unsigned int)(PMIC_RG_BATON_UNDET_TEST_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_auxadc_test_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_AUXADC_TEST_MODE_MASK),
				    (unsigned int)(PMIC_RG_BATON_AUXADC_TEST_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_fgadc_test_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_FGADC_TEST_MODE_MASK),
				    (unsigned int)(PMIC_RG_BATON_FGADC_TEST_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_rtc_test_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_RTC_TEST_MODE_MASK),
				    (unsigned int)(PMIC_RG_BATON_RTC_TEST_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_bif_test_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_BIF_TEST_MODE_MASK),
				    (unsigned int)(PMIC_RG_BATON_BIF_TEST_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_RSV_MASK),
				    (unsigned int)(PMIC_RG_BATON_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_chrdet_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_CHRDET_SW_MASK),
				    (unsigned int)(PMIC_RG_BATON_CHRDET_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_undet_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_UNDET_SW_MASK),
				    (unsigned int)(PMIC_RG_BATON_UNDET_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_auxadc_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_AUXADC_SW_MASK),
				    (unsigned int)(PMIC_RG_BATON_AUXADC_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_fgadc_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_FGADC_SW_MASK),
				    (unsigned int)(PMIC_RG_BATON_FGADC_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_rtc_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_RTC_SW_MASK),
				    (unsigned int)(PMIC_RG_BATON_RTC_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_bif_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_BIF_SW_MASK),
				    (unsigned int)(PMIC_RG_BATON_BIF_SW_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_rsv_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_BAT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_RSV_SW_MASK),
				    (unsigned int)(PMIC_RG_BATON_RSV_SW_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_baton_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_STATUS_MASK),
				  (unsigned int)(PMIC_BATON_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_baton_auxadc_set(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_AUXADC_SET_MASK),
				  (unsigned int)(PMIC_BATON_AUXADC_SET_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_baton_deb_valid(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_DEB_VALID_MASK),
				  (unsigned int)(PMIC_BATON_DEB_VALID_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_baton_bif_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_BIF_STATUS_MASK),
				  (unsigned int)(PMIC_BATON_BIF_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_baton_rtc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_RTC_STATUS_MASK),
				  (unsigned int)(PMIC_BATON_RTC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_baton_fgadc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_FGADC_STATUS_MASK),
				  (unsigned int)(PMIC_BATON_FGADC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_baton_auxadc_trig(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_AUXADC_TRIG_MASK),
				  (unsigned int)(PMIC_BATON_AUXADC_TRIG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_baton_chrdet_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_CHRDET_DEB_MASK),
				  (unsigned int)(PMIC_BATON_CHRDET_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_baton_ivgen_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_IVGEN_ENB_MASK),
				  (unsigned int)(PMIC_BATON_IVGEN_ENB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_baton_vbif28_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_VBIF28_STB_MASK),
				  (unsigned int)(PMIC_BATON_VBIF28_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_baton_vbif28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_VBIF28_EN_MASK),
				  (unsigned int)(PMIC_BATON_VBIF28_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_baton_rsv_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BIF_BAT_CON3),
				  (&val),
				  (unsigned int)(PMIC_BATON_RSV_0_MASK),
				  (unsigned int)(PMIC_BATON_RSV_0_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_bif_batid_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BIF_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIF_BATID_SW_EN_MASK),
				    (unsigned int)(PMIC_RG_BIF_BATID_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_pa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PA_MASK),
				    (unsigned int)(PMIC_RG_OTP_PA_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_pdin(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PDIN_MASK),
				    (unsigned int)(PMIC_RG_OTP_PDIN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_ptm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PTM_MASK),
				    (unsigned int)(PMIC_RG_OTP_PTM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_pwe(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PWE_MASK),
				    (unsigned int)(PMIC_RG_OTP_PWE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_pprog(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PPROG_MASK),
				    (unsigned int)(PMIC_RG_OTP_PPROG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_pwe_src(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PWE_SRC_MASK),
				    (unsigned int)(PMIC_RG_OTP_PWE_SRC_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_prog_pkey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PROG_PKEY_MASK),
				    (unsigned int)(PMIC_RG_OTP_PROG_PKEY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_rd_pkey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_RD_PKEY_MASK),
				    (unsigned int)(PMIC_RG_OTP_RD_PKEY_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_rd_trig(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_RD_TRIG_MASK),
				    (unsigned int)(PMIC_RG_OTP_RD_TRIG_SHIFT)
	    );

}

void mt6335_upmu_set_rg_rd_rdy_bypass(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RD_RDY_BYPASS_MASK),
				    (unsigned int)(PMIC_RG_RD_RDY_BYPASS_SHIFT)
	    );

}

void mt6335_upmu_set_rg_skip_otp_out(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SKIP_OTP_OUT_MASK),
				    (unsigned int)(PMIC_RG_SKIP_OTP_OUT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_rd_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_RD_SW_MASK),
				    (unsigned int)(PMIC_RG_OTP_RD_SW_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rg_otp_dout_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_SW_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_SW_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_rd_busy(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_RD_BUSY_MASK),
				  (unsigned int)(PMIC_RG_OTP_RD_BUSY_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_rd_ack(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_RD_ACK_MASK),
				  (unsigned int)(PMIC_RG_OTP_RD_ACK_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_pa_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_PA_SW_MASK),
				  (unsigned int)(PMIC_RG_OTP_PA_SW_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_0_15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_0_15),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_0_15_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_0_15_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_16_31(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_16_31),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_16_31_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_16_31_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_32_47(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_32_47),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_32_47_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_32_47_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_48_63(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_48_63),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_48_63_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_48_63_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_64_79(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_64_79),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_64_79_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_64_79_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_80_95(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_80_95),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_80_95_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_80_95_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_96_111(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_96_111),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_96_111_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_96_111_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_112_127(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_112_127),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_112_127_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_112_127_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_128_143(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_128_143),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_128_143_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_128_143_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_144_159(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_144_159),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_144_159_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_144_159_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_160_175(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_160_175),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_160_175_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_160_175_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_176_191(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_176_191),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_176_191_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_176_191_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_192_207(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_192_207),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_192_207_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_192_207_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_208_223(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_208_223),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_208_223_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_208_223_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_224_239(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_224_239),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_224_239_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_224_239_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_240_255(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_240_255),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_240_255_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_240_255_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_256_271(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_256_271),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_256_271_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_256_271_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_272_287(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_272_287),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_272_287_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_272_287_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_288_303(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_288_303),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_288_303_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_288_303_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_304_319(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_304_319),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_304_319_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_304_319_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_320_335(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_320_335),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_320_335_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_320_335_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_336_351(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_336_351),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_336_351_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_336_351_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_352_367(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_352_367),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_352_367_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_352_367_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_368_383(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_368_383),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_368_383_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_368_383_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_384_399(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_384_399),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_384_399_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_384_399_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_400_415(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_400_415),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_400_415_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_400_415_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_416_431(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_416_431),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_416_431_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_416_431_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_432_447(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_432_447),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_432_447_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_432_447_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_448_463(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_448_463),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_448_463_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_448_463_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_464_479(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_464_479),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_464_479_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_464_479_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_480_495(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_480_495),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_480_495_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_480_495_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_496_511(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_496_511),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_496_511_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_496_511_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_512_527(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_512_527),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_512_527_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_512_527_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_528_543(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_528_543),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_528_543_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_528_543_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_544_559(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_544_559),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_544_559_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_544_559_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_560_575(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_560_575),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_560_575_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_560_575_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_576_591(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_576_591),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_576_591_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_576_591_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_592_607(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_592_607),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_592_607_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_592_607_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_608_623(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_608_623),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_608_623_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_608_623_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_624_639(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_624_639),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_624_639_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_624_639_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_640_655(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_640_655),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_640_655_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_640_655_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_656_671(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_656_671),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_656_671_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_656_671_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_672_687(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_672_687),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_672_687_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_672_687_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_688_703(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_688_703),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_688_703_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_688_703_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_704_719(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_704_719),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_704_719_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_704_719_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_720_735(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_720_735),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_720_735_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_720_735_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_736_751(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_736_751),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_736_751_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_736_751_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_752_767(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_752_767),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_752_767_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_752_767_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_768_783(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_768_783),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_768_783_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_768_783_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_784_799(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_784_799),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_784_799_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_784_799_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_800_815(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_800_815),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_800_815_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_800_815_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_816_831(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_816_831),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_816_831_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_816_831_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_832_847(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_832_847),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_832_847_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_832_847_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_848_863(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_848_863),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_848_863_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_848_863_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_864_879(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_864_879),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_864_879_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_864_879_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_880_895(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_880_895),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_880_895_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_880_895_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_896_911(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_896_911),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_896_911_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_896_911_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_912_927(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_912_927),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_912_927_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_912_927_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_928_943(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_928_943),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_928_943_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_928_943_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_944_959(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_944_959),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_944_959_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_944_959_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_960_975(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_960_975),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_960_975_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_960_975_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_976_991(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_976_991),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_976_991_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_976_991_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_992_1007(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_992_1007),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_992_1007_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_992_1007_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rg_otp_dout_1008_1023(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_OTP_DOUT_1008_1023),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_1008_1023_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_1008_1023_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_otp_val_0_15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_0_15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_0_15_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_0_15_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_16_31(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_16_31),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_16_31_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_16_31_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_32_47(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_32_47),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_32_47_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_32_47_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_48_63(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_48_63),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_48_63_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_48_63_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_64_79(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_64_79),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_64_79_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_64_79_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_80_95(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_80_95),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_80_95_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_80_95_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_96_111(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_96_111),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_96_111_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_96_111_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_112_127(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_112_127),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_112_127_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_112_127_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_128_143(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_128_143),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_128_143_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_128_143_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_144_159(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_144_159),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_144_159_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_144_159_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_160_175(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_160_175),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_160_175_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_160_175_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_176_191(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_176_191),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_176_191_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_176_191_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_192_207(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_192_207),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_192_207_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_192_207_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_208_223(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_208_223),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_208_223_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_208_223_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_224_239(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_224_239),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_224_239_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_224_239_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_240_255(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_240_255),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_240_255_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_240_255_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_256_271(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_256_271),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_256_271_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_256_271_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_272_287(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_272_287),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_272_287_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_272_287_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_288_303(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_288_303),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_288_303_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_288_303_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_304_319(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_304_319),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_304_319_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_304_319_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_320_335(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_320_335),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_320_335_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_320_335_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_336_351(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_336_351),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_336_351_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_336_351_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_352_367(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_352_367),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_352_367_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_352_367_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_368_383(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_368_383),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_368_383_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_368_383_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_384_399(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_384_399),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_384_399_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_384_399_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_400_415(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_400_415),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_400_415_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_400_415_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_416_431(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_416_431),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_416_431_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_416_431_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_432_447(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_432_447),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_432_447_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_432_447_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_448_463(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_448_463),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_448_463_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_448_463_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_464_479(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_464_479),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_464_479_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_464_479_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_480_495(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_480_495),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_480_495_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_480_495_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_496_511(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_496_511),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_496_511_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_496_511_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_512_527(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_512_527),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_512_527_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_512_527_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_528_543(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_528_543),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_528_543_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_528_543_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_544_559(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_544_559),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_544_559_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_544_559_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_560_575(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_560_575),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_560_575_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_560_575_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_576_591(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_576_591),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_576_591_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_576_591_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_592_607(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_592_607),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_592_607_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_592_607_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_608_623(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_608_623),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_608_623_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_608_623_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_624_639(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_624_639),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_624_639_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_624_639_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_640_655(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_640_655),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_640_655_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_640_655_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_656_671(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_656_671),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_656_671_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_656_671_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_672_687(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_672_687),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_672_687_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_672_687_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_688_703(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_688_703),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_688_703_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_688_703_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_704_719(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_704_719),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_704_719_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_704_719_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_720_735(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_720_735),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_720_735_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_720_735_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_736_751(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_736_751),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_736_751_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_736_751_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_752_767(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_752_767),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_752_767_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_752_767_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_768_783(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_768_783),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_768_783_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_768_783_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_784_799(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_784_799),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_784_799_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_784_799_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_800_815(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_800_815),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_800_815_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_800_815_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_816_831(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_816_831),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_816_831_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_816_831_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_832_847(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_832_847),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_832_847_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_832_847_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_848_863(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_848_863),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_848_863_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_848_863_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_864_879(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_864_879),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_864_879_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_864_879_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_880_895(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_880_895),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_880_895_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_880_895_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_896_911(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_896_911),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_896_911_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_896_911_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_912_927(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_912_927),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_912_927_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_912_927_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_928_943(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_928_943),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_928_943_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_928_943_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_944_959(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_944_959),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_944_959_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_944_959_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_960_975(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_960_975),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_960_975_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_960_975_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_976_991(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_976_991),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_976_991_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_976_991_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_992_1007(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_992_1007),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_992_1007_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_992_1007_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otp_val_1008_1023(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_OTP_VAL_1008_1023),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_1008_1023_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_1008_1023_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_mix_eosc32_stp_lpdtb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_RTC_MIX_CON0),
				  (&val),
				  (unsigned int)(PMIC_MIX_EOSC32_STP_LPDTB_MASK),
				  (unsigned int)(PMIC_MIX_EOSC32_STP_LPDTB_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_mix_eosc32_stp_lpden(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_LPDEN_MASK),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_LPDEN_SHIFT)
	    );

}

void mt6335_upmu_set_mix_xosc32_stp_pwdb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_PWDB_MASK),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_PWDB_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_mix_xosc32_stp_lpdtb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_RTC_MIX_CON0),
				  (&val),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_LPDTB_MASK),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_LPDTB_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_mix_xosc32_stp_lpden(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_LPDEN_MASK),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_LPDEN_SHIFT)
	    );

}

void mt6335_upmu_set_mix_xosc32_stp_lpdrst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_LPDRST_MASK),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_LPDRST_SHIFT)
	    );

}

void mt6335_upmu_set_mix_xosc32_stp_cali(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_CALI_MASK),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_CALI_SHIFT)
	    );

}

void mt6335_upmu_set_stmp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STMP_MODE_MASK),
				    (unsigned int)(PMIC_STMP_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_mix_eosc32_stp_chop_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_CHOP_EN_MASK),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_CHOP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_mix_dcxo_stp_lvsh_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_MASK),
				    (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_SHIFT)
	    );

}

void mt6335_upmu_set_mix_pmu_stp_ddlo_vrtc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_MASK),
				    (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_SHIFT)
	    );

}

void mt6335_upmu_set_mix_pmu_stp_ddlo_vrtc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_EN_MASK),
				    (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_mix_rtc_stp_xosc32_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_STP_XOSC32_ENB_MASK),
				    (unsigned int)(PMIC_MIX_RTC_STP_XOSC32_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_mix_dcxo_stp_test_deglitch_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_MIX_DCXO_STP_TEST_DEGLITCH_MODE_MASK),
				    (unsigned int)(PMIC_MIX_DCXO_STP_TEST_DEGLITCH_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_mix_eosc32_stp_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_RSV_MASK),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_mix_eosc32_vct_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EOSC32_VCT_EN_MASK),
				    (unsigned int)(PMIC_MIX_EOSC32_VCT_EN_SHIFT)
	    );

}

void mt6335_upmu_set_mix_eosc32_opt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EOSC32_OPT_MASK),
				    (unsigned int)(PMIC_MIX_EOSC32_OPT_SHIFT)
	    );

}

void mt6335_upmu_set_mix_dcxo_stp_lvsh_en_int(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_INT_MASK),
				    (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_INT_SHIFT)
	    );

}

void mt6335_upmu_set_mix_rtc_gpio_coredetb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_COREDETB_MASK),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_COREDETB_SHIFT)
	    );

}

void mt6335_upmu_set_mix_rtc_gpio_f32kob(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_F32KOB_MASK),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_F32KOB_SHIFT)
	    );

}

void mt6335_upmu_set_mix_rtc_gpio_gpo(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_GPO_MASK),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_GPO_SHIFT)
	    );

}

void mt6335_upmu_set_mix_rtc_gpio_oe(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_OE_MASK),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_OE_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_mix_rtc_stp_debug_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_RTC_MIX_CON2),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_STP_DEBUG_OUT_MASK),
				  (unsigned int)(PMIC_MIX_RTC_STP_DEBUG_OUT_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_mix_rtc_stp_debug_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_STP_DEBUG_SEL_MASK),
				    (unsigned int)(PMIC_MIX_RTC_STP_DEBUG_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_mix_rtc_stp_k_eosc32_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_STP_K_EOSC32_EN_MASK),
				    (unsigned int)(PMIC_MIX_RTC_STP_K_EOSC32_EN_SHIFT)
	    );

}

void mt6335_upmu_set_mix_rtc_stp_embck_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_STP_EMBCK_SEL_MASK),
				    (unsigned int)(PMIC_MIX_RTC_STP_EMBCK_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_mix_stp_bbwakeup(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_STP_BBWAKEUP_MASK),
				    (unsigned int)(PMIC_MIX_STP_BBWAKEUP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_mix_stp_rtc_ddlo(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_RTC_MIX_CON2),
				  (&val),
				  (unsigned int)(PMIC_MIX_STP_RTC_DDLO_MASK),
				  (unsigned int)(PMIC_MIX_STP_RTC_DDLO_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_mix_rtc_xosc32_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_RTC_MIX_CON2),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_XOSC32_ENB_MASK),
				  (unsigned int)(PMIC_MIX_RTC_XOSC32_ENB_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_mix_efuse_xosc32_enb_opt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_RTC_MIX_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EFUSE_XOSC32_ENB_OPT_MASK),
				    (unsigned int)(PMIC_MIX_EFUSE_XOSC32_ENB_OPT_SHIFT)
	    );

}

void mt6335_upmu_set_fg_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ON_MASK),
				    (unsigned int)(PMIC_FG_ON_SHIFT)
	    );

}

void mt6335_upmu_set_fg_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_CAL_MASK),
				    (unsigned int)(PMIC_FG_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_fg_autocalrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_AUTOCALRATE_MASK),
				    (unsigned int)(PMIC_FG_AUTOCALRATE_SHIFT)
	    );

}

void mt6335_upmu_set_fg_son_slp_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SON_SLP_EN_MASK),
				    (unsigned int)(PMIC_FG_SON_SLP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_fg_soff_slp_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SOFF_SLP_EN_MASK),
				    (unsigned int)(PMIC_FG_SOFF_SLP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_fg_zcv_det_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ZCV_DET_EN_MASK),
				    (unsigned int)(PMIC_FG_ZCV_DET_EN_SHIFT)
	    );

}

void mt6335_upmu_set_fg_auxadc_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_AUXADC_R_MASK),
				    (unsigned int)(PMIC_FG_AUXADC_R_SHIFT)
	    );

}

void mt6335_upmu_set_fg_iavg_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_IAVG_MODE_MASK),
				    (unsigned int)(PMIC_FG_IAVG_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_fg_sw_read_pre(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SW_READ_PRE_MASK),
				    (unsigned int)(PMIC_FG_SW_READ_PRE_SHIFT)
	    );

}

void mt6335_upmu_set_fg_sw_rstclr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SW_RSTCLR_MASK),
				    (unsigned int)(PMIC_FG_SW_RSTCLR_SHIFT)
	    );

}

void mt6335_upmu_set_fg_sw_cr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SW_CR_MASK),
				    (unsigned int)(PMIC_FG_SW_CR_SHIFT)
	    );

}

void mt6335_upmu_set_fg_sw_clear(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SW_CLEAR_MASK),
				    (unsigned int)(PMIC_FG_SW_CLEAR_SHIFT)
	    );

}

void mt6335_upmu_set_fg_offset_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_OFFSET_RST_MASK),
				    (unsigned int)(PMIC_FG_OFFSET_RST_SHIFT)
	    );

}

void mt6335_upmu_set_fg_time_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_TIME_RST_MASK),
				    (unsigned int)(PMIC_FG_TIME_RST_SHIFT)
	    );

}

void mt6335_upmu_set_fg_charge_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_CHARGE_RST_MASK),
				    (unsigned int)(PMIC_FG_CHARGE_RST_SHIFT)
	    );

}

void mt6335_upmu_set_fg_n_charge_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_N_CHARGE_RST_MASK),
				    (unsigned int)(PMIC_FG_N_CHARGE_RST_SHIFT)
	    );

}

void mt6335_upmu_set_fg_soff_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SOFF_RST_MASK),
				    (unsigned int)(PMIC_FG_SOFF_RST_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fg_latchdata_st(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON1),
				  (&val),
				  (unsigned int)(PMIC_FG_LATCHDATA_ST_MASK),
				  (unsigned int)(PMIC_FG_LATCHDATA_ST_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_bat0_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_BAT0_L_MASK),
				  (unsigned int)(PMIC_EVENT_FG_BAT0_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_bat0_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_BAT0_H_MASK),
				  (unsigned int)(PMIC_EVENT_FG_BAT0_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_bat1_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_BAT1_L_MASK),
				  (unsigned int)(PMIC_EVENT_FG_BAT1_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_bat1_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_BAT1_H_MASK),
				  (unsigned int)(PMIC_EVENT_FG_BAT1_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_cur_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_CUR_L_MASK),
				  (unsigned int)(PMIC_EVENT_FG_CUR_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_cur_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_CUR_H_MASK),
				  (unsigned int)(PMIC_EVENT_FG_CUR_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_iavg_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_IAVG_L_MASK),
				  (unsigned int)(PMIC_EVENT_FG_IAVG_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_iavg_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_IAVG_H_MASK),
				  (unsigned int)(PMIC_EVENT_FG_IAVG_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_n_charge_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_N_CHARGE_L_MASK),
				  (unsigned int)(PMIC_EVENT_FG_N_CHARGE_L_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_time_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_TIME_H_MASK),
				  (unsigned int)(PMIC_EVENT_FG_TIME_H_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_discharge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_DISCHARGE_MASK),
				  (unsigned int)(PMIC_EVENT_FG_DISCHARGE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_charge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_CHARGE_MASK),
				  (unsigned int)(PMIC_EVENT_FG_CHARGE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_event_fg_zcv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_EVENT_FG_ZCV_MASK),
				  (unsigned int)(PMIC_EVENT_FG_ZCV_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_fg_osr1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_OSR1_MASK),
				    (unsigned int)(PMIC_FG_OSR1_SHIFT)
	    );

}

void mt6335_upmu_set_fg_osr2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_OSR2_MASK),
				    (unsigned int)(PMIC_FG_OSR2_SHIFT)
	    );

}

void mt6335_upmu_set_fg_fir1bypass(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_FIR1BYPASS_MASK),
				    (unsigned int)(PMIC_FG_FIR1BYPASS_SHIFT)
	    );

}

void mt6335_upmu_set_fg_fir2bypass(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_FIR2BYPASS_MASK),
				    (unsigned int)(PMIC_FG_FIR2BYPASS_SHIFT)
	    );

}

void mt6335_upmu_set_fg_adj_offset_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ADJ_OFFSET_EN_MASK),
				    (unsigned int)(PMIC_FG_ADJ_OFFSET_EN_SHIFT)
	    );

}

void mt6335_upmu_set_fg_adc_autorst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ADC_AUTORST_MASK),
				    (unsigned int)(PMIC_FG_ADC_AUTORST_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fg_adc_rstdetect(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CON4),
				  (&val),
				  (unsigned int)(PMIC_FG_ADC_RSTDETECT_MASK),
				  (unsigned int)(PMIC_FG_ADC_RSTDETECT_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_fg_va18_aon(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_VA18_AON_MASK),
				    (unsigned int)(PMIC_FG_VA18_AON_SHIFT)
	    );

}

void mt6335_upmu_set_fg_va18_aoff(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_VA18_AOFF_MASK),
				    (unsigned int)(PMIC_FG_VA18_AOFF_SHIFT)
	    );

}

void mt6335_upmu_set_fg_son_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SON_SW_MASK),
				    (unsigned int)(PMIC_FG_SON_SW_SHIFT)
	    );

}

void mt6335_upmu_set_fg_son_sw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SON_SW_MODE_MASK),
				    (unsigned int)(PMIC_FG_SON_SW_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_fgadc_con4_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FGADC_CON4_RSV_MASK),
				    (unsigned int)(PMIC_FGADC_CON4_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_fg_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_FG_RSTB_STATUS_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fg_r_curr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_R_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_R_CURR_MASK),
				  (unsigned int)(PMIC_FG_R_CURR_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_fg_current_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CUR_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_CURRENT_OUT_MASK),
				  (unsigned int)(PMIC_FG_CURRENT_OUT_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_fg_cur_lth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CUR_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_CUR_LTH_MASK),
				    (unsigned int)(PMIC_FG_CUR_LTH_SHIFT)
	    );

}

void mt6335_upmu_set_fg_cur_hth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CUR_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_CUR_HTH_MASK),
				    (unsigned int)(PMIC_FG_CUR_HTH_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fg_cic2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CUR_CON3),
				  (&val),
				  (unsigned int)(PMIC_FG_CIC2_MASK),
				  (unsigned int)(PMIC_FG_CIC2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_fg_car_31_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CAR_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_CAR_31_16_MASK),
				  (unsigned int)(PMIC_FG_CAR_31_16_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_fg_car_15_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_CAR_CON1),
				  (&val),
				  (unsigned int)(PMIC_FG_CAR_15_00_MASK),
				  (unsigned int)(PMIC_FG_CAR_15_00_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_fg_bat0_lth_31_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CAR_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BAT0_LTH_31_16_MASK),
				    (unsigned int)(PMIC_FG_BAT0_LTH_31_16_SHIFT)
	    );

}

void mt6335_upmu_set_fg_bat0_lth_15_14(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CAR_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BAT0_LTH_15_14_MASK),
				    (unsigned int)(PMIC_FG_BAT0_LTH_15_14_SHIFT)
	    );

}

void mt6335_upmu_set_fg_bat0_hth_31_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CAR_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BAT0_HTH_31_16_MASK),
				    (unsigned int)(PMIC_FG_BAT0_HTH_31_16_SHIFT)
	    );

}

void mt6335_upmu_set_fg_bat0_hth_15_14(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CAR_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BAT0_HTH_15_14_MASK),
				    (unsigned int)(PMIC_FG_BAT0_HTH_15_14_SHIFT)
	    );

}

void mt6335_upmu_set_fg_bat1_lth_31_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CAR_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BAT1_LTH_31_16_MASK),
				    (unsigned int)(PMIC_FG_BAT1_LTH_31_16_SHIFT)
	    );

}

void mt6335_upmu_set_fg_bat1_lth_15_14(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CAR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BAT1_LTH_15_14_MASK),
				    (unsigned int)(PMIC_FG_BAT1_LTH_15_14_SHIFT)
	    );

}

void mt6335_upmu_set_fg_bat1_hth_31_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CAR_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BAT1_HTH_31_16_MASK),
				    (unsigned int)(PMIC_FG_BAT1_HTH_31_16_SHIFT)
	    );

}

void mt6335_upmu_set_fg_bat1_hth_15_14(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_CAR_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BAT1_HTH_15_14_MASK),
				    (unsigned int)(PMIC_FG_BAT1_HTH_15_14_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fg_ncar_31_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_NCAR_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_NCAR_31_16_MASK),
				  (unsigned int)(PMIC_FG_NCAR_31_16_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_fg_ncar_15_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_NCAR_CON1),
				  (&val),
				  (unsigned int)(PMIC_FG_NCAR_15_00_MASK),
				  (unsigned int)(PMIC_FG_NCAR_15_00_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_fg_n_charge_lth_31_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_NCAR_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_N_CHARGE_LTH_31_16_MASK),
				    (unsigned int)(PMIC_FG_N_CHARGE_LTH_31_16_SHIFT)
	    );

}

void mt6335_upmu_set_fg_n_charge_lth_15_14(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_NCAR_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_N_CHARGE_LTH_15_14_MASK),
				    (unsigned int)(PMIC_FG_N_CHARGE_LTH_15_14_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fg_iavg_27_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_IAVG_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_IAVG_27_16_MASK),
				  (unsigned int)(PMIC_FG_IAVG_27_16_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_fg_iavg_vld(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_IAVG_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_IAVG_VLD_MASK),
				  (unsigned int)(PMIC_FG_IAVG_VLD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_fg_iavg_15_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_IAVG_CON1),
				  (&val),
				  (unsigned int)(PMIC_FG_IAVG_15_00_MASK),
				  (unsigned int)(PMIC_FG_IAVG_15_00_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_fg_iavg_lth_28_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_IAVG_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_IAVG_LTH_28_16_MASK),
				    (unsigned int)(PMIC_FG_IAVG_LTH_28_16_SHIFT)
	    );

}

void mt6335_upmu_set_fg_iavg_lth_15_00(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_IAVG_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_IAVG_LTH_15_00_MASK),
				    (unsigned int)(PMIC_FG_IAVG_LTH_15_00_SHIFT)
	    );

}

void mt6335_upmu_set_fg_iavg_hth_28_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_IAVG_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_IAVG_HTH_28_16_MASK),
				    (unsigned int)(PMIC_FG_IAVG_HTH_28_16_SHIFT)
	    );

}

void mt6335_upmu_set_fg_iavg_hth_15_00(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_IAVG_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_IAVG_HTH_15_00_MASK),
				    (unsigned int)(PMIC_FG_IAVG_HTH_15_00_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fg_nter_29_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_NTER_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_NTER_29_16_MASK),
				  (unsigned int)(PMIC_FG_NTER_29_16_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_fg_nter_15_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_NTER_CON1),
				  (&val),
				  (unsigned int)(PMIC_FG_NTER_15_00_MASK),
				  (unsigned int)(PMIC_FG_NTER_15_00_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_fg_time_hth_29_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_NTER_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_TIME_HTH_29_16_MASK),
				    (unsigned int)(PMIC_FG_TIME_HTH_29_16_SHIFT)
	    );

}

void mt6335_upmu_set_fg_time_hth_15_00(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_NTER_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_TIME_HTH_15_00_MASK),
				    (unsigned int)(PMIC_FG_TIME_HTH_15_00_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fg_offset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_OFFSET_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_OFFSET_MASK),
				  (unsigned int)(PMIC_FG_OFFSET_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_fg_adjust_offset_value(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_OFFSET_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ADJUST_OFFSET_VALUE_MASK),
				    (unsigned int)(PMIC_FG_ADJUST_OFFSET_VALUE_SHIFT)
	    );

}

void mt6335_upmu_set_fg_gain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_GAIN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_GAIN_MASK),
				    (unsigned int)(PMIC_FG_GAIN_SHIFT)
	    );

}

void mt6335_upmu_set_fg_son_slp_cur_th(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_SON_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SON_SLP_CUR_TH_MASK),
				    (unsigned int)(PMIC_FG_SON_SLP_CUR_TH_SHIFT)
	    );

}

void mt6335_upmu_set_fg_son_slp_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_SON_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SON_SLP_TIME_MASK),
				    (unsigned int)(PMIC_FG_SON_SLP_TIME_SHIFT)
	    );

}

void mt6335_upmu_set_fg_son_det_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_SON_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SON_DET_TIME_MASK),
				    (unsigned int)(PMIC_FG_SON_DET_TIME_SHIFT)
	    );

}

void mt6335_upmu_set_fg_fp_ftime(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_SON_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_FP_FTIME_MASK),
				    (unsigned int)(PMIC_FG_FP_FTIME_SHIFT)
	    );

}

void mt6335_upmu_set_fg_soff_slp_cur_th(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_SOFF_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SOFF_SLP_CUR_TH_MASK),
				    (unsigned int)(PMIC_FG_SOFF_SLP_CUR_TH_SHIFT)
	    );

}

void mt6335_upmu_set_fg_soff_slp_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_SOFF_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SOFF_SLP_TIME_MASK),
				    (unsigned int)(PMIC_FG_SOFF_SLP_TIME_SHIFT)
	    );

}

void mt6335_upmu_set_fg_soff_det_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_SOFF_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SOFF_DET_TIME_MASK),
				    (unsigned int)(PMIC_FG_SOFF_DET_TIME_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fg_soff_time_29_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_SOFF_CON3),
				  (&val),
				  (unsigned int)(PMIC_FG_SOFF_TIME_29_16_MASK),
				  (unsigned int)(PMIC_FG_SOFF_TIME_29_16_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_fg_soff(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_SOFF_CON3),
				  (&val),
				  (unsigned int)(PMIC_FG_SOFF_MASK),
				  (unsigned int)(PMIC_FG_SOFF_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_fg_soff_time_15_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_SOFF_CON4),
				  (&val),
				  (unsigned int)(PMIC_FG_SOFF_TIME_15_00_MASK),
				  (unsigned int)(PMIC_FG_SOFF_TIME_15_00_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_fg_pwr_time0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_PWR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_PWR_TIME0_MASK),
				    (unsigned int)(PMIC_FG_PWR_TIME0_SHIFT)
	    );

}

void mt6335_upmu_set_fg_pwr_time1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_PWR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_PWR_TIME1_MASK),
				    (unsigned int)(PMIC_FG_PWR_TIME1_SHIFT)
	    );

}

void mt6335_upmu_set_fg_pwr_time2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_PWR_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_PWR_TIME2_MASK),
				    (unsigned int)(PMIC_FG_PWR_TIME2_SHIFT)
	    );

}

void mt6335_upmu_set_fg_zcv_det_iv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_ZCV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ZCV_DET_IV_MASK),
				    (unsigned int)(PMIC_FG_ZCV_DET_IV_SHIFT)
	    );

}

void mt6335_upmu_set_fg_zcv_car_th_30_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_ZCV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ZCV_CAR_TH_30_16_MASK),
				    (unsigned int)(PMIC_FG_ZCV_CAR_TH_30_16_SHIFT)
	    );

}

void mt6335_upmu_set_fg_zcv_car_th_15_00(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_ZCV_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ZCV_CAR_TH_15_00_MASK),
				    (unsigned int)(PMIC_FG_ZCV_CAR_TH_15_00_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_fg_zcv_car_31_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_ZCV_CON3),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_CAR_31_16_MASK),
				  (unsigned int)(PMIC_FG_ZCV_CAR_31_16_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_fg_zcv_car_15_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_ZCV_CON4),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_CAR_15_00_MASK),
				  (unsigned int)(PMIC_FG_ZCV_CAR_15_00_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_fg_zcv_curr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_ZCV_CON5),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_CURR_MASK),
				  (unsigned int)(PMIC_FG_ZCV_CURR_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_fgadc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_FGADC_EN_MASK),
				  (unsigned int)(PMIC_DA_FGADC_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_fgcal_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_FGCAL_EN_MASK),
				  (unsigned int)(PMIC_DA_FGCAL_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_fg_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_FGADC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_FG_RST_MASK),
				  (unsigned int)(PMIC_DA_FG_RST_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_fganalogtest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGANALOGTEST_MASK),
				    (unsigned int)(PMIC_RG_FGANALOGTEST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fgrintmode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGRINTMODE_MASK),
				    (unsigned int)(PMIC_RG_FGRINTMODE_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fg_widecm_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FG_WIDECM_ENB_MASK),
				    (unsigned int)(PMIC_RG_FG_WIDECM_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_spare(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPARE_MASK),
				    (unsigned int)(PMIC_RG_SPARE_SHIFT)
	    );

}

void mt6335_upmu_set_fg_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_TEST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_MODE_MASK),
				    (unsigned int)(PMIC_FG_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_fg_rst_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_TEST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_RST_SW_MASK),
				    (unsigned int)(PMIC_FG_RST_SW_SHIFT)
	    );

}

void mt6335_upmu_set_fg_fgcal_en_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_TEST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_FGCAL_EN_SW_MASK),
				    (unsigned int)(PMIC_FG_FGCAL_EN_SW_SHIFT)
	    );

}

void mt6335_upmu_set_fg_fgadc_en_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_TEST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_FGADC_EN_SW_MASK),
				    (unsigned int)(PMIC_FG_FGADC_EN_SW_SHIFT)
	    );

}

void mt6335_upmu_set_fg_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_TEST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_RSV1_MASK),
				    (unsigned int)(PMIC_FG_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_fg_test_mode0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_TEST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_TEST_MODE0_MASK),
				    (unsigned int)(PMIC_FG_TEST_MODE0_SHIFT)
	    );

}

void mt6335_upmu_set_fg_test_mode1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_TEST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_TEST_MODE1_MASK),
				    (unsigned int)(PMIC_FG_TEST_MODE1_SHIFT)
	    );

}

void mt6335_upmu_set_fg_soff_rd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_RSV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SOFF_RD_MASK),
				    (unsigned int)(PMIC_FG_SOFF_RD_SHIFT)
	    );

}

void mt6335_upmu_set_fg_rsv_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_RSV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_RSV_CON0_RSV_MASK),
				    (unsigned int)(PMIC_FG_RSV_CON0_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_fg_rsv_con1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_RSV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_RSV_CON1_RSV_MASK),
				    (unsigned int)(PMIC_FG_RSV_CON1_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_fg_rsv_con2_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_RSV_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_RSV_CON2_RSV_MASK),
				    (unsigned int)(PMIC_FG_RSV_CON2_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_fg_rsv_con3_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_RSV_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_RSV_CON3_RSV_MASK),
				    (unsigned int)(PMIC_FG_RSV_CON3_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_system_info_con0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SYSTEM_INFO_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON0_MASK),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON0_SHIFT)
	    );

}

void mt6335_upmu_set_system_info_con1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SYSTEM_INFO_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON1_MASK),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON1_SHIFT)
	    );

}

void mt6335_upmu_set_system_info_con2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SYSTEM_INFO_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON2_MASK),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON2_SHIFT)
	    );

}

void mt6335_upmu_set_system_info_con3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SYSTEM_INFO_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON3_MASK),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON3_SHIFT)
	    );

}

void mt6335_upmu_set_system_info_con4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_SYSTEM_INFO_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON4_MASK),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON4_SHIFT)
	    );

}

void mt6335_upmu_set_rg_fgadc_gainerror_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_FGADC_EFUSE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGADC_GAINERROR_CAL_MASK),
				    (unsigned int)(PMIC_RG_FGADC_GAINERROR_CAL_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf1_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF1_MODE_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF1_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf1_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF1_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF1_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf2_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF2_MODE_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF2_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf2_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF2_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF2_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf3_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF3_MODE_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF3_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf3_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF3_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF3_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf4_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF4_MODE_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF4_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf4_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF4_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF4_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_bb_lpm_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_BB_LPM_EN_MASK),
				    (unsigned int)(PMIC_XO_BB_LPM_EN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_enbb_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_ENBB_MAN_MASK),
				    (unsigned int)(PMIC_XO_ENBB_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_enbb_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_ENBB_EN_M_MASK),
				    (unsigned int)(PMIC_XO_ENBB_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_clksel_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CLKSEL_MAN_MASK),
				    (unsigned int)(PMIC_XO_CLKSEL_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_clksel_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CLKSEL_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CLKSEL_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf1_ckg_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF1_CKG_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF1_CKG_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf1_ckg_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF1_CKG_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF1_CKG_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf2_ckg_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF2_CKG_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF2_CKG_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf2_ckg_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF2_CKG_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF2_CKG_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf3_ckg_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF3_CKG_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF3_CKG_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf3_ckg_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF3_CKG_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF3_CKG_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf4_ckg_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF4_CKG_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF4_CKG_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf4_ckg_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF4_CKG_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF4_CKG_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_intbuf_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_INTBUF_MAN_MASK),
				    (unsigned int)(PMIC_XO_INTBUF_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_pbuf_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_PBUF_EN_M_MASK),
				    (unsigned int)(PMIC_XO_PBUF_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_ibuf_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_IBUF_EN_M_MASK),
				    (unsigned int)(PMIC_XO_IBUF_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_lpmbuf_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LPMBUF_MAN_MASK),
				    (unsigned int)(PMIC_XO_LPMBUF_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_lpm_prebuf_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LPM_PREBUF_EN_M_MASK),
				    (unsigned int)(PMIC_XO_LPM_PREBUF_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_lpbuf_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LPBUF_EN_M_MASK),
				    (unsigned int)(PMIC_XO_LPBUF_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_bblpm_cksel_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_BBLPM_CKSEL_M_MASK),
				    (unsigned int)(PMIC_XO_BBLPM_CKSEL_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_en32k_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EN32K_MAN_MASK),
				    (unsigned int)(PMIC_XO_EN32K_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_en32k_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EN32K_M_MASK),
				    (unsigned int)(PMIC_XO_EN32K_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_xmode_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_XMODE_MAN_MASK),
				    (unsigned int)(PMIC_XO_XMODE_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_xmode_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_XMODE_M_MASK),
				    (unsigned int)(PMIC_XO_XMODE_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_strup_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_STRUP_MODE_MASK),
				    (unsigned int)(PMIC_XO_STRUP_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_fpm_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_FPM_TIME_MASK),
				    (unsigned int)(PMIC_XO_AAC_FPM_TIME_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_mode_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_MODE_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_MODE_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_mode_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_MODE_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_MODE_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_en26m_offsq_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EN26M_OFFSQ_EN_MASK),
				    (unsigned int)(PMIC_XO_EN26M_OFFSQ_EN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_ldocal_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LDOCAL_EN_MASK),
				    (unsigned int)(PMIC_XO_LDOCAL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_cbank_sync_dyn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_DYN_MASK),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_DYN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_26mlp_man_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_26MLP_MAN_EN_MASK),
				    (unsigned int)(PMIC_XO_26MLP_MAN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_bufldok_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_BUFLDOK_EN_MASK),
				    (unsigned int)(PMIC_XO_BUFLDOK_EN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf5_ckg_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF5_CKG_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF5_CKG_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf5_ckg_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF5_CKG_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF5_CKG_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf6_ckg_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF6_CKG_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF6_CKG_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf6_ckg_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF6_CKG_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF6_CKG_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf7_ckg_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF7_CKG_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF7_CKG_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf7_ckg_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF7_CKG_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF7_CKG_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_lpm_isel_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LPM_ISEL_MAN_MASK),
				    (unsigned int)(PMIC_XO_LPM_ISEL_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_fpm_isel_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_FPM_ISEL_MAN_MASK),
				    (unsigned int)(PMIC_XO_FPM_ISEL_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_cdac_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW04),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CDAC_FPM_MASK),
				    (unsigned int)(PMIC_XO_CDAC_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_cdac_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW04),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CDAC_LPM_MASK),
				    (unsigned int)(PMIC_XO_CDAC_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_32kdiv_nfrac_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW05),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_32KDIV_NFRAC_FPM_MASK),
				    (unsigned int)(PMIC_XO_32KDIV_NFRAC_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_cofst_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW05),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_COFST_FPM_MASK),
				    (unsigned int)(PMIC_XO_COFST_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_32kdiv_nfrac_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW06),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_32KDIV_NFRAC_LPM_MASK),
				    (unsigned int)(PMIC_XO_32KDIV_NFRAC_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_cofst_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW06),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_COFST_LPM_MASK),
				    (unsigned int)(PMIC_XO_COFST_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_MAN_MASK),
				    (unsigned int)(PMIC_XO_CORE_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CORE_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_turbo_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_TURBO_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CORE_TURBO_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_aac_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_AAC_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CORE_AAC_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_startup_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_STARTUP_EN_M_MASK),
				    (unsigned int)(PMIC_XO_STARTUP_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_vbfpm_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_VBFPM_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CORE_VBFPM_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_vblpm_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_VBLPM_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CORE_VBLPM_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_lpmbias_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LPMBIAS_EN_M_MASK),
				    (unsigned int)(PMIC_XO_LPMBIAS_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_vtcgen_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_VTCGEN_EN_M_MASK),
				    (unsigned int)(PMIC_XO_VTCGEN_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_iaac_comp_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_IAAC_COMP_EN_M_MASK),
				    (unsigned int)(PMIC_XO_IAAC_COMP_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_ifpm_comp_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_IFPM_COMP_EN_M_MASK),
				    (unsigned int)(PMIC_XO_IFPM_COMP_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_ilpm_comp_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_ILPM_COMP_EN_M_MASK),
				    (unsigned int)(PMIC_XO_ILPM_COMP_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_bypcas_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_BYPCAS_FPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_BYPCAS_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_gmx2_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_GMX2_FPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_GMX2_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_idac_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_IDAC_FPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_IDAC_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_comp_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_COMP_MAN_MASK),
				    (unsigned int)(PMIC_XO_AAC_COMP_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_EN_M_MASK),
				    (unsigned int)(PMIC_XO_AAC_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_monen_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_MONEN_M_MASK),
				    (unsigned int)(PMIC_XO_AAC_MONEN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_comp_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_COMP_EN_M_MASK),
				    (unsigned int)(PMIC_XO_COMP_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_comp_tsten_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_COMP_TSTEN_M_MASK),
				    (unsigned int)(PMIC_XO_COMP_TSTEN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_hv_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_HV_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_HV_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_ibias_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_IBIAS_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_IBIAS_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_vofst_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_VOFST_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_VOFST_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_comp_hv_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_COMP_HV_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_COMP_HV_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_vsel_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_VSEL_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_VSEL_FPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_comp_pol(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_COMP_POL_MASK),
				    (unsigned int)(PMIC_XO_AAC_COMP_POL_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_bypcas_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_BYPCAS_LPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_BYPCAS_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_gmx2_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_GMX2_LPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_GMX2_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_core_idac_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_IDAC_LPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_IDAC_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_comp_hv_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_COMP_HV_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_COMP_HV_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_vsel_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_VSEL_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_VSEL_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_hv_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_HV_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_HV_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_ibias_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_IBIAS_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_IBIAS_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_vofst_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_VOFST_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_VOFST_LPM_SHIFT)
	    );

}

void mt6335_upmu_set_xo_aac_fpm_swen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_FPM_SWEN_MASK),
				    (unsigned int)(PMIC_XO_AAC_FPM_SWEN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_swrst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_SWRST_MASK),
				    (unsigned int)(PMIC_XO_SWRST_SHIFT)
	    );

}

void mt6335_upmu_set_xo_32kdiv_swrst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_32KDIV_SWRST_MASK),
				    (unsigned int)(PMIC_XO_32KDIV_SWRST_SHIFT)
	    );

}

void mt6335_upmu_set_xo_32kdiv_ratio_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_32KDIV_RATIO_MAN_MASK),
				    (unsigned int)(PMIC_XO_32KDIV_RATIO_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_32kdiv_test_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_32KDIV_TEST_EN_MASK),
				    (unsigned int)(PMIC_XO_32KDIV_TEST_EN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_cbank_sync_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_MAN_MASK),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_cbank_sync_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_ctl_sync_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CTL_SYNC_MAN_MASK),
				    (unsigned int)(PMIC_XO_CTL_SYNC_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_ctl_sync_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CTL_SYNC_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CTL_SYNC_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_ldo_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LDO_MAN_MASK),
				    (unsigned int)(PMIC_XO_LDO_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_ldopbuf_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LDOPBUF_EN_M_MASK),
				    (unsigned int)(PMIC_XO_LDOPBUF_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_ldopbuf_vset_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LDOPBUF_VSET_M_MASK),
				    (unsigned int)(PMIC_XO_LDOPBUF_VSET_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_ldovtst_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LDOVTST_EN_M_MASK),
				    (unsigned int)(PMIC_XO_LDOVTST_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_test_vcal_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_TEST_VCAL_EN_M_MASK),
				    (unsigned int)(PMIC_XO_TEST_VCAL_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_vbist_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_VBIST_EN_M_MASK),
				    (unsigned int)(PMIC_XO_VBIST_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_vtest_sel_mux(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_VTEST_SEL_MUX_MASK),
				    (unsigned int)(PMIC_XO_VTEST_SEL_MUX_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf5_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF5_MODE_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF5_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf5_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF5_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF5_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf6_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF6_MODE_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF6_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf6_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF6_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF6_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf7_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF7_MODE_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF7_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf7_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF7_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF7_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_bufldok_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_BUFLDOK_MAN_MASK),
				    (unsigned int)(PMIC_XO_BUFLDOK_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_buf1ldo_cal_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_BUF1LDO_CAL_M_MASK),
				    (unsigned int)(PMIC_XO_BUF1LDO_CAL_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_bufldo_cal_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_BUFLDO_CAL_M_MASK),
				    (unsigned int)(PMIC_XO_BUFLDO_CAL_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf4_clksel_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF4_CLKSEL_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF4_CLKSEL_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_vio18pg_bufen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_VIO18PG_BUFEN_MASK),
				    (unsigned int)(PMIC_XO_VIO18PG_BUFEN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_cal_en_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CAL_EN_MAN_MASK),
				    (unsigned int)(PMIC_XO_CAL_EN_MAN_SHIFT)
	    );

}

void mt6335_upmu_set_xo_cal_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CAL_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CAL_EN_M_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_core_osctd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_CORE_OSCTD_MASK),
				    (unsigned int)(PMIC_RG_XO_CORE_OSCTD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_thadc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_THADC_EN_MASK),
				    (unsigned int)(PMIC_RG_XO_THADC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_sync_ckpol(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_SYNC_CKPOL_MASK),
				    (unsigned int)(PMIC_RG_XO_SYNC_CKPOL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_cbank_pol(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_CBANK_POL_MASK),
				    (unsigned int)(PMIC_RG_XO_CBANK_POL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_cbank_sync_byp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_CBANK_SYNC_BYP_MASK),
				    (unsigned int)(PMIC_RG_XO_CBANK_SYNC_BYP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_ctl_pol(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_CTL_POL_MASK),
				    (unsigned int)(PMIC_RG_XO_CTL_POL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_ctl_sync_byp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_CTL_SYNC_BYP_MASK),
				    (unsigned int)(PMIC_RG_XO_CTL_SYNC_BYP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_lpbuf_inv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_LPBUF_INV_MASK),
				    (unsigned int)(PMIC_RG_XO_LPBUF_INV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_ldopbuf_byp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_LDOPBUF_BYP_MASK),
				    (unsigned int)(PMIC_RG_XO_LDOPBUF_BYP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_ldopbuf_encl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_LDOPBUF_ENCL_MASK),
				    (unsigned int)(PMIC_RG_XO_LDOPBUF_ENCL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_vgbias_vset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_VGBIAS_VSET_MASK),
				    (unsigned int)(PMIC_RG_XO_VGBIAS_VSET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_pbuf_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_PBUF_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_PBUF_ISET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_ibuf_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_IBUF_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_IBUF_ISET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo1_encl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO1_ENCL_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO1_ENCL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo1_ibx2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO1_IBX2_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO1_IBX2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo1_ix2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO1_IX2_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO1_IX2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo1_vset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO1_VSET_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO1_VSET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo24_encl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO24_ENCL_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO24_ENCL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo24_ibx2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO24_IBX2_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO24_IBX2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo24_vset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO24_VSET_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO24_VSET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo35_encl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO35_ENCL_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO35_ENCL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo35_ibx2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO35_IBX2_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO35_IBX2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo35_ix2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO35_IX2_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO35_IX2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo35_vset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO35_VSET_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO35_VSET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo67_encl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO67_ENCL_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO67_ENCL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo67_ibx2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO67_IBX2_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO67_IBX2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo67_ix2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO67_IX2_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO67_IX2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_bufldo67_vset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO67_VSET_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO67_VSET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_extbuf_inv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF_INV_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF_INV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_reserved0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_RESERVED0_MASK),
				    (unsigned int)(PMIC_RG_XO_RESERVED0_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_audio_atten(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_AUDIO_ATTEN_MASK),
				    (unsigned int)(PMIC_RG_XO_AUDIO_ATTEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_audio_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_AUDIO_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_AUDIO_ISET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_extbuf1_hd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF1_HD_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF1_HD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_extbuf2_hd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF2_HD_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF2_HD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_extbuf3_hd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF3_HD_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF3_HD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_extbuf4_hd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF4_HD_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF4_HD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_extbuf5_hd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF5_HD_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF5_HD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_extbuf6_hd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF6_HD_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF6_HD_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_extbuf7_hd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF7_HD_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF7_HD_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf1_iset_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF1_ISET_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF1_ISET_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf2_iset_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF2_ISET_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF2_ISET_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf3_iset_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF3_ISET_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF3_ISET_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf4_iset_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF4_ISET_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF4_ISET_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf5_iset_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF5_ISET_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF5_ISET_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf6_iset_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF6_ISET_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF6_ISET_M_SHIFT)
	    );

}

void mt6335_upmu_set_xo_extbuf7_iset_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF7_ISET_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF7_ISET_M_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_lpm_prebuf_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_LPM_PREBUF_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_LPM_PREBUF_ISET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_xo_reserved1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_RESERVED1_MASK),
				    (unsigned int)(PMIC_RG_XO_RESERVED1_SHIFT)
	    );

}

void mt6335_upmu_set_xo_static_auxout_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_STATIC_AUXOUT_SEL_MASK),
				    (unsigned int)(PMIC_XO_STATIC_AUXOUT_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_xo_auxout_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_DCXO_CW18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AUXOUT_SEL_MASK),
				    (unsigned int)(PMIC_XO_AUXOUT_SEL_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_xo_static_auxout(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_DCXO_CW19),
				  (&val),
				  (unsigned int)(PMIC_XO_STATIC_AUXOUT_MASK),
				  (unsigned int)(PMIC_XO_STATIC_AUXOUT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH3_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH3_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH3_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH3_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH4_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH4_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH4_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH4_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH5_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH5_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH5_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH5_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch6(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH6_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH6_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch6(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH6_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH6_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch7(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch7(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch8(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC8),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH8_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH8_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch8(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC8),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH8_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH8_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch9(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC9),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH9_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH9_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch9(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC9),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH9_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH9_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch10(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH10_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH10_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch10(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH10_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH10_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch11(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC11),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH11_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH11_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch11(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC11),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH11_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH11_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch12_15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC12),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH12_15_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH12_15_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch12_15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC12),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH12_15_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH12_15_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_thr_hw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_THR_HW_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_THR_HW_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_thr_hw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_THR_HW_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_THR_HW_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_lbat(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_LBAT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_LBAT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_lbat(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_LBAT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_LBAT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_lbat2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_LBAT2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_LBAT2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_lbat2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_LBAT2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_LBAT2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch7_by_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC16),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch7_by_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC16),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch7_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC17),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch7_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC17),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch7_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC18),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch7_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC18),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch4_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC19),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH4_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH4_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch4_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC19),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH4_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH4_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_wakeup_pchr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC20),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_WAKEUP_PCHR_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_WAKEUP_PCHR_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_wakeup_pchr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC20),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_PCHR_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_PCHR_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_wakeup_swchr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC21),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_WAKEUP_SWCHR_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_WAKEUP_SWCHR_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_wakeup_swchr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC21),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_SWCHR_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_SWCHR_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch0_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC22),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch0_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC22),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch0_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC23),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch0_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC23),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch1_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC24),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch1_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC24),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_ch1_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC25),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_ch1_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC25),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_bat_temp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC26),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_BAT_TEMP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_BAT_TEMP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_bat_temp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC26),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_BAT_TEMP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_BAT_TEMP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_fgadc1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC27),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_FGADC1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_FGADC1_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_fgadc1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC27),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_FGADC1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_FGADC1_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_fgadc2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC28),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_FGADC2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_FGADC2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_fgadc2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC28),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_FGADC2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_FGADC2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_bat_plugin1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC29),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_BAT_PLUGIN1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_BAT_PLUGIN1_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_bat_plugin1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC29),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_BAT_PLUGIN1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_BAT_PLUGIN1_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_bat_plugin2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC30),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_BAT_PLUGIN2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_BAT_PLUGIN2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_bat_plugin2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC30),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_BAT_PLUGIN2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_BAT_PLUGIN2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_imp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC31),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_IMP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_IMP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_imp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC31),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_IMP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_IMP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_imp_avg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC32),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_IMP_AVG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_IMP_AVG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_imp_avg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC32),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_IMP_AVG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_IMP_AVG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_raw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC33),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_RAW_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_RAW_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC34),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC34),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_mdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC35),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_MDBG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_MDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_mdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC35),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_MDBG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_MDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_jeita(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC36),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_JEITA_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_JEITA_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_jeita(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC36),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_JEITA_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_JEITA_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_dcxo_by_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC37),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_dcxo_by_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC37),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_dcxo_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC38),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_dcxo_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC38),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_dcxo_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC39),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_dcxo_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC39),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_dcxo_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC40),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_dcxo_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC40),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_nag(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC41),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_NAG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_NAG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_nag(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC41),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_NAG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_NAG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_out_batid(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC42),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_BATID_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_BATID_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_rdy_batid(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ADC42),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_BATID_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_BATID_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_00_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_00_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_00_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_00_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_01(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_01_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_01_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_01(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_01_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_01_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_02(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_02_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_02_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_02(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_02_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_02_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_03(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_03_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_03_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_03(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_03_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_03_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_04(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_04_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_04_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_04(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_04_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_04_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_05(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_05_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_05_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_05(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_05_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_05_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_06(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_06_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_06_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_06(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_06_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_06_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_07(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_07_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_07_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_07(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_07_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_07_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_08(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF8),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_08_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_08_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_08(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF8),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_08_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_08_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_09(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF9),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_09_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_09_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_09(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF9),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_09_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_09_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_10(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_10_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_10_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_10(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_10_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_10_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_11(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF11),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_11_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_11_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_11(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF11),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_11_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_11_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF12),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_12_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_12_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF12),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_12_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_12_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_13(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_13_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_13_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_13(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_13_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_13_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_14(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_14_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_14_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_14(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_14_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_14_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_15_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_15_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_15_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_15_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF16),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_16_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_16_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF16),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_16_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_16_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_17(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF17),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_17_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_17_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_17(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF17),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_17_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_17_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF18),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_18_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_18_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF18),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_18_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_18_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_19(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF19),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_19_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_19_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_19(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF19),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_19_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_19_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_20(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF20),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_20_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_20_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_20(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF20),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_20_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_20_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_21(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF21),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_21_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_21_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_21(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF21),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_21_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_21_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_22(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF22),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_22_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_22_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_22(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF22),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_22_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_22_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_23(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF23),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_23_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_23_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_23(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF23),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_23_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_23_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_24(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF24),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_24_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_24_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_24(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF24),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_24_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_24_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_25(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF25),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_25_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_25_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_25(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF25),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_25_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_25_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_26(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF26),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_26_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_26_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_26(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF26),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_26_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_26_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_27(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF27),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_27_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_27_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_27(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF27),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_27_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_27_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF28),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_28_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_28_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF28),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_28_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_28_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_29(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF29),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_29_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_29_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_29(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF29),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_29_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_29_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_30(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF30),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_30_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_30_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_30(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF30),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_30_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_30_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_out_31(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF31),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_31_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_31_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_buf_rdy_31(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BUF31),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_31_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_31_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_lbat(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_LBAT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_LBAT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_lbat2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_LBAT2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_LBAT2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_bat_temp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_BAT_TEMP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_BAT_TEMP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_wakeup(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_WAKEUP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_WAKEUP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_dcxo_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_dcxo_gps_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_dcxo_gps_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_dcxo_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_jeita(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_JEITA_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_JEITA_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_mdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_MDBG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_MDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_share(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_SHARE_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_SHARE_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_imp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_IMP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_IMP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_fgadc1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_FGADC1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_FGADC1_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_fgadc2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_FGADC2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_FGADC2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_gps_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_gps_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_thr_hw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_THR_HW_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_THR_HW_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_thr_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_THR_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_THR_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_bat_plugin1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_BAT_PLUGIN1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_BAT_PLUGIN1_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_bat_plugin2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_BAT_PLUGIN2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_BAT_PLUGIN2_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_batid(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_BATID_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_BATID_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_adc_busy_in_nag(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_STA2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_NAG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_NAG_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_rqst_ch0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH0_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH1_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH1_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH2_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH2_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH3_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH3_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH4_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH4_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH5_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH5_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch6(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH6_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH6_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch7(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch8(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH8_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH8_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch9(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH9_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH9_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch10(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH10_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH10_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch11(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH11_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH11_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch12(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH12_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH12_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch13(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH13_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH13_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch14(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH14_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH14_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH15_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH15_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch0_by_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH0_BY_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH0_BY_MD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch1_by_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH1_BY_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH1_BY_MD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_batid(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_BATID_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_BATID_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch4_by_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH4_BY_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH4_BY_MD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch7_by_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_MD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_ch7_by_gps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_GPS_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_GPS_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_dcxo_by_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_MD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_dcxo_by_gps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_GPS_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_GPS_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rqst_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_RSV1_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_ck_on_extd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CK_ON_EXTD_MASK),
				    (unsigned int)(PMIC_AUXADC_CK_ON_EXTD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_srclken_src_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SRCLKEN_SRC_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_SRCLKEN_SRC_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adc_pwdb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_PWDB_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_PWDB_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adc_pwdb_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_PWDB_SWCTRL_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_PWDB_SWCTRL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_strup_ck_on_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_STRUP_CK_ON_ENB_MASK),
				    (unsigned int)(PMIC_AUXADC_STRUP_CK_ON_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_srclken_ck_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SRCLKEN_CK_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_SRCLKEN_CK_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_ck_aon_gps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CK_AON_GPS_MASK),
				    (unsigned int)(PMIC_AUXADC_CK_AON_GPS_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_ck_aon_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CK_AON_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_CK_AON_MD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_ck_aon(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CK_AON_MASK),
				    (unsigned int)(PMIC_AUXADC_CK_AON_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_avg_num_small(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SMALL_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SMALL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_avg_num_large(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_LARGE_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_LARGE_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_avg_num_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_avg_num_sel_share(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_SHARE_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_SHARE_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_avg_num_sel_lbat(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_LBAT_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_LBAT_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_avg_num_sel_bat_temp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_BAT_TEMP_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_BAT_TEMP_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_avg_num_sel_wakeup(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_WAKEUP_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_WAKEUP_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num_large(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_LARGE_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_LARGE_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num_sleep_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num_sel_share(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_SHARE_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_SHARE_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num_sel_lbat(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_LBAT_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_LBAT_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num_sel_bat_temp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_BAT_TEMP_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_BAT_TEMP_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num_sel_wakeup(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_WAKEUP_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_WAKEUP_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num_ch0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_CH0_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_CH0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num_ch3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_CH3_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_CH3_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_spl_num_ch7(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_CH7_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_CH7_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_avg_num_lbat(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_LBAT_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_LBAT_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_avg_num_ch7(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_CH7_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_CH7_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_avg_num_ch3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_CH3_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_CH3_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_avg_num_ch0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_CH0_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_CH0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch0_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH0_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH0_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH1_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH1_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH2_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH2_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch3_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH3_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH3_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch4_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH4_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH4_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch5_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH5_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH5_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch6_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH6_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH6_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch7_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH7_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH7_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch8_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH8_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH8_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch9_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH9_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH9_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch10_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH10_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH10_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_trim_ch11_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH11_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH11_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adc_2s_comp_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_2S_COMP_ENB_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_2S_COMP_ENB_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adc_trim_comp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_TRIM_COMP_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_TRIM_COMP_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_sw_gain_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SW_GAIN_TRIM_MASK),
				    (unsigned int)(PMIC_AUXADC_SW_GAIN_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_sw_offset_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SW_OFFSET_TRIM_MASK),
				    (unsigned int)(PMIC_AUXADC_SW_OFFSET_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rng_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RNG_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_RNG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_test_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TEST_MODE_MASK),
				    (unsigned int)(PMIC_AUXADC_TEST_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bit_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BIT_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_BIT_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_start_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_START_SW_MASK),
				    (unsigned int)(PMIC_AUXADC_START_SW_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_start_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_START_SWCTRL_MASK),
				    (unsigned int)(PMIC_AUXADC_START_SWCTRL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_ts_vbe_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_ts_vbe_sel_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_SWCTRL_MASK),
				    (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_SWCTRL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_vbuf_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VBUF_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_VBUF_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_vbuf_en_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VBUF_EN_SWCTRL_MASK),
				    (unsigned int)(PMIC_AUXADC_VBUF_EN_SWCTRL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_out_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_OUT_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_OUT_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_da_dac(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DA_DAC_MASK),
				    (unsigned int)(PMIC_AUXADC_DA_DAC_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_da_dac_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DA_DAC_SWCTRL_MASK),
				    (unsigned int)(PMIC_AUXADC_DA_DAC_SWCTRL_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_ad_auxadc_comp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_CON15),
				  (&val),
				  (unsigned int)(PMIC_AD_AUXADC_COMP_MASK),
				  (unsigned int)(PMIC_AD_AUXADC_COMP_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vbuf_exten(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBUF_EXTEN_MASK),
				    (unsigned int)(PMIC_RG_VBUF_EXTEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbuf_calen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBUF_CALEN_MASK),
				    (unsigned int)(PMIC_RG_VBUF_CALEN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vbuf_byp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBUF_BYP_MASK),
				    (unsigned int)(PMIC_RG_VBUF_BYP_SHIFT)
	    );

}

void mt6335_upmu_set_rg_aux_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUX_RSV_MASK),
				    (unsigned int)(PMIC_RG_AUX_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_auxadc_cali(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_CALI_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_CALI_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adcin_vsen_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adcin_vbat_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VBAT_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VBAT_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adcin_vsen_mux_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_MUX_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_MUX_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adcin_vsen_ext_baton_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EXT_BATON_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EXT_BATON_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adcin_chr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_CHR_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_CHR_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adcin_baton_tdet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_BATON_TDET_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_BATON_TDET_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_accdet_anaswctrl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ACCDET_ANASWCTRL_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ACCDET_ANASWCTRL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_xo_thadc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_XO_THADC_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_XO_THADC_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adcin_batid_sw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_BATID_SW_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_BATID_SW_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dig0_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DIG0_RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_DIG0_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_chsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CHSEL_MASK),
				    (unsigned int)(PMIC_AUXADC_CHSEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_swctrl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SWCTRL_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_SWCTRL_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_source_lbat_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SOURCE_LBAT_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_SOURCE_LBAT_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_source_lbat2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SOURCE_LBAT2_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_SOURCE_LBAT2_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_start_extd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_START_EXTD_MASK),
				    (unsigned int)(PMIC_AUXADC_START_EXTD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dac_extd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DAC_EXTD_MASK),
				    (unsigned int)(PMIC_AUXADC_DAC_EXTD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dac_extd_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DAC_EXTD_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_DAC_EXTD_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_pmu_thr_pdn_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON19),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SW_MASK),
				    (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SW_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_pmu_thr_pdn_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON19),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SEL_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_pmu_thr_pdn_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_CON19),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_STATUS_MASK),
				  (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_dig0_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON19),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DIG0_RSV1_MASK),
				    (unsigned int)(PMIC_AUXADC_DIG0_RSV1_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_start_shade_num(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON20),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_NUM_MASK),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_NUM_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_start_shade_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON20),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_start_shade_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON20),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adc_rdy_wakeup_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON21),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_CLR_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adc_rdy_fgadc_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON21),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_RDY_FGADC_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_RDY_FGADC_CLR_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_adc_rdy_bat_plugin_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON21),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_RDY_BAT_PLUGIN_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_RDY_BAT_PLUGIN_CLR_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_data_reuse_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON22),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DATA_REUSE_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_DATA_REUSE_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_ch0_data_reuse_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON22),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CH0_DATA_REUSE_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_CH0_DATA_REUSE_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_ch1_data_reuse_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON22),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CH1_DATA_REUSE_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_CH1_DATA_REUSE_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dcxo_data_reuse_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON22),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_DATA_REUSE_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_DATA_REUSE_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_data_reuse_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON22),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DATA_REUSE_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_DATA_REUSE_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_ch0_data_reuse_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON22),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CH0_DATA_REUSE_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_CH0_DATA_REUSE_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_ch1_data_reuse_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON22),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CH1_DATA_REUSE_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_CH1_DATA_REUSE_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dcxo_data_reuse_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_CON22),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_DATA_REUSE_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_DATA_REUSE_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_autorpt_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_AUTORPT0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AUTORPT_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_AUTORPT_PRD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_autorpt_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_AUTORPT0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AUTORPT_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_AUTORPT_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat_debt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat_debt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat_det_prd_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_15_0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat_det_prd_19_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_19_16_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_19_16_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat_volt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat_irq_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_EN_MAX_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_lbat_max_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_LBAT3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_MAX_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_MAX_IRQ_B_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_lbat_volt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat_irq_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_EN_MIN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_lbat_min_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_LBAT4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_MIN_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_MIN_IRQ_B_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_lbat_debounce_count_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_LBAT5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBOUNCE_COUNT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBOUNCE_COUNT_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_lbat_debounce_count_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_LBAT6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBOUNCE_COUNT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBOUNCE_COUNT_MIN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_accdet_auto_spl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_ACCDET),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_SPL_MASK),
				    (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_SPL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_accdet_auto_rqst_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_ACCDET),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_RQST_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_RQST_CLR_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_accdet_dig1_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_ACCDET),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ACCDET_DIG1_RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_ACCDET_DIG1_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_accdet_dig0_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_ACCDET),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ACCDET_DIG0_RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_ACCDET_DIG0_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_thr_debt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_THR0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_DEBT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_DEBT_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_thr_debt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_THR0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_DEBT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_DEBT_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_thr_det_prd_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_THR1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_DET_PRD_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_DET_PRD_15_0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_thr_det_prd_19_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_THR2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_DET_PRD_19_16_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_DET_PRD_19_16_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_thr_volt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_THR3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_VOLT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_VOLT_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_thr_irq_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_THR3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_thr_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_THR3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_EN_MAX_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_thr_max_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_THR3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_MAX_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_MAX_IRQ_B_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_thr_volt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_THR4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_VOLT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_VOLT_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_thr_irq_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_THR4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_thr_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_THR4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_EN_MIN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_thr_min_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_THR4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_MIN_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_MIN_IRQ_B_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_thr_debounce_count_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_THR5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_DEBOUNCE_COUNT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_DEBOUNCE_COUNT_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_thr_debounce_count_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_THR6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_DEBOUNCE_COUNT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_DEBOUNCE_COUNT_MIN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_efuse_gain_ch4_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH4_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH4_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_efuse_offset_ch4_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH4_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH4_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_efuse_gain_ch0_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH0_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH0_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_efuse_offset_ch0_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH0_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH0_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_efuse_gain_ch7_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH7_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH7_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_efuse_offset_ch7_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH7_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH7_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_fgadc_start_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_FGADC_START_SW_MASK),
				    (unsigned int)(PMIC_AUXADC_FGADC_START_SW_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_fgadc_start_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_FGADC_START_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_FGADC_START_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_fgadc_r_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_FGADC_R_SW_MASK),
				    (unsigned int)(PMIC_AUXADC_FGADC_R_SW_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_fgadc_r_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_FGADC_R_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_FGADC_R_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_plugin_start_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_PLUGIN_START_SW_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_PLUGIN_START_SW_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_plugin_start_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_PLUGIN_START_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_PLUGIN_START_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dbg_dig0_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DBG_DIG0_RSV2_MASK),
				    (unsigned int)(PMIC_AUXADC_DBG_DIG0_RSV2_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dbg_dig1_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DBG_DIG1_RSV2_MASK),
				    (unsigned int)(PMIC_AUXADC_DBG_DIG1_RSV2_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_impedance_cnt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_IMP0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_CNT_MASK),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_CNT_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_impedance_chsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_IMP0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_CHSEL_MASK),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_CHSEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_impedance_irq_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_IMP0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_IRQ_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_IRQ_CLR_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_impedance_irq_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_IMP0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_IRQ_STATUS_MASK),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_IRQ_STATUS_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_clr_imp_cnt_stop(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_IMP0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CLR_IMP_CNT_STOP_MASK),
				    (unsigned int)(PMIC_AUXADC_CLR_IMP_CNT_STOP_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_impedance_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_IMP0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_MODE_MASK),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_imp_autorpt_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_IMP1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_PRD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_imp_autorpt_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_IMP1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_temp_froze_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_FROZE_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_FROZE_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_temp_debt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_DEBT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_DEBT_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_temp_debt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_DEBT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_DEBT_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_temp_det_prd_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_DET_PRD_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_DET_PRD_15_0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_temp_det_prd_19_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_DET_PRD_19_16_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_DET_PRD_19_16_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_temp_volt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_VOLT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_VOLT_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_temp_irq_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_IRQ_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_IRQ_EN_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_temp_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_EN_MAX_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_bat_temp_max_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BAT_TEMP_MAX_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_BAT_TEMP_MAX_IRQ_B_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_bat_temp_volt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_VOLT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_VOLT_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_temp_irq_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_IRQ_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_IRQ_EN_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_bat_temp_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_BAT_TEMP_EN_MIN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_bat_temp_min_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BAT_TEMP_MIN_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_BAT_TEMP_MIN_IRQ_B_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_bat_temp_debounce_count_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_6),
				  (&val),
				  (unsigned
				   int)(PMIC_AUXADC_BAT_TEMP_DEBOUNCE_COUNT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_BAT_TEMP_DEBOUNCE_COUNT_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_bat_temp_debounce_count_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_BAT_TEMP_7),
				  (&val),
				  (unsigned
				   int)(PMIC_AUXADC_BAT_TEMP_DEBOUNCE_COUNT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_BAT_TEMP_DEBOUNCE_COUNT_MIN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_lbat2_debt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT2_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat2_debt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT2_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat2_det_prd_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT2_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_15_0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat2_det_prd_19_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT2_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_19_16_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_19_16_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat2_volt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT2_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat2_irq_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT2_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MAX_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat2_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT2_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_EN_MAX_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_lbat2_max_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_LBAT2_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_MAX_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_MAX_IRQ_B_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_lbat2_volt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT2_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat2_irq_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT2_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MIN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_lbat2_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_LBAT2_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_EN_MIN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_lbat2_min_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_LBAT2_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_MIN_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_MIN_IRQ_B_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_lbat2_debounce_count_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_LBAT2_6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBOUNCE_COUNT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBOUNCE_COUNT_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_lbat2_debounce_count_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_LBAT2_7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBOUNCE_COUNT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBOUNCE_COUNT_MIN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_mdbg_det_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDBG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDBG_DET_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_MDBG_DET_PRD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdbg_det_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDBG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDBG_DET_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_MDBG_DET_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_mdbg_r_ptr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_MDBG_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDBG_R_PTR_MASK),
				  (unsigned int)(PMIC_AUXADC_MDBG_R_PTR_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_mdbg_w_ptr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_MDBG_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDBG_W_PTR_MASK),
				  (unsigned int)(PMIC_AUXADC_MDBG_W_PTR_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_mdbg_buf_length(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDBG_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDBG_BUF_LENGTH_MASK),
				    (unsigned int)(PMIC_AUXADC_MDBG_BUF_LENGTH_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdrt_det_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDRT_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_PRD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdrt_det_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDRT_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdrt_det_wkup_start_cnt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDRT_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CNT_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CNT_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdrt_det_wkup_start_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDRT_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CLR_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdrt_det_wkup_start(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdrt_det_wkup_start_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdrt_det_wkup_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdrt_det_srclken_ind(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_SRCLKEN_IND_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_SRCLKEN_IND_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdrt_det_rdy_st_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDRT_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_RDY_ST_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_RDY_ST_PRD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdrt_det_rdy_st_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDRT_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_RDY_ST_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_RDY_ST_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_mdrt_det_start_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_MDRT_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_START_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_START_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_jeita_irq_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_JEITA_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_JEITA_IRQ_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_JEITA_IRQ_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_jeita_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_JEITA_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_JEITA_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_JEITA_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_jeita_det_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_JEITA_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_JEITA_DET_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_JEITA_DET_PRD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_jeita_debt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_JEITA_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_JEITA_DEBT_MASK),
				    (unsigned int)(PMIC_AUXADC_JEITA_DEBT_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_jeita_mipi_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_JEITA_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_JEITA_MIPI_DIS_MASK),
				    (unsigned int)(PMIC_AUXADC_JEITA_MIPI_DIS_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_jeita_froze_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_JEITA_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_JEITA_FROZE_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_JEITA_FROZE_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_jeita_volt_hot(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_JEITA_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_JEITA_VOLT_HOT_MASK),
				    (unsigned int)(PMIC_AUXADC_JEITA_VOLT_HOT_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_jeita_hot_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_JEITA_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_JEITA_HOT_IRQ_MASK),
				  (unsigned int)(PMIC_AUXADC_JEITA_HOT_IRQ_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_jeita_volt_warm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_JEITA_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_JEITA_VOLT_WARM_MASK),
				    (unsigned int)(PMIC_AUXADC_JEITA_VOLT_WARM_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_jeita_warm_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_JEITA_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_JEITA_WARM_IRQ_MASK),
				  (unsigned int)(PMIC_AUXADC_JEITA_WARM_IRQ_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_jeita_volt_cool(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_JEITA_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_JEITA_VOLT_COOL_MASK),
				    (unsigned int)(PMIC_AUXADC_JEITA_VOLT_COOL_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_jeita_cool_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_JEITA_3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_JEITA_COOL_IRQ_MASK),
				  (unsigned int)(PMIC_AUXADC_JEITA_COOL_IRQ_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_jeita_volt_cold(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_JEITA_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_JEITA_VOLT_COLD_MASK),
				    (unsigned int)(PMIC_AUXADC_JEITA_VOLT_COLD_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_jeita_cold_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_JEITA_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_JEITA_COLD_IRQ_MASK),
				  (unsigned int)(PMIC_AUXADC_JEITA_COLD_IRQ_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_jeita_debounce_count_cold(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_JEITA_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_JEITA_DEBOUNCE_COUNT_COLD_MASK),
				  (unsigned int)(PMIC_AUXADC_JEITA_DEBOUNCE_COUNT_COLD_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_jeita_debounce_count_cool(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_JEITA_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_JEITA_DEBOUNCE_COUNT_COOL_MASK),
				  (unsigned int)(PMIC_AUXADC_JEITA_DEBOUNCE_COUNT_COOL_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_jeita_debounce_count_warm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_JEITA_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_JEITA_DEBOUNCE_COUNT_WARM_MASK),
				  (unsigned int)(PMIC_AUXADC_JEITA_DEBOUNCE_COUNT_WARM_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_jeita_debounce_count_hot(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_JEITA_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_JEITA_DEBOUNCE_COUNT_HOT_MASK),
				  (unsigned int)(PMIC_AUXADC_JEITA_DEBOUNCE_COUNT_HOT_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_dcxo_mdrt_det_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DCXO_MDRT_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_PRD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dcxo_mdrt_det_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DCXO_MDRT_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dcxo_mdrt_det_wkup_start_cnt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DCXO_MDRT_1),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dcxo_mdrt_det_wkup_start_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DCXO_MDRT_1),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CLR_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dcxo_mdrt_det_wkup_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DCXO_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dcxo_mdrt_det_wkup_start_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DCXO_MDRT_2),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dcxo_mdrt_det_wkup_start(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DCXO_MDRT_2),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dcxo_mdrt_det_srclken_ind(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DCXO_MDRT_2),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_AUXADC_DCXO_MDRT_DET_SRCLKEN_IND_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_SRCLKEN_IND_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_dcxo_ch4_mux_ap_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_DCXO_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_CH4_MUX_AP_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_CH4_MUX_AP_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_nag_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_NAG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_nag_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_NAG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_CLR_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_nag_vbat1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_NAG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_VBAT1_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_VBAT1_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_nag_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_NAG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_PRD_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_nag_irq_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_NAG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_IRQ_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_IRQ_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_nag_c_dltv_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_NAG_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_IRQ_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_IRQ_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_nag_zcv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_NAG_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_ZCV_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_ZCV_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_nag_c_dltv_th_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_NAG_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_15_0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_nag_c_dltv_th_26_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_NAG_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_26_16_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_26_16_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_auxadc_nag_cnt_15_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_NAG_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_CNT_15_0_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_CNT_15_0_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_nag_cnt_25_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_NAG_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_CNT_25_16_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_CNT_25_16_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_nag_dltv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_NAG_6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_DLTV_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_DLTV_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_nag_c_dltv_15_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_NAG_7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_15_0_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_15_0_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_auxadc_nag_c_dltv_26_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_NAG_8),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_26_16_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_26_16_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_auxadc_efuse_degc_cali(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_EFUSE_DEGC_CALI_MASK),
				    (unsigned int)(PMIC_AUXADC_EFUSE_DEGC_CALI_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_efuse_adc_cali_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_EFUSE_ADC_CALI_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_EFUSE_ADC_CALI_EN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_efuse_1rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_EFUSE_1RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_EFUSE_1RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_efuse_o_vts(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_EFUSE_O_VTS_MASK),
				    (unsigned int)(PMIC_AUXADC_EFUSE_O_VTS_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_efuse_2rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_EFUSE_2RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_EFUSE_2RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_efuse_o_slope(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_EFUSE_O_SLOPE_MASK),
				    (unsigned int)(PMIC_AUXADC_EFUSE_O_SLOPE_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_efuse_o_slope_sign(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_EFUSE_O_SLOPE_SIGN_MASK),
				    (unsigned int)(PMIC_AUXADC_EFUSE_O_SLOPE_SIGN_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_efuse_3rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_EFUSE_3RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_EFUSE_3RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_efuse_auxadc_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_EFUSE_AUXADC_RSV_MASK),
				    (unsigned int)(PMIC_AUXADC_EFUSE_AUXADC_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_efuse_id(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_EFUSE_ID_MASK),
				    (unsigned int)(PMIC_AUXADC_EFUSE_ID_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_efuse_4rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_EFUSE_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_EFUSE_4RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_EFUSE_4RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_auxadc_rsv_1rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_AUXADC_RSV_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RSV_1RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_RSV_1RSV0_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_da_adcin_vbat_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ANA_0),
				  (&val),
				  (unsigned int)(PMIC_DA_ADCIN_VBAT_EN_MASK),
				  (unsigned int)(PMIC_DA_ADCIN_VBAT_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_auxadc_vbat_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ANA_0),
				  (&val),
				  (unsigned int)(PMIC_DA_AUXADC_VBAT_EN_MASK),
				  (unsigned int)(PMIC_DA_AUXADC_VBAT_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_adcin_vsen_mux_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ANA_0),
				  (&val),
				  (unsigned int)(PMIC_DA_ADCIN_VSEN_MUX_EN_MASK),
				  (unsigned int)(PMIC_DA_ADCIN_VSEN_MUX_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_adcin_vsen_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ANA_0),
				  (&val),
				  (unsigned int)(PMIC_DA_ADCIN_VSEN_EN_MASK),
				  (unsigned int)(PMIC_DA_ADCIN_VSEN_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_adcin_chr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ANA_0),
				  (&val),
				  (unsigned int)(PMIC_DA_ADCIN_CHR_EN_MASK),
				  (unsigned int)(PMIC_DA_ADCIN_CHR_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_baton_tdet_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ANA_0),
				  (&val),
				  (unsigned int)(PMIC_DA_BATON_TDET_EN_MASK),
				  (unsigned int)(PMIC_DA_BATON_TDET_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_da_adcin_batid_sw_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_AUXADC_ANA_0),
				  (&val),
				  (unsigned int)(PMIC_DA_ADCIN_BATID_SW_EN_MASK),
				  (unsigned int)(PMIC_DA_ADCIN_BATID_SW_EN_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcdt_hv_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCDT_HV_EN_MASK),
				    (unsigned int)(PMIC_RG_VCDT_HV_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_chr_ldo_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RGS_CHR_LDO_DET_MASK),
				  (unsigned int)(PMIC_RGS_CHR_LDO_DET_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcdt_deb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCDT_DEB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VCDT_DEB_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pchr_ft_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_FT_CTRL_MASK),
				    (unsigned int)(PMIC_RG_PCHR_FT_CTRL_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_chrdet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RGS_CHRDET_MASK),
				  (unsigned int)(PMIC_RGS_CHRDET_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_vcdt_lv_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RGS_VCDT_LV_DET_MASK),
				  (unsigned int)(PMIC_RGS_VCDT_LV_DET_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_rgs_vcdt_hv_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RGS_VCDT_HV_DET_MASK),
				  (unsigned int)(PMIC_RGS_VCDT_HV_DET_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcdt_lv_vth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCDT_LV_VTH_MASK),
				    (unsigned int)(PMIC_RG_VCDT_LV_VTH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_vcdt_hv_vth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCDT_HV_VTH_MASK),
				    (unsigned int)(PMIC_RG_VCDT_HV_VTH_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_pchr_flag_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_CHR_CON2),
				  (&val),
				  (unsigned int)(PMIC_RGS_PCHR_FLAG_OUT_MASK),
				  (unsigned int)(PMIC_RGS_PCHR_FLAG_OUT_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_pchr_flag_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_FLAG_EN_MASK),
				    (unsigned int)(PMIC_RG_PCHR_FLAG_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pchr_flag_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_FLAG_SEL_MASK),
				    (unsigned int)(PMIC_RG_PCHR_FLAG_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_pchr_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_RSV_MASK),
				    (unsigned int)(PMIC_RG_PCHR_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_envtem_d(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ENVTEM_D_MASK),
				    (unsigned int)(PMIC_RG_ENVTEM_D_SHIFT)
	    );

}

void mt6335_upmu_set_rg_envtem_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ENVTEM_EN_MASK),
				    (unsigned int)(PMIC_RG_ENVTEM_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_EN_MASK),
				    (unsigned int)(PMIC_RG_BATON_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_ht_en_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_HT_EN_RSV0_MASK),
				    (unsigned int)(PMIC_RG_BATON_HT_EN_RSV0_SHIFT)
	    );

}

void mt6335_upmu_set_baton_tdet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BATON_TDET_EN_MASK),
				    (unsigned int)(PMIC_BATON_TDET_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_ht_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_HT_TRIM_MASK),
				    (unsigned int)(PMIC_RG_BATON_HT_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_ht_trim_set(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_HT_TRIM_SET_MASK),
				    (unsigned int)(PMIC_RG_BATON_HT_TRIM_SET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_baton_tdet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_TDET_EN_MASK),
				    (unsigned int)(PMIC_RG_BATON_TDET_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_otg_bvalid_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTG_BVALID_EN_MASK),
				    (unsigned int)(PMIC_RG_OTG_BVALID_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_otg_bvalid_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_CHR_CON10),
				  (&val),
				  (unsigned int)(PMIC_RGS_OTG_BVALID_DET_MASK),
				  (unsigned int)(PMIC_RGS_OTG_BVALID_DET_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_pchr_rv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_RV_MASK),
				    (unsigned int)(PMIC_RG_PCHR_RV_SHIFT)
	    );

}

void mt6335_upmu_set_rg_usbdl_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_USBDL_RST_MASK),
				    (unsigned int)(PMIC_RG_USBDL_RST_SHIFT)
	    );

}

void mt6335_upmu_set_rg_usbdl_set(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_USBDL_SET_MASK),
				    (unsigned int)(PMIC_RG_USBDL_SET_SHIFT)
	    );

}

void mt6335_upmu_set_rg_adcin_vsen_mux_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_MUX_EN_MASK),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_MUX_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_adcin_vsen_ext_baton_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_EXT_BATON_EN_MASK),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_EXT_BATON_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_adcin_vbat_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ADCIN_VBAT_EN_MASK),
				    (unsigned int)(PMIC_RG_ADCIN_VBAT_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_adcin_vsen_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_EN_MASK),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_adcin_chr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ADCIN_CHR_EN_MASK),
				    (unsigned int)(PMIC_RG_ADCIN_CHR_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_uvlo_vthl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_UVLO_VTHL_MASK),
				    (unsigned int)(PMIC_RG_UVLO_VTHL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_uvlo_vh_lat(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_UVLO_VH_LAT_MASK),
				    (unsigned int)(PMIC_RG_UVLO_VH_LAT_SHIFT)
	    );

}

void mt6335_upmu_set_rg_lbat_int_vth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LBAT_INT_VTH_MASK),
				    (unsigned int)(PMIC_RG_LBAT_INT_VTH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bgr_rsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON19),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_RSEL_MASK),
				    (unsigned int)(PMIC_RG_BGR_RSEL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bgr_unchop_ph(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON19),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_UNCHOP_PH_MASK),
				    (unsigned int)(PMIC_RG_BGR_UNCHOP_PH_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bgr_unchop(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON19),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_UNCHOP_MASK),
				    (unsigned int)(PMIC_RG_BGR_UNCHOP_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_baton_hv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_BATON_CON0),
				  (&val),
				  (unsigned int)(PMIC_RGS_BATON_HV_MASK),
				  (unsigned int)(PMIC_RGS_BATON_HV_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_hw_vth_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BATON_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HW_VTH_CTRL_MASK),
				    (unsigned int)(PMIC_RG_HW_VTH_CTRL_SHIFT)
	    );

}

void mt6335_upmu_set_rg_hw_vth2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BATON_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HW_VTH2_MASK),
				    (unsigned int)(PMIC_RG_HW_VTH2_SHIFT)
	    );

}

void mt6335_upmu_set_rg_hw_vth1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_BATON_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HW_VTH1_MASK),
				    (unsigned int)(PMIC_RG_HW_VTH1_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bgr_trim_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON26),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_TRIM_EN_MASK),
				    (unsigned int)(PMIC_RG_BGR_TRIM_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_ichrg_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON26),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ICHRG_TRIM_MASK),
				    (unsigned int)(PMIC_RG_ICHRG_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bgr_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON27),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_TRIM_MASK),
				    (unsigned int)(PMIC_RG_BGR_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_chr_osc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON29),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHR_OSC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_CHR_OSC_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_da_qi_bgr_ext_buf_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON29),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_BGR_EXT_BUF_EN_MASK),
				    (unsigned int)(PMIC_DA_QI_BGR_EXT_BUF_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bgr_test_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON29),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_TEST_EN_MASK),
				    (unsigned int)(PMIC_RG_BGR_TEST_EN_SHIFT)
	    );

}

void mt6335_upmu_set_rg_bgr_test_rstb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON29),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_TEST_RSTB_MASK),
				    (unsigned int)(PMIC_RG_BGR_TEST_RSTB_SHIFT)
	    );

}

void mt6335_upmu_set_rg_qi_baton_lt_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON44),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_QI_BATON_LT_EN_MASK),
				    (unsigned int)(PMIC_RG_QI_BATON_LT_EN_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_rgs_baton_undet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_CHR_CON44),
				  (&val),
				  (unsigned int)(PMIC_RGS_BATON_UNDET_MASK),
				  (unsigned int)(PMIC_RGS_BATON_UNDET_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_rg_vcdt_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON48),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCDT_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VCDT_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_rg_indicator_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_CHR_CON48),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INDICATOR_TRIM_MASK),
				    (unsigned int)(PMIC_RG_INDICATOR_TRIM_SHIFT)
	    );

}

void mt6335_upmu_set_eosc_cali_start(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_EOSC_CALI_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EOSC_CALI_START_MASK),
				    (unsigned int)(PMIC_EOSC_CALI_START_SHIFT)
	    );

}

void mt6335_upmu_set_eosc_cali_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_EOSC_CALI_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EOSC_CALI_TD_MASK),
				    (unsigned int)(PMIC_EOSC_CALI_TD_SHIFT)
	    );

}

void mt6335_upmu_set_eosc_cali_test(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_EOSC_CALI_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EOSC_CALI_TEST_MASK),
				    (unsigned int)(PMIC_EOSC_CALI_TEST_SHIFT)
	    );

}

void mt6335_upmu_set_eosc_cali_dcxo_rdy_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_EOSC_CALI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EOSC_CALI_DCXO_RDY_TD_MASK),
				    (unsigned int)(PMIC_EOSC_CALI_DCXO_RDY_TD_SHIFT)
	    );

}

void mt6335_upmu_set_frc_vtcxo0_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_EOSC_CALI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FRC_VTCXO0_ON_MASK),
				    (unsigned int)(PMIC_FRC_VTCXO0_ON_SHIFT)
	    );

}

void mt6335_upmu_set_eosc_cali_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_EOSC_CALI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EOSC_CALI_RSV_MASK),
				    (unsigned int)(PMIC_EOSC_CALI_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_vrtc_pwm_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VRTC_PWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VRTC_PWM_MODE_MASK),
				    (unsigned int)(PMIC_VRTC_PWM_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_vrtc_pwm_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VRTC_PWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VRTC_PWM_RSV_MASK),
				    (unsigned int)(PMIC_VRTC_PWM_RSV_SHIFT)
	    );

}

void mt6335_upmu_set_vrtc_pwm_l_duty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VRTC_PWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VRTC_PWM_L_DUTY_MASK),
				    (unsigned int)(PMIC_VRTC_PWM_L_DUTY_SHIFT)
	    );

}

void mt6335_upmu_set_vrtc_pwm_h_duty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VRTC_PWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VRTC_PWM_H_DUTY_MASK),
				    (unsigned int)(PMIC_VRTC_PWM_H_DUTY_SHIFT)
	    );

}

void mt6335_upmu_set_vrtc_cap_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_VRTC_PWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VRTC_CAP_SEL_MASK),
				    (unsigned int)(PMIC_VRTC_CAP_SEL_SHIFT)
	    );

}

void mt6335_upmu_set_gpio_dir0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_DIR0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO_DIR0_MASK),
				    (unsigned int)(PMIC_GPIO_DIR0_SHIFT)
	    );

}

void mt6335_upmu_set_gpio_pullen0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_PULLEN0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO_PULLEN0_MASK),
				    (unsigned int)(PMIC_GPIO_PULLEN0_SHIFT)
	    );

}

void mt6335_upmu_set_gpio_pullsel0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_PULLSEL0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO_PULLSEL0_MASK),
				    (unsigned int)(PMIC_GPIO_PULLSEL0_SHIFT)
	    );

}

void mt6335_upmu_set_gpio_dinv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_DINV0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO_DINV0_MASK),
				    (unsigned int)(PMIC_GPIO_DINV0_SHIFT)
	    );

}

void mt6335_upmu_set_gpio_dout0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_DOUT0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO_DOUT0_MASK),
				    (unsigned int)(PMIC_GPIO_DOUT0_SHIFT)
	    );

}

unsigned int mt6335_upmu_get_gpio_pi0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_GPIO_PI0),
				  (&val),
				  (unsigned int)(PMIC_GPIO_PI0_MASK),
				  (unsigned int)(PMIC_GPIO_PI0_SHIFT)
	    );


	return val;
}

unsigned int mt6335_upmu_get_gpio_poe0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6335_GPIO_POE0),
				  (&val),
				  (unsigned int)(PMIC_GPIO_POE0_MASK),
				  (unsigned int)(PMIC_GPIO_POE0_SHIFT)
	    );


	return val;
}

void mt6335_upmu_set_gpio0_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_MODE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO0_MODE_MASK),
				    (unsigned int)(PMIC_GPIO0_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_gpio1_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_MODE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO1_MODE_MASK),
				    (unsigned int)(PMIC_GPIO1_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_gpio2_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_MODE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO2_MODE_MASK),
				    (unsigned int)(PMIC_GPIO2_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_gpio3_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_MODE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO3_MODE_MASK),
				    (unsigned int)(PMIC_GPIO3_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_gpio4_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_MODE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO4_MODE_MASK),
				    (unsigned int)(PMIC_GPIO4_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_gpio5_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_MODE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO5_MODE_MASK),
				    (unsigned int)(PMIC_GPIO5_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_gpio6_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_MODE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO6_MODE_MASK),
				    (unsigned int)(PMIC_GPIO6_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_gpio7_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_MODE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO7_MODE_MASK),
				    (unsigned int)(PMIC_GPIO7_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_gpio8_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_MODE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO8_MODE_MASK),
				    (unsigned int)(PMIC_GPIO8_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_gpio9_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_MODE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO9_MODE_MASK),
				    (unsigned int)(PMIC_GPIO9_MODE_SHIFT)
	    );

}

void mt6335_upmu_set_gpio_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6335_GPIO_RSV),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_GPIO_RSV_MASK),
				    (unsigned int)(PMIC_GPIO_RSV_SHIFT)
	    );

}

/*---Manual---*/
unsigned int mt6335_upmu_get_rg_vfe28_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_ALDO_1_ANA_CON1),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VFE28_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VFE28_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vbif28_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_ALDO_1_ANA_CON1),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VBIF28_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VBIF28_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vcn28_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_ALDO_1_ANA_CON2),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VCN28_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCN28_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vxo22_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_ALDO_1_ANA_CON3),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VXO22_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VXO22_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_va18_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_ALDO_1_ANA_CON4),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VA18_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VA18_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vcama1_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_ALDO_2_ANA_CON2),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VCAMA1_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCAMA1_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vcama2_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_ALDO_2_ANA_CON4),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VCAMA2_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCAMA2_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vmc_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_DLDO_ANA_CON1),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VMC_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VMC_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vcn33_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_DLDO_ANA_CON2),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VCN33_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCN33_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vcn33_wifi_vosel(void)
{
	return mt6335_upmu_get_rg_vcn33_vosel();
}

unsigned int mt6335_upmu_get_rg_vcn33_bt_vosel(void)
{
	return mt6335_upmu_get_rg_vcn33_vosel();
}

unsigned int mt6335_upmu_get_rg_vsim1_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_DLDO_ANA_CON4),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VSIM1_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VSIM1_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vemc_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_DLDO_ANA_CON6),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VEMC_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VEMC_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vibr_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_DLDO_ANA_CON8),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VIBR_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VIBR_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vefuse_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_DLDO_ANA_CON11),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VEFUSE_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VEFUSE_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vio28_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_DLDO_ANA_CON13),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VIO28_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VIO28_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vmch_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_DLDO_ANA_CON15),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VMCH_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VMCH_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vsim2_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_DLDO_ANA_CON16),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VSIM2_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VSIM2_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_va12_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_SLDO14_ANA_CON6),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VA12_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VA12_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vcamd1_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_SLDO14_ANA_CON7),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VCAMD1_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCAMD1_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_va10_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_SLDO14_ANA_CON9),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VA10_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VA10_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vrf12_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_SLDO14_ANA_CON10),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VRF12_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VRF12_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vcamd2_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_SLDO14_ANA_CON12),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VCAMD2_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCAMD2_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vrf18_1_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_SLDO20_ANA_CON1),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VRF18_1_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VRF18_1_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vrf18_2_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_SLDO20_ANA_CON2),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VRF18_2_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VRF18_2_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vcn18_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_SLDO20_ANA_CON4),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VCN18_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCN18_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vcn18_bt_vosel(void)
{
	return mt6335_upmu_get_rg_vcn18_vosel();
}

unsigned int mt6335_upmu_get_rg_vcn18_wifi_vosel(void)
{
	return mt6335_upmu_get_rg_vcn18_vosel();
}

unsigned int mt6335_upmu_get_rg_vmipi_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_SLDO20_ANA_CON5),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VMIPI_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VMIPI_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vcamio_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_SLDO20_ANA_CON8),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VCAMIO_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCAMIO_VOSEL_SHIFT)
	    );
	return val;

}

unsigned int mt6335_upmu_get_rg_vgp3_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;

	ret = pmic_read_interface((unsigned int)(MT6335_SLDO20_ANA_CON11),
				  (unsigned int *)(&val),
				  (unsigned int)(PMIC_RG_VGP3_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VGP3_VOSEL_SHIFT)
	    );
	return val;
}

/*---Manual---*/
